------------------------------------------------------------------------------
--                                                                          --
--                             Unicode Utilities                            --
--                                                                          --
--                           Case Folding Utilities                         --
--                             Simple Case Folding                          --
--                                                                          --
-- ------------------------------------------------------------------------ --
--                                                                          --
--  Copyright (C) 2019, ANNEXI-STRAYLINE Trans-Human Ltd.                   --
--  All rights reserved.                                                    --
--                                                                          --
--  Original Contributors:                                                  --
--  * Richard Wai (ANNEXI-STRAYLINE)                                        --
--                                                                          --
--  Redistribution and use in source and binary forms, with or without      --
--  modification, are permitted provided that the following conditions are  --
--  met:                                                                    --
--                                                                          --
--      * Redistributions of source code must retain the above copyright    --
--        notice, this list of conditions and the following disclaimer.     --
--                                                                          --
--      * Redistributions in binary form must reproduce the above copyright --
--        notice, this list of conditions and the following disclaimer in   --
--        the documentation and/or other materials provided with the        --
--        distribution.                                                     --
--                                                                          --
--      * Neither the name of the copyright holder nor the names of its     --
--        contributors may be used to endorse or promote products derived   --
--        from this software without specific prior written permission.     --
--                                                                          --
--  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     --
--  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       --
--  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A --
--  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      --
--  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
--  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        --
--  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   --
--  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   --
--  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     --
--  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   --
--  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    --
--                                                                          --
------------------------------------------------------------------------------

-- Generated: 2019-08-15
-- CaseFolding.txt source
-- https://www.unicode.org/Public/UCD/latest/ucd/CaseFolding.txt


-- ********** THIS FILE IS AUTOMATICALLY GENERATED ********* --
--   - See AURA.Unicode.UCD.Generate_Case_Folding.Simple -   --


-- CaseFolding.txt: C+S maps loaded = 1411


function Unicode.Case_Folding.Simple (C: Wide_Wide_Character)
                                     return Wide_Wide_Character
is
   type Codepoint is mod 2**24;
   type Key_Hash  is mod 2**8;

   function Hash (C: Codepoint) return Key_Hash with Inline is
      T: Codepoint := C;
   begin
      return K: Key_Hash := 0 do
         for I in 1 .. 3 loop
            K := K xor Key_Hash (T and 16#FF#);
            T := T / 16#100#;
         end loop;
      end return;
   end Hash;

   function Bucket_00 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000202# => Wide_Wide_Character'Val (16#000203#),
         when 16#000404# => Wide_Wide_Character'Val (16#000454#),
         when 16#001E1E# => Wide_Wide_Character'Val (16#001E1F#),
         when 16#002C2C# => Wide_Wide_Character'Val (16#002C5C#),
         when 16#00ABAB# => Wide_Wide_Character'Val (16#0013DB#),
         when 16#010405# => Wide_Wide_Character'Val (16#01042D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_01 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000100# => Wide_Wide_Character'Val (16#000101#),
         when 16#000405# => Wide_Wide_Character'Val (16#000455#),
         when 16#000504# => Wide_Wide_Character'Val (16#000505#),
         when 16#002C2D# => Wide_Wide_Character'Val (16#002C5D#),
         when 16#00A7A6# => Wide_Wide_Character'Val (16#00A7A7#),
         when 16#00ABAA# => Wide_Wide_Character'Val (16#0013DA#),
         when 16#010404# => Wide_Wide_Character'Val (16#01042C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_02 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000200# => Wide_Wide_Character'Val (16#000201#),
         when 16#000406# => Wide_Wide_Character'Val (16#000456#),
         when 16#001E1C# => Wide_Wide_Character'Val (16#001E1D#),
         when 16#001F1D# => Wide_Wide_Character'Val (16#001F15#),
         when 16#002C2E# => Wide_Wide_Character'Val (16#002C5E#),
         when 16#00ABA9# => Wide_Wide_Character'Val (16#0013D9#),
         when 16#010407# => Wide_Wide_Character'Val (16#01042F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_03 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000102# => Wide_Wide_Character'Val (16#000103#),
         when 16#000407# => Wide_Wide_Character'Val (16#000457#),
         when 16#000506# => Wide_Wide_Character'Val (16#000507#),
         when 16#001F1C# => Wide_Wide_Character'Val (16#001F14#),
         when 16#00A7A4# => Wide_Wide_Character'Val (16#00A7A5#),
         when 16#00ABA8# => Wide_Wide_Character'Val (16#0013D8#),
         when 16#010406# => Wide_Wide_Character'Val (16#01042E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_04 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000206# => Wide_Wide_Character'Val (16#000207#),
         when 16#000400# => Wide_Wide_Character'Val (16#000450#),
         when 16#001E1A# => Wide_Wide_Character'Val (16#001E1B#),
         when 16#001F1B# => Wide_Wide_Character'Val (16#001F13#),
         when 16#002C28# => Wide_Wide_Character'Val (16#002C58#),
         when 16#00ABAF# => Wide_Wide_Character'Val (16#0013DF#),
         when 16#010401# => Wide_Wide_Character'Val (16#010429#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_05 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000104# => Wide_Wide_Character'Val (16#000105#),
         when 16#000401# => Wide_Wide_Character'Val (16#000451#),
         when 16#000500# => Wide_Wide_Character'Val (16#000501#),
         when 16#001F1A# => Wide_Wide_Character'Val (16#001F12#),
         when 16#002C29# => Wide_Wide_Character'Val (16#002C59#),
         when 16#00A7A2# => Wide_Wide_Character'Val (16#00A7A3#),
         when 16#00ABAE# => Wide_Wide_Character'Val (16#0013DE#),
         when 16#010400# => Wide_Wide_Character'Val (16#010428#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_06 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000204# => Wide_Wide_Character'Val (16#000205#),
         when 16#000402# => Wide_Wide_Character'Val (16#000452#),
         when 16#001E18# => Wide_Wide_Character'Val (16#001E19#),
         when 16#001F19# => Wide_Wide_Character'Val (16#001F11#),
         when 16#002C2A# => Wide_Wide_Character'Val (16#002C5A#),
         when 16#00ABAD# => Wide_Wide_Character'Val (16#0013DD#),
         when 16#010403# => Wide_Wide_Character'Val (16#01042B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_07 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000106# => Wide_Wide_Character'Val (16#000107#),
         when 16#000403# => Wide_Wide_Character'Val (16#000453#),
         when 16#000502# => Wide_Wide_Character'Val (16#000503#),
         when 16#001F18# => Wide_Wide_Character'Val (16#001F10#),
         when 16#002126# => Wide_Wide_Character'Val (16#0003C9#),
         when 16#002C2B# => Wide_Wide_Character'Val (16#002C5B#),
         when 16#00A7A0# => Wide_Wide_Character'Val (16#00A7A1#),
         when 16#00ABAC# => Wide_Wide_Character'Val (16#0013DC#),
         when 16#010402# => Wide_Wide_Character'Val (16#01042A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_08 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00020A# => Wide_Wide_Character'Val (16#00020B#),
         when 16#00040C# => Wide_Wide_Character'Val (16#00045C#),
         when 16#001E16# => Wide_Wide_Character'Val (16#001E17#),
         when 16#002C24# => Wide_Wide_Character'Val (16#002C54#),
         when 16#00ABA3# => Wide_Wide_Character'Val (16#0013D3#),
         when 16#01040D# => Wide_Wide_Character'Val (16#010435#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_09 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000108# => Wide_Wide_Character'Val (16#000109#),
         when 16#00040D# => Wide_Wide_Character'Val (16#00045D#),
         when 16#00050C# => Wide_Wide_Character'Val (16#00050D#),
         when 16#002C25# => Wide_Wide_Character'Val (16#002C55#),
         when 16#00A7AE# => Wide_Wide_Character'Val (16#00026A#),
         when 16#00ABA2# => Wide_Wide_Character'Val (16#0013D2#),
         when 16#01040C# => Wide_Wide_Character'Val (16#010434#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000208# => Wide_Wide_Character'Val (16#000209#),
         when 16#00040E# => Wide_Wide_Character'Val (16#00045E#),
         when 16#001E14# => Wide_Wide_Character'Val (16#001E15#),
         when 16#00212B# => Wide_Wide_Character'Val (16#0000E5#),
         when 16#002C26# => Wide_Wide_Character'Val (16#002C56#),
         when 16#00A7AD# => Wide_Wide_Character'Val (16#00026C#),
         when 16#00ABA1# => Wide_Wide_Character'Val (16#0013D1#),
         when 16#01040F# => Wide_Wide_Character'Val (16#010437#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00010A# => Wide_Wide_Character'Val (16#00010B#),
         when 16#00040F# => Wide_Wide_Character'Val (16#00045F#),
         when 16#00050E# => Wide_Wide_Character'Val (16#00050F#),
         when 16#00212A# => Wide_Wide_Character'Val (16#00006B#),
         when 16#002C27# => Wide_Wide_Character'Val (16#002C57#),
         when 16#00A7AC# => Wide_Wide_Character'Val (16#000261#),
         when 16#00ABA0# => Wide_Wide_Character'Val (16#0013D0#),
         when 16#01040E# => Wide_Wide_Character'Val (16#010436#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00020E# => Wide_Wide_Character'Val (16#00020F#),
         when 16#000408# => Wide_Wide_Character'Val (16#000458#),
         when 16#001E12# => Wide_Wide_Character'Val (16#001E13#),
         when 16#002C20# => Wide_Wide_Character'Val (16#002C50#),
         when 16#00A7AB# => Wide_Wide_Character'Val (16#00025C#),
         when 16#00ABA7# => Wide_Wide_Character'Val (16#0013D7#),
         when 16#010409# => Wide_Wide_Character'Val (16#010431#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00010C# => Wide_Wide_Character'Val (16#00010D#),
         when 16#000409# => Wide_Wide_Character'Val (16#000459#),
         when 16#000508# => Wide_Wide_Character'Val (16#000509#),
         when 16#002C21# => Wide_Wide_Character'Val (16#002C51#),
         when 16#00A7AA# => Wide_Wide_Character'Val (16#000266#),
         when 16#00ABA6# => Wide_Wide_Character'Val (16#0013D6#),
         when 16#010408# => Wide_Wide_Character'Val (16#010430#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00020C# => Wide_Wide_Character'Val (16#00020D#),
         when 16#00040A# => Wide_Wide_Character'Val (16#00045A#),
         when 16#001E10# => Wide_Wide_Character'Val (16#001E11#),
         when 16#002C22# => Wide_Wide_Character'Val (16#002C52#),
         when 16#00ABA5# => Wide_Wide_Character'Val (16#0013D5#),
         when 16#01040B# => Wide_Wide_Character'Val (16#010433#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_0F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00010E# => Wide_Wide_Character'Val (16#00010F#),
         when 16#00040B# => Wide_Wide_Character'Val (16#00045B#),
         when 16#00050A# => Wide_Wide_Character'Val (16#00050B#),
         when 16#002C23# => Wide_Wide_Character'Val (16#002C53#),
         when 16#00A7A8# => Wide_Wide_Character'Val (16#00A7A9#),
         when 16#00ABA4# => Wide_Wide_Character'Val (16#0013D4#),
         when 16#01040A# => Wide_Wide_Character'Val (16#010432#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_10 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000212# => Wide_Wide_Character'Val (16#000213#),
         when 16#000414# => Wide_Wide_Character'Val (16#000434#),
         when 16#001E0E# => Wide_Wide_Character'Val (16#001E0F#),
         when 16#001F0F# => Wide_Wide_Character'Val (16#001F07#),
         when 16#00ABBB# => Wide_Wide_Character'Val (16#0013EB#),
         when 16#010415# => Wide_Wide_Character'Val (16#01043D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_11 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000110# => Wide_Wide_Character'Val (16#000111#),
         when 16#000415# => Wide_Wide_Character'Val (16#000435#),
         when 16#000514# => Wide_Wide_Character'Val (16#000515#),
         when 16#001F0E# => Wide_Wide_Character'Val (16#001F06#),
         when 16#00A7B6# => Wide_Wide_Character'Val (16#00A7B7#),
         when 16#00ABBA# => Wide_Wide_Character'Val (16#0013EA#),
         when 16#010414# => Wide_Wide_Character'Val (16#01043C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_12 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000210# => Wide_Wide_Character'Val (16#000211#),
         when 16#000416# => Wide_Wide_Character'Val (16#000436#),
         when 16#001E0C# => Wide_Wide_Character'Val (16#001E0D#),
         when 16#001F0D# => Wide_Wide_Character'Val (16#001F05#),
         when 16#00ABB9# => Wide_Wide_Character'Val (16#0013E9#),
         when 16#010417# => Wide_Wide_Character'Val (16#01043F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_13 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000112# => Wide_Wide_Character'Val (16#000113#),
         when 16#000417# => Wide_Wide_Character'Val (16#000437#),
         when 16#000516# => Wide_Wide_Character'Val (16#000517#),
         when 16#001F0C# => Wide_Wide_Character'Val (16#001F04#),
         when 16#002132# => Wide_Wide_Character'Val (16#00214E#),
         when 16#00A7B4# => Wide_Wide_Character'Val (16#00A7B5#),
         when 16#00ABB8# => Wide_Wide_Character'Val (16#0013E8#),
         when 16#010416# => Wide_Wide_Character'Val (16#01043E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_14 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000216# => Wide_Wide_Character'Val (16#000217#),
         when 16#000410# => Wide_Wide_Character'Val (16#000430#),
         when 16#001E0A# => Wide_Wide_Character'Val (16#001E0B#),
         when 16#001F0B# => Wide_Wide_Character'Val (16#001F03#),
         when 16#00A7B3# => Wide_Wide_Character'Val (16#00AB53#),
         when 16#00ABBF# => Wide_Wide_Character'Val (16#0013EF#),
         when 16#010411# => Wide_Wide_Character'Val (16#010439#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_15 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000114# => Wide_Wide_Character'Val (16#000115#),
         when 16#000411# => Wide_Wide_Character'Val (16#000431#),
         when 16#000510# => Wide_Wide_Character'Val (16#000511#),
         when 16#001F0A# => Wide_Wide_Character'Val (16#001F02#),
         when 16#00A7B2# => Wide_Wide_Character'Val (16#00029D#),
         when 16#00ABBE# => Wide_Wide_Character'Val (16#0013EE#),
         when 16#010410# => Wide_Wide_Character'Val (16#010438#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_16 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000214# => Wide_Wide_Character'Val (16#000215#),
         when 16#000412# => Wide_Wide_Character'Val (16#000432#),
         when 16#001E08# => Wide_Wide_Character'Val (16#001E09#),
         when 16#001F09# => Wide_Wide_Character'Val (16#001F01#),
         when 16#00A7B1# => Wide_Wide_Character'Val (16#000287#),
         when 16#00ABBD# => Wide_Wide_Character'Val (16#0013ED#),
         when 16#010413# => Wide_Wide_Character'Val (16#01043B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_17 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000116# => Wide_Wide_Character'Val (16#000117#),
         when 16#000413# => Wide_Wide_Character'Val (16#000433#),
         when 16#000512# => Wide_Wide_Character'Val (16#000513#),
         when 16#001F08# => Wide_Wide_Character'Val (16#001F00#),
         when 16#00A7B0# => Wide_Wide_Character'Val (16#00029E#),
         when 16#00ABBC# => Wide_Wide_Character'Val (16#0013EC#),
         when 16#010412# => Wide_Wide_Character'Val (16#01043A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_18 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00021A# => Wide_Wide_Character'Val (16#00021B#),
         when 16#00041C# => Wide_Wide_Character'Val (16#00043C#),
         when 16#001E06# => Wide_Wide_Character'Val (16#001E07#),
         when 16#00ABB3# => Wide_Wide_Character'Val (16#0013E3#),
         when 16#01041D# => Wide_Wide_Character'Val (16#010445#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_19 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000118# => Wide_Wide_Character'Val (16#000119#),
         when 16#00041D# => Wide_Wide_Character'Val (16#00043D#),
         when 16#00051C# => Wide_Wide_Character'Val (16#00051D#),
         when 16#00A7BE# => Wide_Wide_Character'Val (16#00A7BF#),
         when 16#00ABB2# => Wide_Wide_Character'Val (16#0013E2#),
         when 16#01041C# => Wide_Wide_Character'Val (16#010444#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000218# => Wide_Wide_Character'Val (16#000219#),
         when 16#00041E# => Wide_Wide_Character'Val (16#00043E#),
         when 16#001E04# => Wide_Wide_Character'Val (16#001E05#),
         when 16#00ABB1# => Wide_Wide_Character'Val (16#0013E1#),
         when 16#01041F# => Wide_Wide_Character'Val (16#010447#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00011A# => Wide_Wide_Character'Val (16#00011B#),
         when 16#00041F# => Wide_Wide_Character'Val (16#00043F#),
         when 16#00051E# => Wide_Wide_Character'Val (16#00051F#),
         when 16#00A7BC# => Wide_Wide_Character'Val (16#00A7BD#),
         when 16#00ABB0# => Wide_Wide_Character'Val (16#0013E0#),
         when 16#01041E# => Wide_Wide_Character'Val (16#010446#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00021E# => Wide_Wide_Character'Val (16#00021F#),
         when 16#000418# => Wide_Wide_Character'Val (16#000438#),
         when 16#001E02# => Wide_Wide_Character'Val (16#001E03#),
         when 16#00ABB7# => Wide_Wide_Character'Val (16#0013E7#),
         when 16#010419# => Wide_Wide_Character'Val (16#010441#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00011C# => Wide_Wide_Character'Val (16#00011D#),
         when 16#000419# => Wide_Wide_Character'Val (16#000439#),
         when 16#000518# => Wide_Wide_Character'Val (16#000519#),
         when 16#00A7BA# => Wide_Wide_Character'Val (16#00A7BB#),
         when 16#00ABB6# => Wide_Wide_Character'Val (16#0013E6#),
         when 16#010418# => Wide_Wide_Character'Val (16#010440#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00021C# => Wide_Wide_Character'Val (16#00021D#),
         when 16#00041A# => Wide_Wide_Character'Val (16#00043A#),
         when 16#001E00# => Wide_Wide_Character'Val (16#001E01#),
         when 16#00ABB5# => Wide_Wide_Character'Val (16#0013E5#),
         when 16#01041B# => Wide_Wide_Character'Val (16#010443#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_1F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00011E# => Wide_Wide_Character'Val (16#00011F#),
         when 16#00041B# => Wide_Wide_Character'Val (16#00043B#),
         when 16#00051A# => Wide_Wide_Character'Val (16#00051B#),
         when 16#00A7B8# => Wide_Wide_Character'Val (16#00A7B9#),
         when 16#00ABB4# => Wide_Wide_Character'Val (16#0013E4#),
         when 16#01041A# => Wide_Wide_Character'Val (16#010442#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_20 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000222# => Wide_Wide_Character'Val (16#000223#),
         when 16#000424# => Wide_Wide_Character'Val (16#000444#),
         when 16#001E3E# => Wide_Wide_Character'Val (16#001E3F#),
         when 16#001F3F# => Wide_Wide_Character'Val (16#001F37#),
         when 16#002C0C# => Wide_Wide_Character'Val (16#002C3C#),
         when 16#00A686# => Wide_Wide_Character'Val (16#00A687#),
         when 16#00AB8B# => Wide_Wide_Character'Val (16#0013BB#),
         when 16#010425# => Wide_Wide_Character'Val (16#01044D#),
         when 16#016E4F# => Wide_Wide_Character'Val (16#016E6F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_21 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000120# => Wide_Wide_Character'Val (16#000121#),
         when 16#000425# => Wide_Wide_Character'Val (16#000445#),
         when 16#000524# => Wide_Wide_Character'Val (16#000525#),
         when 16#001F3E# => Wide_Wide_Character'Val (16#001F36#),
         when 16#002C0D# => Wide_Wide_Character'Val (16#002C3D#),
         when 16#00A786# => Wide_Wide_Character'Val (16#00A787#),
         when 16#00AB8A# => Wide_Wide_Character'Val (16#0013BA#),
         when 16#010424# => Wide_Wide_Character'Val (16#01044C#),
         when 16#016E4E# => Wide_Wide_Character'Val (16#016E6E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_22 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000220# => Wide_Wide_Character'Val (16#00019E#),
         when 16#000426# => Wide_Wide_Character'Val (16#000446#),
         when 16#001E3C# => Wide_Wide_Character'Val (16#001E3D#),
         when 16#001F3D# => Wide_Wide_Character'Val (16#001F35#),
         when 16#002C0E# => Wide_Wide_Character'Val (16#002C3E#),
         when 16#00A684# => Wide_Wide_Character'Val (16#00A685#),
         when 16#00AB89# => Wide_Wide_Character'Val (16#0013B9#),
         when 16#010427# => Wide_Wide_Character'Val (16#01044F#),
         when 16#016E4D# => Wide_Wide_Character'Val (16#016E6D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_23 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000122# => Wide_Wide_Character'Val (16#000123#),
         when 16#000427# => Wide_Wide_Character'Val (16#000447#),
         when 16#000526# => Wide_Wide_Character'Val (16#000527#),
         when 16#001F3C# => Wide_Wide_Character'Val (16#001F34#),
         when 16#002C0F# => Wide_Wide_Character'Val (16#002C3F#),
         when 16#00A784# => Wide_Wide_Character'Val (16#00A785#),
         when 16#00AB88# => Wide_Wide_Character'Val (16#0013B8#),
         when 16#010426# => Wide_Wide_Character'Val (16#01044E#),
         when 16#016E4C# => Wide_Wide_Character'Val (16#016E6C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_24 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000226# => Wide_Wide_Character'Val (16#000227#),
         when 16#000420# => Wide_Wide_Character'Val (16#000440#),
         when 16#001E3A# => Wide_Wide_Character'Val (16#001E3B#),
         when 16#001F3B# => Wide_Wide_Character'Val (16#001F33#),
         when 16#002C08# => Wide_Wide_Character'Val (16#002C38#),
         when 16#00A682# => Wide_Wide_Character'Val (16#00A683#),
         when 16#00AB8F# => Wide_Wide_Character'Val (16#0013BF#),
         when 16#010421# => Wide_Wide_Character'Val (16#010449#),
         when 16#016E4B# => Wide_Wide_Character'Val (16#016E6B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_25 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000124# => Wide_Wide_Character'Val (16#000125#),
         when 16#000421# => Wide_Wide_Character'Val (16#000441#),
         when 16#000520# => Wide_Wide_Character'Val (16#000521#),
         when 16#001F3A# => Wide_Wide_Character'Val (16#001F32#),
         when 16#002C09# => Wide_Wide_Character'Val (16#002C39#),
         when 16#00A782# => Wide_Wide_Character'Val (16#00A783#),
         when 16#00AB8E# => Wide_Wide_Character'Val (16#0013BE#),
         when 16#010420# => Wide_Wide_Character'Val (16#010448#),
         when 16#016E4A# => Wide_Wide_Character'Val (16#016E6A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_26 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000224# => Wide_Wide_Character'Val (16#000225#),
         when 16#000422# => Wide_Wide_Character'Val (16#000442#),
         when 16#001E38# => Wide_Wide_Character'Val (16#001E39#),
         when 16#001F39# => Wide_Wide_Character'Val (16#001F31#),
         when 16#002C0A# => Wide_Wide_Character'Val (16#002C3A#),
         when 16#00A680# => Wide_Wide_Character'Val (16#00A681#),
         when 16#00AB8D# => Wide_Wide_Character'Val (16#0013BD#),
         when 16#010423# => Wide_Wide_Character'Val (16#01044B#),
         when 16#016E49# => Wide_Wide_Character'Val (16#016E69#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_27 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000126# => Wide_Wide_Character'Val (16#000127#),
         when 16#000423# => Wide_Wide_Character'Val (16#000443#),
         when 16#000522# => Wide_Wide_Character'Val (16#000523#),
         when 16#001F38# => Wide_Wide_Character'Val (16#001F30#),
         when 16#002C0B# => Wide_Wide_Character'Val (16#002C3B#),
         when 16#00A780# => Wide_Wide_Character'Val (16#00A781#),
         when 16#00AB8C# => Wide_Wide_Character'Val (16#0013BC#),
         when 16#010422# => Wide_Wide_Character'Val (16#01044A#),
         when 16#016E48# => Wide_Wide_Character'Val (16#016E68#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_28 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00022A# => Wide_Wide_Character'Val (16#00022B#),
         when 16#00042C# => Wide_Wide_Character'Val (16#00044C#),
         when 16#001E36# => Wide_Wide_Character'Val (16#001E37#),
         when 16#002C04# => Wide_Wide_Character'Val (16#002C34#),
         when 16#00A68E# => Wide_Wide_Character'Val (16#00A68F#),
         when 16#00AB83# => Wide_Wide_Character'Val (16#0013B3#),
         when 16#016E47# => Wide_Wide_Character'Val (16#016E67#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_29 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000128# => Wide_Wide_Character'Val (16#000129#),
         when 16#00042D# => Wide_Wide_Character'Val (16#00044D#),
         when 16#00052C# => Wide_Wide_Character'Val (16#00052D#),
         when 16#002C05# => Wide_Wide_Character'Val (16#002C35#),
         when 16#00AB82# => Wide_Wide_Character'Val (16#0013B2#),
         when 16#016E46# => Wide_Wide_Character'Val (16#016E66#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000228# => Wide_Wide_Character'Val (16#000229#),
         when 16#00042E# => Wide_Wide_Character'Val (16#00044E#),
         when 16#001E34# => Wide_Wide_Character'Val (16#001E35#),
         when 16#002C06# => Wide_Wide_Character'Val (16#002C36#),
         when 16#00A68C# => Wide_Wide_Character'Val (16#00A68D#),
         when 16#00A78D# => Wide_Wide_Character'Val (16#000265#),
         when 16#00AB81# => Wide_Wide_Character'Val (16#0013B1#),
         when 16#016E45# => Wide_Wide_Character'Val (16#016E65#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00012A# => Wide_Wide_Character'Val (16#00012B#),
         when 16#00042F# => Wide_Wide_Character'Val (16#00044F#),
         when 16#00052E# => Wide_Wide_Character'Val (16#00052F#),
         when 16#002C07# => Wide_Wide_Character'Val (16#002C37#),
         when 16#00AB80# => Wide_Wide_Character'Val (16#0013B0#),
         when 16#016E44# => Wide_Wide_Character'Val (16#016E64#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00022E# => Wide_Wide_Character'Val (16#00022F#),
         when 16#000428# => Wide_Wide_Character'Val (16#000448#),
         when 16#001E32# => Wide_Wide_Character'Val (16#001E33#),
         when 16#002C00# => Wide_Wide_Character'Val (16#002C30#),
         when 16#00A68A# => Wide_Wide_Character'Val (16#00A68B#),
         when 16#00A78B# => Wide_Wide_Character'Val (16#00A78C#),
         when 16#00AB87# => Wide_Wide_Character'Val (16#0013B7#),
         when 16#016E43# => Wide_Wide_Character'Val (16#016E63#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00012C# => Wide_Wide_Character'Val (16#00012D#),
         when 16#000429# => Wide_Wide_Character'Val (16#000449#),
         when 16#000528# => Wide_Wide_Character'Val (16#000529#),
         when 16#002C01# => Wide_Wide_Character'Val (16#002C31#),
         when 16#00AB86# => Wide_Wide_Character'Val (16#0013B6#),
         when 16#016E42# => Wide_Wide_Character'Val (16#016E62#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00022C# => Wide_Wide_Character'Val (16#00022D#),
         when 16#00042A# => Wide_Wide_Character'Val (16#00044A#),
         when 16#001E30# => Wide_Wide_Character'Val (16#001E31#),
         when 16#002C02# => Wide_Wide_Character'Val (16#002C32#),
         when 16#00A688# => Wide_Wide_Character'Val (16#00A689#),
         when 16#00AB85# => Wide_Wide_Character'Val (16#0013B5#),
         when 16#016E41# => Wide_Wide_Character'Val (16#016E61#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_2F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00012E# => Wide_Wide_Character'Val (16#00012F#),
         when 16#00042B# => Wide_Wide_Character'Val (16#00044B#),
         when 16#00052A# => Wide_Wide_Character'Val (16#00052B#),
         when 16#002C03# => Wide_Wide_Character'Val (16#002C33#),
         when 16#00AB84# => Wide_Wide_Character'Val (16#0013B4#),
         when 16#016E40# => Wide_Wide_Character'Val (16#016E60#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_30 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000232# => Wide_Wide_Character'Val (16#000233#),
         when 16#000535# => Wide_Wide_Character'Val (16#000565#),
         when 16#001E2E# => Wide_Wide_Character'Val (16#001E2F#),
         when 16#001F2F# => Wide_Wide_Character'Val (16#001F27#),
         when 16#002C1C# => Wide_Wide_Character'Val (16#002C4C#),
         when 16#00A696# => Wide_Wide_Character'Val (16#00A697#),
         when 16#00AB9B# => Wide_Wide_Character'Val (16#0013CB#),
         when 16#016E5F# => Wide_Wide_Character'Val (16#016E7F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_31 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000534# => Wide_Wide_Character'Val (16#000564#),
         when 16#001F2E# => Wide_Wide_Character'Val (16#001F26#),
         when 16#002C1D# => Wide_Wide_Character'Val (16#002C4D#),
         when 16#00A796# => Wide_Wide_Character'Val (16#00A797#),
         when 16#00AB9A# => Wide_Wide_Character'Val (16#0013CA#),
         when 16#016E5E# => Wide_Wide_Character'Val (16#016E7E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_32 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000230# => Wide_Wide_Character'Val (16#000231#),
         when 16#000537# => Wide_Wide_Character'Val (16#000567#),
         when 16#001E2C# => Wide_Wide_Character'Val (16#001E2D#),
         when 16#001F2D# => Wide_Wide_Character'Val (16#001F25#),
         when 16#002C1E# => Wide_Wide_Character'Val (16#002C4E#),
         when 16#00A694# => Wide_Wide_Character'Val (16#00A695#),
         when 16#00AB99# => Wide_Wide_Character'Val (16#0013C9#),
         when 16#016E5D# => Wide_Wide_Character'Val (16#016E7D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_33 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000132# => Wide_Wide_Character'Val (16#000133#),
         when 16#000536# => Wide_Wide_Character'Val (16#000566#),
         when 16#001F2C# => Wide_Wide_Character'Val (16#001F24#),
         when 16#002C1F# => Wide_Wide_Character'Val (16#002C4F#),
         when 16#00AB98# => Wide_Wide_Character'Val (16#0013C8#),
         when 16#016E5C# => Wide_Wide_Character'Val (16#016E7C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_34 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000531# => Wide_Wide_Character'Val (16#000561#),
         when 16#001E2A# => Wide_Wide_Character'Val (16#001E2B#),
         when 16#001F2B# => Wide_Wide_Character'Val (16#001F23#),
         when 16#002C18# => Wide_Wide_Character'Val (16#002C48#),
         when 16#00A692# => Wide_Wide_Character'Val (16#00A693#),
         when 16#00AB9F# => Wide_Wide_Character'Val (16#0013CF#),
         when 16#016E5B# => Wide_Wide_Character'Val (16#016E7B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_35 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000134# => Wide_Wide_Character'Val (16#000135#),
         when 16#001F2A# => Wide_Wide_Character'Val (16#001F22#),
         when 16#002C19# => Wide_Wide_Character'Val (16#002C49#),
         when 16#00A792# => Wide_Wide_Character'Val (16#00A793#),
         when 16#00AB9E# => Wide_Wide_Character'Val (16#0013CE#),
         when 16#016E5A# => Wide_Wide_Character'Val (16#016E7A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_36 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000533# => Wide_Wide_Character'Val (16#000563#),
         when 16#001E28# => Wide_Wide_Character'Val (16#001E29#),
         when 16#001F29# => Wide_Wide_Character'Val (16#001F21#),
         when 16#002C1A# => Wide_Wide_Character'Val (16#002C4A#),
         when 16#00A690# => Wide_Wide_Character'Val (16#00A691#),
         when 16#00AB9D# => Wide_Wide_Character'Val (16#0013CD#),
         when 16#016E59# => Wide_Wide_Character'Val (16#016E79#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_37 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000136# => Wide_Wide_Character'Val (16#000137#),
         when 16#000532# => Wide_Wide_Character'Val (16#000562#),
         when 16#001F28# => Wide_Wide_Character'Val (16#001F20#),
         when 16#002C1B# => Wide_Wide_Character'Val (16#002C4B#),
         when 16#00A790# => Wide_Wide_Character'Val (16#00A791#),
         when 16#00AB9C# => Wide_Wide_Character'Val (16#0013CC#),
         when 16#016E58# => Wide_Wide_Character'Val (16#016E78#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_38 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000139# => Wide_Wide_Character'Val (16#00013A#),
         when 16#00023A# => Wide_Wide_Character'Val (16#002C65#),
         when 16#00053D# => Wide_Wide_Character'Val (16#00056D#),
         when 16#001E26# => Wide_Wide_Character'Val (16#001E27#),
         when 16#002C14# => Wide_Wide_Character'Val (16#002C44#),
         when 16#00AB93# => Wide_Wide_Character'Val (16#0013C3#),
         when 16#016E57# => Wide_Wide_Character'Val (16#016E77#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_39 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00023B# => Wide_Wide_Character'Val (16#00023C#),
         when 16#00053C# => Wide_Wide_Character'Val (16#00056C#),
         when 16#002C15# => Wide_Wide_Character'Val (16#002C45#),
         when 16#00A79E# => Wide_Wide_Character'Val (16#00A79F#),
         when 16#00AB92# => Wide_Wide_Character'Val (16#0013C2#),
         when 16#016E56# => Wide_Wide_Character'Val (16#016E76#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00013B# => Wide_Wide_Character'Val (16#00013C#),
         when 16#00053F# => Wide_Wide_Character'Val (16#00056F#),
         when 16#001E24# => Wide_Wide_Character'Val (16#001E25#),
         when 16#002C16# => Wide_Wide_Character'Val (16#002C46#),
         when 16#00AB91# => Wide_Wide_Character'Val (16#0013C1#),
         when 16#016E55# => Wide_Wide_Character'Val (16#016E75#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00053E# => Wide_Wide_Character'Val (16#00056E#),
         when 16#002C17# => Wide_Wide_Character'Val (16#002C47#),
         when 16#00A79C# => Wide_Wide_Character'Val (16#00A79D#),
         when 16#00AB90# => Wide_Wide_Character'Val (16#0013C0#),
         when 16#016E54# => Wide_Wide_Character'Val (16#016E74#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00013D# => Wide_Wide_Character'Val (16#00013E#),
         when 16#00023E# => Wide_Wide_Character'Val (16#002C66#),
         when 16#000539# => Wide_Wide_Character'Val (16#000569#),
         when 16#001E22# => Wide_Wide_Character'Val (16#001E23#),
         when 16#002C10# => Wide_Wide_Character'Val (16#002C40#),
         when 16#00A69A# => Wide_Wide_Character'Val (16#00A69B#),
         when 16#00AB97# => Wide_Wide_Character'Val (16#0013C7#),
         when 16#016E53# => Wide_Wide_Character'Val (16#016E73#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000538# => Wide_Wide_Character'Val (16#000568#),
         when 16#002C11# => Wide_Wide_Character'Val (16#002C41#),
         when 16#00A79A# => Wide_Wide_Character'Val (16#00A79B#),
         when 16#00AB96# => Wide_Wide_Character'Val (16#0013C6#),
         when 16#016E52# => Wide_Wide_Character'Val (16#016E72#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00013F# => Wide_Wide_Character'Val (16#000140#),
         when 16#00053B# => Wide_Wide_Character'Val (16#00056B#),
         when 16#001E20# => Wide_Wide_Character'Val (16#001E21#),
         when 16#002C12# => Wide_Wide_Character'Val (16#002C42#),
         when 16#00A698# => Wide_Wide_Character'Val (16#00A699#),
         when 16#00AB95# => Wide_Wide_Character'Val (16#0013C5#),
         when 16#016E51# => Wide_Wide_Character'Val (16#016E71#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_3F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00023D# => Wide_Wide_Character'Val (16#00019A#),
         when 16#00053A# => Wide_Wide_Character'Val (16#00056A#),
         when 16#002C13# => Wide_Wide_Character'Val (16#002C43#),
         when 16#00A798# => Wide_Wide_Character'Val (16#00A799#),
         when 16#00AB94# => Wide_Wide_Character'Val (16#0013C4#),
         when 16#016E50# => Wide_Wide_Character'Val (16#016E70#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_40 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000141# => Wide_Wide_Character'Val (16#000142#),
         when 16#000545# => Wide_Wide_Character'Val (16#000575#),
         when 16#001E5E# => Wide_Wide_Character'Val (16#001E5F#),
         when 16#001F5F# => Wide_Wide_Character'Val (16#001F57#),
         when 16#002161# => Wide_Wide_Character'Val (16#002171#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_41 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000041# => Wide_Wide_Character'Val (16#000061#),
         when 16#000243# => Wide_Wide_Character'Val (16#000180#),
         when 16#000544# => Wide_Wide_Character'Val (16#000574#),
         when 16#002160# => Wide_Wide_Character'Val (16#002170#),
         when 16#002C6D# => Wide_Wide_Character'Val (16#000251#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_42 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000042# => Wide_Wide_Character'Val (16#000062#),
         when 16#000143# => Wide_Wide_Character'Val (16#000144#),
         when 16#000547# => Wide_Wide_Character'Val (16#000577#),
         when 16#001E5C# => Wide_Wide_Character'Val (16#001E5D#),
         when 16#001F5D# => Wide_Wide_Character'Val (16#001F55#),
         when 16#002163# => Wide_Wide_Character'Val (16#002173#),
         when 16#002C6E# => Wide_Wide_Character'Val (16#000271#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_43 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000043# => Wide_Wide_Character'Val (16#000063#),
         when 16#000241# => Wide_Wide_Character'Val (16#000242#),
         when 16#000546# => Wide_Wide_Character'Val (16#000576#),
         when 16#002162# => Wide_Wide_Character'Val (16#002172#),
         when 16#002C6F# => Wide_Wide_Character'Val (16#000250#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_44 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000044# => Wide_Wide_Character'Val (16#000064#),
         when 16#000145# => Wide_Wide_Character'Val (16#000146#),
         when 16#000246# => Wide_Wide_Character'Val (16#000247#),
         when 16#000541# => Wide_Wide_Character'Val (16#000571#),
         when 16#001E5A# => Wide_Wide_Character'Val (16#001E5B#),
         when 16#001F5B# => Wide_Wide_Character'Val (16#001F53#),
         when 16#002165# => Wide_Wide_Character'Val (16#002175#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_45 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000045# => Wide_Wide_Character'Val (16#000065#),
         when 16#000540# => Wide_Wide_Character'Val (16#000570#),
         when 16#002164# => Wide_Wide_Character'Val (16#002174#),
         when 16#002C69# => Wide_Wide_Character'Val (16#002C6A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_46 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000046# => Wide_Wide_Character'Val (16#000066#),
         when 16#000147# => Wide_Wide_Character'Val (16#000148#),
         when 16#000244# => Wide_Wide_Character'Val (16#000289#),
         when 16#000345# => Wide_Wide_Character'Val (16#0003B9#),
         when 16#000543# => Wide_Wide_Character'Val (16#000573#),
         when 16#001E58# => Wide_Wide_Character'Val (16#001E59#),
         when 16#001F59# => Wide_Wide_Character'Val (16#001F51#),
         when 16#002167# => Wide_Wide_Character'Val (16#002177#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_47 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000047# => Wide_Wide_Character'Val (16#000067#),
         when 16#000245# => Wide_Wide_Character'Val (16#00028C#),
         when 16#000542# => Wide_Wide_Character'Val (16#000572#),
         when 16#002166# => Wide_Wide_Character'Val (16#002176#),
         when 16#002C6B# => Wide_Wide_Character'Val (16#002C6C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_48 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000048# => Wide_Wide_Character'Val (16#000068#),
         when 16#00024A# => Wide_Wide_Character'Val (16#00024B#),
         when 16#00054D# => Wide_Wide_Character'Val (16#00057D#),
         when 16#001E56# => Wide_Wide_Character'Val (16#001E57#),
         when 16#002169# => Wide_Wide_Character'Val (16#002179#),
         when 16#002C64# => Wide_Wide_Character'Val (16#00027D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_49 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000049# => Wide_Wide_Character'Val (16#000069#),
         when 16#00054C# => Wide_Wide_Character'Val (16#00057C#),
         when 16#002168# => Wide_Wide_Character'Val (16#002178#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004A# => Wide_Wide_Character'Val (16#00006A#),
         when 16#000248# => Wide_Wide_Character'Val (16#000249#),
         when 16#00054F# => Wide_Wide_Character'Val (16#00057F#),
         when 16#001E54# => Wide_Wide_Character'Val (16#001E55#),
         when 16#00216B# => Wide_Wide_Character'Val (16#00217B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004B# => Wide_Wide_Character'Val (16#00006B#),
         when 16#00014A# => Wide_Wide_Character'Val (16#00014B#),
         when 16#00054E# => Wide_Wide_Character'Val (16#00057E#),
         when 16#00216A# => Wide_Wide_Character'Val (16#00217A#),
         when 16#002C67# => Wide_Wide_Character'Val (16#002C68#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004C# => Wide_Wide_Character'Val (16#00006C#),
         when 16#00024E# => Wide_Wide_Character'Val (16#00024F#),
         when 16#000549# => Wide_Wide_Character'Val (16#000579#),
         when 16#001E52# => Wide_Wide_Character'Val (16#001E53#),
         when 16#00216D# => Wide_Wide_Character'Val (16#00217D#),
         when 16#002C60# => Wide_Wide_Character'Val (16#002C61#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004D# => Wide_Wide_Character'Val (16#00006D#),
         when 16#00014C# => Wide_Wide_Character'Val (16#00014D#),
         when 16#000548# => Wide_Wide_Character'Val (16#000578#),
         when 16#00216C# => Wide_Wide_Character'Val (16#00217C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004E# => Wide_Wide_Character'Val (16#00006E#),
         when 16#00024C# => Wide_Wide_Character'Val (16#00024D#),
         when 16#00054B# => Wide_Wide_Character'Val (16#00057B#),
         when 16#001E50# => Wide_Wide_Character'Val (16#001E51#),
         when 16#00216F# => Wide_Wide_Character'Val (16#00217F#),
         when 16#002C62# => Wide_Wide_Character'Val (16#00026B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_4F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00004F# => Wide_Wide_Character'Val (16#00006F#),
         when 16#00014E# => Wide_Wide_Character'Val (16#00014F#),
         when 16#00054A# => Wide_Wide_Character'Val (16#00057A#),
         when 16#00216E# => Wide_Wide_Character'Val (16#00217E#),
         when 16#002C63# => Wide_Wide_Character'Val (16#001D7D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_50 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000050# => Wide_Wide_Character'Val (16#000070#),
         when 16#000555# => Wide_Wide_Character'Val (16#000585#),
         when 16#001E4E# => Wide_Wide_Character'Val (16#001E4F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_51 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000051# => Wide_Wide_Character'Val (16#000071#),
         when 16#000150# => Wide_Wide_Character'Val (16#000151#),
         when 16#000554# => Wide_Wide_Character'Val (16#000584#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_52 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000052# => Wide_Wide_Character'Val (16#000072#),
         when 16#001E4C# => Wide_Wide_Character'Val (16#001E4D#),
         when 16#001F4D# => Wide_Wide_Character'Val (16#001F45#),
         when 16#002C7E# => Wide_Wide_Character'Val (16#00023F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_53 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000053# => Wide_Wide_Character'Val (16#000073#),
         when 16#000152# => Wide_Wide_Character'Val (16#000153#),
         when 16#000556# => Wide_Wide_Character'Val (16#000586#),
         when 16#001F4C# => Wide_Wide_Character'Val (16#001F44#),
         when 16#002C7F# => Wide_Wide_Character'Val (16#000240#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_54 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000054# => Wide_Wide_Character'Val (16#000074#),
         when 16#000551# => Wide_Wide_Character'Val (16#000581#),
         when 16#001E4A# => Wide_Wide_Character'Val (16#001E4B#),
         when 16#001F4B# => Wide_Wide_Character'Val (16#001F43#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_55 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000055# => Wide_Wide_Character'Val (16#000075#),
         when 16#000154# => Wide_Wide_Character'Val (16#000155#),
         when 16#000550# => Wide_Wide_Character'Val (16#000580#),
         when 16#001F4A# => Wide_Wide_Character'Val (16#001F42#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_56 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000056# => Wide_Wide_Character'Val (16#000076#),
         when 16#000553# => Wide_Wide_Character'Val (16#000583#),
         when 16#001E48# => Wide_Wide_Character'Val (16#001E49#),
         when 16#001F49# => Wide_Wide_Character'Val (16#001F41#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_57 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000057# => Wide_Wide_Character'Val (16#000077#),
         when 16#000156# => Wide_Wide_Character'Val (16#000157#),
         when 16#000552# => Wide_Wide_Character'Val (16#000582#),
         when 16#001F48# => Wide_Wide_Character'Val (16#001F40#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_58 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000058# => Wide_Wide_Character'Val (16#000078#),
         when 16#001E46# => Wide_Wide_Character'Val (16#001E47#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_59 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000059# => Wide_Wide_Character'Val (16#000079#),
         when 16#000158# => Wide_Wide_Character'Val (16#000159#),
         when 16#002C75# => Wide_Wide_Character'Val (16#002C76#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00005A# => Wide_Wide_Character'Val (16#00007A#),
         when 16#001E44# => Wide_Wide_Character'Val (16#001E45#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00015A# => Wide_Wide_Character'Val (16#00015B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#001E42# => Wide_Wide_Character'Val (16#001E43#),
         when 16#002C70# => Wide_Wide_Character'Val (16#000252#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00015C# => Wide_Wide_Character'Val (16#00015D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#001E40# => Wide_Wide_Character'Val (16#001E41#),
         when 16#002C72# => Wide_Wide_Character'Val (16#002C73#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_5F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00015E# => Wide_Wide_Character'Val (16#00015F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_60 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000464# => Wide_Wide_Character'Val (16#000465#),
         when 16#001E7E# => Wide_Wide_Character'Val (16#001E7F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_61 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000160# => Wide_Wide_Character'Val (16#000161#),
         when 16#00A7C6# => Wide_Wide_Character'Val (16#001D8E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_62 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000466# => Wide_Wide_Character'Val (16#000467#),
         when 16#001E7C# => Wide_Wide_Character'Val (16#001E7D#),
         when 16#00A7C5# => Wide_Wide_Character'Val (16#000282#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_63 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000162# => Wide_Wide_Character'Val (16#000163#),
         when 16#00A7C4# => Wide_Wide_Character'Val (16#00A794#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_64 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000460# => Wide_Wide_Character'Val (16#000461#),
         when 16#001E7A# => Wide_Wide_Character'Val (16#001E7B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_65 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000164# => Wide_Wide_Character'Val (16#000165#),
         when 16#00A7C2# => Wide_Wide_Character'Val (16#00A7C3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_66 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000462# => Wide_Wide_Character'Val (16#000463#),
         when 16#001E78# => Wide_Wide_Character'Val (16#001E79#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_67 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000166# => Wide_Wide_Character'Val (16#000167#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_68 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00046C# => Wide_Wide_Character'Val (16#00046D#),
         when 16#001E76# => Wide_Wide_Character'Val (16#001E77#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_69 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000168# => Wide_Wide_Character'Val (16#000169#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00046E# => Wide_Wide_Character'Val (16#00046F#),
         when 16#001E74# => Wide_Wide_Character'Val (16#001E75#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00016A# => Wide_Wide_Character'Val (16#00016B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000468# => Wide_Wide_Character'Val (16#000469#),
         when 16#001E72# => Wide_Wide_Character'Val (16#001E73#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00016C# => Wide_Wide_Character'Val (16#00016D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00046A# => Wide_Wide_Character'Val (16#00046B#),
         when 16#001E70# => Wide_Wide_Character'Val (16#001E71#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_6F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00016E# => Wide_Wide_Character'Val (16#00016F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_70 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000474# => Wide_Wide_Character'Val (16#000475#),
         when 16#001E6E# => Wide_Wide_Character'Val (16#001E6F#),
         when 16#001F6F# => Wide_Wide_Character'Val (16#001F67#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_71 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000170# => Wide_Wide_Character'Val (16#000171#),
         when 16#000372# => Wide_Wide_Character'Val (16#000373#),
         when 16#001F6E# => Wide_Wide_Character'Val (16#001F66#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_72 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000476# => Wide_Wide_Character'Val (16#000477#),
         when 16#001E6C# => Wide_Wide_Character'Val (16#001E6D#),
         when 16#001F6D# => Wide_Wide_Character'Val (16#001F65#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_73 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000172# => Wide_Wide_Character'Val (16#000173#),
         when 16#000370# => Wide_Wide_Character'Val (16#000371#),
         when 16#001F6C# => Wide_Wide_Character'Val (16#001F64#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_74 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000470# => Wide_Wide_Character'Val (16#000471#),
         when 16#001E6A# => Wide_Wide_Character'Val (16#001E6B#),
         when 16#001F6B# => Wide_Wide_Character'Val (16#001F63#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_75 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000174# => Wide_Wide_Character'Val (16#000175#),
         when 16#000376# => Wide_Wide_Character'Val (16#000377#),
         when 16#001F6A# => Wide_Wide_Character'Val (16#001F62#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_76 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000472# => Wide_Wide_Character'Val (16#000473#),
         when 16#001E68# => Wide_Wide_Character'Val (16#001E69#),
         when 16#001F69# => Wide_Wide_Character'Val (16#001F61#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_77 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000176# => Wide_Wide_Character'Val (16#000177#),
         when 16#001F68# => Wide_Wide_Character'Val (16#001F60#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_78 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000179# => Wide_Wide_Character'Val (16#00017A#),
         when 16#00047C# => Wide_Wide_Character'Val (16#00047D#),
         when 16#001E66# => Wide_Wide_Character'Val (16#001E67#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_79 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000178# => Wide_Wide_Character'Val (16#0000FF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_7A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00017B# => Wide_Wide_Character'Val (16#00017C#),
         when 16#00047E# => Wide_Wide_Character'Val (16#00047F#),
         when 16#001E64# => Wide_Wide_Character'Val (16#001E65#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_7B (C: Codepoint) return Wide_Wide_Character is
      (Wide_Wide_Character'Val (C)) with Inline;

   function Bucket_7C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00017D# => Wide_Wide_Character'Val (16#00017E#),
         when 16#00037F# => Wide_Wide_Character'Val (16#0003F3#),
         when 16#000478# => Wide_Wide_Character'Val (16#000479#),
         when 16#001E62# => Wide_Wide_Character'Val (16#001E63#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_7D (C: Codepoint) return Wide_Wide_Character is
      (Wide_Wide_Character'Val (C)) with Inline;

   function Bucket_7E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00017F# => Wide_Wide_Character'Val (16#000073#),
         when 16#00047A# => Wide_Wide_Character'Val (16#00047B#),
         when 16#001E60# => Wide_Wide_Character'Val (16#001E61#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_7F (C: Codepoint) return Wide_Wide_Character is
      (Wide_Wide_Character'Val (C)) with Inline;

   function Bucket_80 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000181# => Wide_Wide_Character'Val (16#000253#),
         when 16#001C9C# => Wide_Wide_Character'Val (16#0010DC#),
         when 16#001E9E# => Wide_Wide_Character'Val (16#0000DF#),
         when 16#001F9F# => Wide_Wide_Character'Val (16#001F97#),
         when 16#002CAC# => Wide_Wide_Character'Val (16#002CAD#),
         when 16#010C8D# => Wide_Wide_Character'Val (16#010CCD#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_81 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#001C9D# => Wide_Wide_Character'Val (16#0010DD#),
         when 16#001F9E# => Wide_Wide_Character'Val (16#001F96#),
         when 16#00A726# => Wide_Wide_Character'Val (16#00A727#),
         when 16#010C8C# => Wide_Wide_Character'Val (16#010CCC#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_82 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#001C9E# => Wide_Wide_Character'Val (16#0010DE#),
         when 16#001F9D# => Wide_Wide_Character'Val (16#001F95#),
         when 16#002CAE# => Wide_Wide_Character'Val (16#002CAF#),
         when 16#010C8F# => Wide_Wide_Character'Val (16#010CCF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_83 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000182# => Wide_Wide_Character'Val (16#000183#),
         when 16#001C9F# => Wide_Wide_Character'Val (16#0010DF#),
         when 16#001F9C# => Wide_Wide_Character'Val (16#001F94#),
         when 16#00A724# => Wide_Wide_Character'Val (16#00A725#),
         when 16#010C8E# => Wide_Wide_Character'Val (16#010CCE#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_84 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000480# => Wide_Wide_Character'Val (16#000481#),
         when 16#001C98# => Wide_Wide_Character'Val (16#0010D8#),
         when 16#001F9B# => Wide_Wide_Character'Val (16#001F93#),
         when 16#002CA8# => Wide_Wide_Character'Val (16#002CA9#),
         when 16#010C89# => Wide_Wide_Character'Val (16#010CC9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_85 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000184# => Wide_Wide_Character'Val (16#000185#),
         when 16#000386# => Wide_Wide_Character'Val (16#0003AC#),
         when 16#001C99# => Wide_Wide_Character'Val (16#0010D9#),
         when 16#001E9B# => Wide_Wide_Character'Val (16#001E61#),
         when 16#001F9A# => Wide_Wide_Character'Val (16#001F92#),
         when 16#00A722# => Wide_Wide_Character'Val (16#00A723#),
         when 16#010C88# => Wide_Wide_Character'Val (16#010CC8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_86 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000187# => Wide_Wide_Character'Val (16#000188#),
         when 16#001C9A# => Wide_Wide_Character'Val (16#0010DA#),
         when 16#001F99# => Wide_Wide_Character'Val (16#001F91#),
         when 16#002CAA# => Wide_Wide_Character'Val (16#002CAB#),
         when 16#010C8B# => Wide_Wide_Character'Val (16#010CCB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_87 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000186# => Wide_Wide_Character'Val (16#000254#),
         when 16#001C9B# => Wide_Wide_Character'Val (16#0010DB#),
         when 16#001F98# => Wide_Wide_Character'Val (16#001F90#),
         when 16#010C8A# => Wide_Wide_Character'Val (16#010CCA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_88 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000189# => Wide_Wide_Character'Val (16#000256#),
         when 16#00048C# => Wide_Wide_Character'Val (16#00048D#),
         when 16#001C94# => Wide_Wide_Character'Val (16#0010D4#),
         when 16#002CA4# => Wide_Wide_Character'Val (16#002CA5#),
         when 16#010C85# => Wide_Wide_Character'Val (16#010CC5#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_89 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00038A# => Wide_Wide_Character'Val (16#0003AF#),
         when 16#001C95# => Wide_Wide_Character'Val (16#0010D5#),
         when 16#00A72E# => Wide_Wide_Character'Val (16#00A72F#),
         when 16#010C84# => Wide_Wide_Character'Val (16#010CC4#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00018B# => Wide_Wide_Character'Val (16#00018C#),
         when 16#000389# => Wide_Wide_Character'Val (16#0003AE#),
         when 16#00048E# => Wide_Wide_Character'Val (16#00048F#),
         when 16#001C96# => Wide_Wide_Character'Val (16#0010D6#),
         when 16#001E94# => Wide_Wide_Character'Val (16#001E95#),
         when 16#002CA6# => Wide_Wide_Character'Val (16#002CA7#),
         when 16#010C87# => Wide_Wide_Character'Val (16#010CC7#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00018A# => Wide_Wide_Character'Val (16#000257#),
         when 16#000388# => Wide_Wide_Character'Val (16#0003AD#),
         when 16#001C97# => Wide_Wide_Character'Val (16#0010D7#),
         when 16#00A72C# => Wide_Wide_Character'Val (16#00A72D#),
         when 16#010C86# => Wide_Wide_Character'Val (16#010CC6#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00038F# => Wide_Wide_Character'Val (16#0003CE#),
         when 16#001C90# => Wide_Wide_Character'Val (16#0010D0#),
         when 16#001E92# => Wide_Wide_Character'Val (16#001E93#),
         when 16#002CA0# => Wide_Wide_Character'Val (16#002CA1#),
         when 16#010C81# => Wide_Wide_Character'Val (16#010CC1#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00038E# => Wide_Wide_Character'Val (16#0003CD#),
         when 16#001C91# => Wide_Wide_Character'Val (16#0010D1#),
         when 16#00A72A# => Wide_Wide_Character'Val (16#00A72B#),
         when 16#010C80# => Wide_Wide_Character'Val (16#010CC0#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00018F# => Wide_Wide_Character'Val (16#000259#),
         when 16#00048A# => Wide_Wide_Character'Val (16#00048B#),
         when 16#001C92# => Wide_Wide_Character'Val (16#0010D2#),
         when 16#001E90# => Wide_Wide_Character'Val (16#001E91#),
         when 16#002CA2# => Wide_Wide_Character'Val (16#002CA3#),
         when 16#010C83# => Wide_Wide_Character'Val (16#010CC3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_8F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00018E# => Wide_Wide_Character'Val (16#0001DD#),
         when 16#00038C# => Wide_Wide_Character'Val (16#0003CC#),
         when 16#001C93# => Wide_Wide_Character'Val (16#0010D3#),
         when 16#00A728# => Wide_Wide_Character'Val (16#00A729#),
         when 16#010C82# => Wide_Wide_Character'Val (16#010CC2#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_90 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000191# => Wide_Wide_Character'Val (16#000192#),
         when 16#000393# => Wide_Wide_Character'Val (16#0003B3#),
         when 16#000494# => Wide_Wide_Character'Val (16#000495#),
         when 16#001E8E# => Wide_Wide_Character'Val (16#001E8F#),
         when 16#001F8F# => Wide_Wide_Character'Val (16#001F87#),
         when 16#002CBC# => Wide_Wide_Character'Val (16#002CBD#),
         when 16#010C9D# => Wide_Wide_Character'Val (16#010CDD#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_91 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000190# => Wide_Wide_Character'Val (16#00025B#),
         when 16#000392# => Wide_Wide_Character'Val (16#0003B2#),
         when 16#001F8E# => Wide_Wide_Character'Val (16#001F86#),
         when 16#00A736# => Wide_Wide_Character'Val (16#00A737#),
         when 16#010C9C# => Wide_Wide_Character'Val (16#010CDC#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_92 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000193# => Wide_Wide_Character'Val (16#000260#),
         when 16#000391# => Wide_Wide_Character'Val (16#0003B1#),
         when 16#000496# => Wide_Wide_Character'Val (16#000497#),
         when 16#001E8C# => Wide_Wide_Character'Val (16#001E8D#),
         when 16#001F8D# => Wide_Wide_Character'Val (16#001F85#),
         when 16#0024B6# => Wide_Wide_Character'Val (16#0024D0#),
         when 16#002CBE# => Wide_Wide_Character'Val (16#002CBF#),
         when 16#010C9F# => Wide_Wide_Character'Val (16#010CDF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_93 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#001F8C# => Wide_Wide_Character'Val (16#001F84#),
         when 16#0024B7# => Wide_Wide_Character'Val (16#0024D1#),
         when 16#00A734# => Wide_Wide_Character'Val (16#00A735#),
         when 16#010C9E# => Wide_Wide_Character'Val (16#010CDE#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_94 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000397# => Wide_Wide_Character'Val (16#0003B7#),
         when 16#000490# => Wide_Wide_Character'Val (16#000491#),
         when 16#001C88# => Wide_Wide_Character'Val (16#00A64B#),
         when 16#001E8A# => Wide_Wide_Character'Val (16#001E8B#),
         when 16#001F8B# => Wide_Wide_Character'Val (16#001F83#),
         when 16#002CB8# => Wide_Wide_Character'Val (16#002CB9#),
         when 16#010C99# => Wide_Wide_Character'Val (16#010CD9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_95 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000194# => Wide_Wide_Character'Val (16#000263#),
         when 16#000396# => Wide_Wide_Character'Val (16#0003B6#),
         when 16#001F8A# => Wide_Wide_Character'Val (16#001F82#),
         when 16#00A732# => Wide_Wide_Character'Val (16#00A733#),
         when 16#010C98# => Wide_Wide_Character'Val (16#010CD8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_96 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000197# => Wide_Wide_Character'Val (16#000268#),
         when 16#000395# => Wide_Wide_Character'Val (16#0003B5#),
         when 16#000492# => Wide_Wide_Character'Val (16#000493#),
         when 16#001E88# => Wide_Wide_Character'Val (16#001E89#),
         when 16#001F89# => Wide_Wide_Character'Val (16#001F81#),
         when 16#002CBA# => Wide_Wide_Character'Val (16#002CBB#),
         when 16#010C9B# => Wide_Wide_Character'Val (16#010CDB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_97 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000196# => Wide_Wide_Character'Val (16#000269#),
         when 16#000394# => Wide_Wide_Character'Val (16#0003B4#),
         when 16#001F88# => Wide_Wide_Character'Val (16#001F80#),
         when 16#010C9A# => Wide_Wide_Character'Val (16#010CDA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_98 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00039B# => Wide_Wide_Character'Val (16#0003BB#),
         when 16#00049C# => Wide_Wide_Character'Val (16#00049D#),
         when 16#001C84# => Wide_Wide_Character'Val (16#000442#),
         when 16#001E86# => Wide_Wide_Character'Val (16#001E87#),
         when 16#0024BC# => Wide_Wide_Character'Val (16#0024D6#),
         when 16#002CB4# => Wide_Wide_Character'Val (16#002CB5#),
         when 16#010C95# => Wide_Wide_Character'Val (16#010CD5#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_99 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000198# => Wide_Wide_Character'Val (16#000199#),
         when 16#00039A# => Wide_Wide_Character'Val (16#0003BA#),
         when 16#001C85# => Wide_Wide_Character'Val (16#000442#),
         when 16#0024BD# => Wide_Wide_Character'Val (16#0024D7#),
         when 16#00A73E# => Wide_Wide_Character'Val (16#00A73F#),
         when 16#010C94# => Wide_Wide_Character'Val (16#010CD4#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9A (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000399# => Wide_Wide_Character'Val (16#0003B9#),
         when 16#00049E# => Wide_Wide_Character'Val (16#00049F#),
         when 16#001C86# => Wide_Wide_Character'Val (16#00044A#),
         when 16#001E84# => Wide_Wide_Character'Val (16#001E85#),
         when 16#0024BE# => Wide_Wide_Character'Val (16#0024D8#),
         when 16#002CB6# => Wide_Wide_Character'Val (16#002CB7#),
         when 16#010C97# => Wide_Wide_Character'Val (16#010CD7#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9B (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#000398# => Wide_Wide_Character'Val (16#0003B8#),
         when 16#001C87# => Wide_Wide_Character'Val (16#000463#),
         when 16#0024BF# => Wide_Wide_Character'Val (16#0024D9#),
         when 16#00A73C# => Wide_Wide_Character'Val (16#00A73D#),
         when 16#010C96# => Wide_Wide_Character'Val (16#010CD6#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9C (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00019D# => Wide_Wide_Character'Val (16#000272#),
         when 16#00039F# => Wide_Wide_Character'Val (16#0003BF#),
         when 16#000498# => Wide_Wide_Character'Val (16#000499#),
         when 16#001C80# => Wide_Wide_Character'Val (16#000432#),
         when 16#001E82# => Wide_Wide_Character'Val (16#001E83#),
         when 16#0024B8# => Wide_Wide_Character'Val (16#0024D2#),
         when 16#002CB0# => Wide_Wide_Character'Val (16#002CB1#),
         when 16#010C91# => Wide_Wide_Character'Val (16#010CD1#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9D (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00019C# => Wide_Wide_Character'Val (16#00026F#),
         when 16#00039E# => Wide_Wide_Character'Val (16#0003BE#),
         when 16#001C81# => Wide_Wide_Character'Val (16#000434#),
         when 16#0024B9# => Wide_Wide_Character'Val (16#0024D3#),
         when 16#00A73A# => Wide_Wide_Character'Val (16#00A73B#),
         when 16#010C90# => Wide_Wide_Character'Val (16#010CD0#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9E (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00019F# => Wide_Wide_Character'Val (16#000275#),
         when 16#00039D# => Wide_Wide_Character'Val (16#0003BD#),
         when 16#00049A# => Wide_Wide_Character'Val (16#00049B#),
         when 16#001C82# => Wide_Wide_Character'Val (16#00043E#),
         when 16#001E80# => Wide_Wide_Character'Val (16#001E81#),
         when 16#0024BA# => Wide_Wide_Character'Val (16#0024D4#),
         when 16#002CB2# => Wide_Wide_Character'Val (16#002CB3#),
         when 16#010C93# => Wide_Wide_Character'Val (16#010CD3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_9F (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00039C# => Wide_Wide_Character'Val (16#0003BC#),
         when 16#001C83# => Wide_Wide_Character'Val (16#000441#),
         when 16#0024BB# => Wide_Wide_Character'Val (16#0024D5#),
         when 16#00A738# => Wide_Wide_Character'Val (16#00A739#),
         when 16#010C92# => Wide_Wide_Character'Val (16#010CD2#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003A3# => Wide_Wide_Character'Val (16#0003C3#),
         when 16#0004A4# => Wide_Wide_Character'Val (16#0004A5#),
         when 16#0010B0# => Wide_Wide_Character'Val (16#002D10#),
         when 16#001EBE# => Wide_Wide_Character'Val (16#001EBF#),
         when 16#002C8C# => Wide_Wide_Character'Val (16#002C8D#),
         when 16#010CAD# => Wide_Wide_Character'Val (16#010CED#),
         when 16#0118B9# => Wide_Wide_Character'Val (16#0118D9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A0# => Wide_Wide_Character'Val (16#0001A1#),
         when 16#0010B1# => Wide_Wide_Character'Val (16#002D11#),
         when 16#001CBD# => Wide_Wide_Character'Val (16#0010FD#),
         when 16#001FBE# => Wide_Wide_Character'Val (16#0003B9#),
         when 16#010CAC# => Wide_Wide_Character'Val (16#010CEC#),
         when 16#0118B8# => Wide_Wide_Character'Val (16#0118D8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003A1# => Wide_Wide_Character'Val (16#0003C1#),
         when 16#0004A6# => Wide_Wide_Character'Val (16#0004A7#),
         when 16#0010B2# => Wide_Wide_Character'Val (16#002D12#),
         when 16#001CBE# => Wide_Wide_Character'Val (16#0010FE#),
         when 16#001EBC# => Wide_Wide_Character'Val (16#001EBD#),
         when 16#002183# => Wide_Wide_Character'Val (16#002184#),
         when 16#002C8E# => Wide_Wide_Character'Val (16#002C8F#),
         when 16#010CAF# => Wide_Wide_Character'Val (16#010CEF#),
         when 16#0118BB# => Wide_Wide_Character'Val (16#0118DB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A2# => Wide_Wide_Character'Val (16#0001A3#),
         when 16#0003A0# => Wide_Wide_Character'Val (16#0003C0#),
         when 16#0010B3# => Wide_Wide_Character'Val (16#002D13#),
         when 16#001CBF# => Wide_Wide_Character'Val (16#0010FF#),
         when 16#001FBC# => Wide_Wide_Character'Val (16#001FB3#),
         when 16#010CAE# => Wide_Wide_Character'Val (16#010CEE#),
         when 16#0118BA# => Wide_Wide_Character'Val (16#0118DA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003A7# => Wide_Wide_Character'Val (16#0003C7#),
         when 16#0004A0# => Wide_Wide_Character'Val (16#0004A1#),
         when 16#0010B4# => Wide_Wide_Character'Val (16#002D14#),
         when 16#001CB8# => Wide_Wide_Character'Val (16#0010F8#),
         when 16#001EBA# => Wide_Wide_Character'Val (16#001EBB#),
         when 16#001FBB# => Wide_Wide_Character'Val (16#001F71#),
         when 16#002C88# => Wide_Wide_Character'Val (16#002C89#),
         when 16#010CA9# => Wide_Wide_Character'Val (16#010CE9#),
         when 16#0118BD# => Wide_Wide_Character'Val (16#0118DD#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A4# => Wide_Wide_Character'Val (16#0001A5#),
         when 16#0003A6# => Wide_Wide_Character'Val (16#0003C6#),
         when 16#0010B5# => Wide_Wide_Character'Val (16#002D15#),
         when 16#001CB9# => Wide_Wide_Character'Val (16#0010F9#),
         when 16#001FBA# => Wide_Wide_Character'Val (16#001F70#),
         when 16#010CA8# => Wide_Wide_Character'Val (16#010CE8#),
         when 16#0118BC# => Wide_Wide_Character'Val (16#0118DC#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A7# => Wide_Wide_Character'Val (16#0001A8#),
         when 16#0003A5# => Wide_Wide_Character'Val (16#0003C5#),
         when 16#0004A2# => Wide_Wide_Character'Val (16#0004A3#),
         when 16#0010B6# => Wide_Wide_Character'Val (16#002D16#),
         when 16#001CBA# => Wide_Wide_Character'Val (16#0010FA#),
         when 16#001EB8# => Wide_Wide_Character'Val (16#001EB9#),
         when 16#001FB9# => Wide_Wide_Character'Val (16#001FB1#),
         when 16#002C8A# => Wide_Wide_Character'Val (16#002C8B#),
         when 16#010CAB# => Wide_Wide_Character'Val (16#010CEB#),
         when 16#0118BF# => Wide_Wide_Character'Val (16#0118DF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A6# => Wide_Wide_Character'Val (16#000280#),
         when 16#0003A4# => Wide_Wide_Character'Val (16#0003C4#),
         when 16#0010B7# => Wide_Wide_Character'Val (16#002D17#),
         when 16#001FB8# => Wide_Wide_Character'Val (16#001FB0#),
         when 16#010CAA# => Wide_Wide_Character'Val (16#010CEA#),
         when 16#0118BE# => Wide_Wide_Character'Val (16#0118DE#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001A9# => Wide_Wide_Character'Val (16#000283#),
         when 16#0003AB# => Wide_Wide_Character'Val (16#0003CB#),
         when 16#0004AC# => Wide_Wide_Character'Val (16#0004AD#),
         when 16#0010B8# => Wide_Wide_Character'Val (16#002D18#),
         when 16#001CB4# => Wide_Wide_Character'Val (16#0010F4#),
         when 16#001EB6# => Wide_Wide_Character'Val (16#001EB7#),
         when 16#002C84# => Wide_Wide_Character'Val (16#002C85#),
         when 16#010CA5# => Wide_Wide_Character'Val (16#010CE5#),
         when 16#0118B1# => Wide_Wide_Character'Val (16#0118D1#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_A9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003AA# => Wide_Wide_Character'Val (16#0003CA#),
         when 16#0010B9# => Wide_Wide_Character'Val (16#002D19#),
         when 16#001CB5# => Wide_Wide_Character'Val (16#0010F5#),
         when 16#010CA4# => Wide_Wide_Character'Val (16#010CE4#),
         when 16#0118B0# => Wide_Wide_Character'Val (16#0118D0#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003A9# => Wide_Wide_Character'Val (16#0003C9#),
         when 16#0004AE# => Wide_Wide_Character'Val (16#0004AF#),
         when 16#0010BA# => Wide_Wide_Character'Val (16#002D1A#),
         when 16#001CB6# => Wide_Wide_Character'Val (16#0010F6#),
         when 16#001EB4# => Wide_Wide_Character'Val (16#001EB5#),
         when 16#002C86# => Wide_Wide_Character'Val (16#002C87#),
         when 16#010CA7# => Wide_Wide_Character'Val (16#010CE7#),
         when 16#0118B3# => Wide_Wide_Character'Val (16#0118D3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003A8# => Wide_Wide_Character'Val (16#0003C8#),
         when 16#0010BB# => Wide_Wide_Character'Val (16#002D1B#),
         when 16#001CB7# => Wide_Wide_Character'Val (16#0010F7#),
         when 16#010CA6# => Wide_Wide_Character'Val (16#010CE6#),
         when 16#0118B2# => Wide_Wide_Character'Val (16#0118D2#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004A8# => Wide_Wide_Character'Val (16#0004A9#),
         when 16#0010BC# => Wide_Wide_Character'Val (16#002D1C#),
         when 16#001CB0# => Wide_Wide_Character'Val (16#0010F0#),
         when 16#001EB2# => Wide_Wide_Character'Val (16#001EB3#),
         when 16#002C80# => Wide_Wide_Character'Val (16#002C81#),
         when 16#010CA1# => Wide_Wide_Character'Val (16#010CE1#),
         when 16#0118B5# => Wide_Wide_Character'Val (16#0118D5#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AD (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001AC# => Wide_Wide_Character'Val (16#0001AD#),
         when 16#0010BD# => Wide_Wide_Character'Val (16#002D1D#),
         when 16#001CB1# => Wide_Wide_Character'Val (16#0010F1#),
         when 16#010CA0# => Wide_Wide_Character'Val (16#010CE0#),
         when 16#0118B4# => Wide_Wide_Character'Val (16#0118D4#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001AF# => Wide_Wide_Character'Val (16#0001B0#),
         when 16#0004AA# => Wide_Wide_Character'Val (16#0004AB#),
         when 16#0010BE# => Wide_Wide_Character'Val (16#002D1E#),
         when 16#001CB2# => Wide_Wide_Character'Val (16#0010F2#),
         when 16#001EB0# => Wide_Wide_Character'Val (16#001EB1#),
         when 16#002C82# => Wide_Wide_Character'Val (16#002C83#),
         when 16#010CA3# => Wide_Wide_Character'Val (16#010CE3#),
         when 16#0118B7# => Wide_Wide_Character'Val (16#0118D7#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_AF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001AE# => Wide_Wide_Character'Val (16#000288#),
         when 16#0010BF# => Wide_Wide_Character'Val (16#002D1F#),
         when 16#001CB3# => Wide_Wide_Character'Val (16#0010F3#),
         when 16#010CA2# => Wide_Wide_Character'Val (16#010CE2#),
         when 16#0118B6# => Wide_Wide_Character'Val (16#0118D6#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B1# => Wide_Wide_Character'Val (16#00028A#),
         when 16#0004B4# => Wide_Wide_Character'Val (16#0004B5#),
         when 16#0010A0# => Wide_Wide_Character'Val (16#002D00#),
         when 16#001CAC# => Wide_Wide_Character'Val (16#0010EC#),
         when 16#001EAE# => Wide_Wide_Character'Val (16#001EAF#),
         when 16#001FAF# => Wide_Wide_Character'Val (16#001FA7#),
         when 16#002C9C# => Wide_Wide_Character'Val (16#002C9D#),
         when 16#0104B5# => Wide_Wide_Character'Val (16#0104DD#),
         when 16#0118A9# => Wide_Wide_Character'Val (16#0118C9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0010A1# => Wide_Wide_Character'Val (16#002D01#),
         when 16#001CAD# => Wide_Wide_Character'Val (16#0010ED#),
         when 16#001FAE# => Wide_Wide_Character'Val (16#001FA6#),
         when 16#0104B4# => Wide_Wide_Character'Val (16#0104DC#),
         when 16#0118A8# => Wide_Wide_Character'Val (16#0118C8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B3# => Wide_Wide_Character'Val (16#0001B4#),
         when 16#0004B6# => Wide_Wide_Character'Val (16#0004B7#),
         when 16#0010A2# => Wide_Wide_Character'Val (16#002D02#),
         when 16#001CAE# => Wide_Wide_Character'Val (16#0010EE#),
         when 16#001EAC# => Wide_Wide_Character'Val (16#001EAD#),
         when 16#001FAD# => Wide_Wide_Character'Val (16#001FA5#),
         when 16#002C9E# => Wide_Wide_Character'Val (16#002C9F#),
         when 16#0104B7# => Wide_Wide_Character'Val (16#0104DF#),
         when 16#0118AB# => Wide_Wide_Character'Val (16#0118CB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B2# => Wide_Wide_Character'Val (16#00028B#),
         when 16#0010A3# => Wide_Wide_Character'Val (16#002D03#),
         when 16#001CAF# => Wide_Wide_Character'Val (16#0010EF#),
         when 16#001FAC# => Wide_Wide_Character'Val (16#001FA4#),
         when 16#0104B6# => Wide_Wide_Character'Val (16#0104DE#),
         when 16#0118AA# => Wide_Wide_Character'Val (16#0118CA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B5# => Wide_Wide_Character'Val (16#0001B6#),
         when 16#0004B0# => Wide_Wide_Character'Val (16#0004B1#),
         when 16#0010A4# => Wide_Wide_Character'Val (16#002D04#),
         when 16#001CA8# => Wide_Wide_Character'Val (16#0010E8#),
         when 16#001EAA# => Wide_Wide_Character'Val (16#001EAB#),
         when 16#001FAB# => Wide_Wide_Character'Val (16#001FA3#),
         when 16#002C98# => Wide_Wide_Character'Val (16#002C99#),
         when 16#0104B1# => Wide_Wide_Character'Val (16#0104D9#),
         when 16#0118AD# => Wide_Wide_Character'Val (16#0118CD#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000B5# => Wide_Wide_Character'Val (16#0003BC#),
         when 16#0010A5# => Wide_Wide_Character'Val (16#002D05#),
         when 16#001CA9# => Wide_Wide_Character'Val (16#0010E9#),
         when 16#001FAA# => Wide_Wide_Character'Val (16#001FA2#),
         when 16#0104B0# => Wide_Wide_Character'Val (16#0104D8#),
         when 16#0118AC# => Wide_Wide_Character'Val (16#0118CC#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B7# => Wide_Wide_Character'Val (16#000292#),
         when 16#0004B2# => Wide_Wide_Character'Val (16#0004B3#),
         when 16#0010A6# => Wide_Wide_Character'Val (16#002D06#),
         when 16#001CAA# => Wide_Wide_Character'Val (16#0010EA#),
         when 16#001EA8# => Wide_Wide_Character'Val (16#001EA9#),
         when 16#001FA9# => Wide_Wide_Character'Val (16#001FA1#),
         when 16#002C9A# => Wide_Wide_Character'Val (16#002C9B#),
         when 16#0104B3# => Wide_Wide_Character'Val (16#0104DB#),
         when 16#0118AF# => Wide_Wide_Character'Val (16#0118CF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0010A7# => Wide_Wide_Character'Val (16#002D07#),
         when 16#001CAB# => Wide_Wide_Character'Val (16#0010EB#),
         when 16#001FA8# => Wide_Wide_Character'Val (16#001FA0#),
         when 16#0104B2# => Wide_Wide_Character'Val (16#0104DA#),
         when 16#0118AE# => Wide_Wide_Character'Val (16#0118CE#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004BC# => Wide_Wide_Character'Val (16#0004BD#),
         when 16#0010A8# => Wide_Wide_Character'Val (16#002D08#),
         when 16#001CA4# => Wide_Wide_Character'Val (16#0010E4#),
         when 16#001EA6# => Wide_Wide_Character'Val (16#001EA7#),
         when 16#002C94# => Wide_Wide_Character'Val (16#002C95#),
         when 16#0104BD# => Wide_Wide_Character'Val (16#0104E5#),
         when 16#0118A1# => Wide_Wide_Character'Val (16#0118C1#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_B9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001B8# => Wide_Wide_Character'Val (16#0001B9#),
         when 16#0010A9# => Wide_Wide_Character'Val (16#002D09#),
         when 16#001CA5# => Wide_Wide_Character'Val (16#0010E5#),
         when 16#0104BC# => Wide_Wide_Character'Val (16#0104E4#),
         when 16#0118A0# => Wide_Wide_Character'Val (16#0118C0#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004BE# => Wide_Wide_Character'Val (16#0004BF#),
         when 16#0010AA# => Wide_Wide_Character'Val (16#002D0A#),
         when 16#001CA6# => Wide_Wide_Character'Val (16#0010E6#),
         when 16#001EA4# => Wide_Wide_Character'Val (16#001EA5#),
         when 16#002C96# => Wide_Wide_Character'Val (16#002C97#),
         when 16#0104BF# => Wide_Wide_Character'Val (16#0104E7#),
         when 16#0118A3# => Wide_Wide_Character'Val (16#0118C3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0010AB# => Wide_Wide_Character'Val (16#002D0B#),
         when 16#001CA7# => Wide_Wide_Character'Val (16#0010E7#),
         when 16#0104BE# => Wide_Wide_Character'Val (16#0104E6#),
         when 16#0118A2# => Wide_Wide_Character'Val (16#0118C2#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004B8# => Wide_Wide_Character'Val (16#0004B9#),
         when 16#0010AC# => Wide_Wide_Character'Val (16#002D0C#),
         when 16#001CA0# => Wide_Wide_Character'Val (16#0010E0#),
         when 16#001EA2# => Wide_Wide_Character'Val (16#001EA3#),
         when 16#002C90# => Wide_Wide_Character'Val (16#002C91#),
         when 16#0104B9# => Wide_Wide_Character'Val (16#0104E1#),
         when 16#010CB1# => Wide_Wide_Character'Val (16#010CF1#),
         when 16#0118A5# => Wide_Wide_Character'Val (16#0118C5#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BD (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001BC# => Wide_Wide_Character'Val (16#0001BD#),
         when 16#0010AD# => Wide_Wide_Character'Val (16#002D0D#),
         when 16#001CA1# => Wide_Wide_Character'Val (16#0010E1#),
         when 16#0104B8# => Wide_Wide_Character'Val (16#0104E0#),
         when 16#010CB0# => Wide_Wide_Character'Val (16#010CF0#),
         when 16#0118A4# => Wide_Wide_Character'Val (16#0118C4#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004BA# => Wide_Wide_Character'Val (16#0004BB#),
         when 16#0010AE# => Wide_Wide_Character'Val (16#002D0E#),
         when 16#001CA2# => Wide_Wide_Character'Val (16#0010E2#),
         when 16#001EA0# => Wide_Wide_Character'Val (16#001EA1#),
         when 16#002C92# => Wide_Wide_Character'Val (16#002C93#),
         when 16#0104BB# => Wide_Wide_Character'Val (16#0104E3#),
         when 16#0118A7# => Wide_Wide_Character'Val (16#0118C7#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_BF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0010AF# => Wide_Wide_Character'Val (16#002D0F#),
         when 16#001CA3# => Wide_Wide_Character'Val (16#0010E3#),
         when 16#0104BA# => Wide_Wide_Character'Val (16#0104E2#),
         when 16#010CB2# => Wide_Wide_Character'Val (16#010CF2#),
         when 16#0118A6# => Wide_Wide_Character'Val (16#0118C6#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C0# => Wide_Wide_Character'Val (16#0000E0#),
         when 16#001EDE# => Wide_Wide_Character'Val (16#001EDF#),
         when 16#00A666# => Wide_Wide_Character'Val (16#00A667#),
         when 16#0104C5# => Wide_Wide_Character'Val (16#0104ED#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C1# => Wide_Wide_Character'Val (16#0000E1#),
         when 16#0003C2# => Wide_Wide_Character'Val (16#0003C3#),
         when 16#0004C5# => Wide_Wide_Character'Val (16#0004C6#),
         when 16#002CED# => Wide_Wide_Character'Val (16#002CEE#),
         when 16#00A766# => Wide_Wide_Character'Val (16#00A767#),
         when 16#0104C4# => Wide_Wide_Character'Val (16#0104EC#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C2# => Wide_Wide_Character'Val (16#0000E2#),
         when 16#001EDC# => Wide_Wide_Character'Val (16#001EDD#),
         when 16#00A664# => Wide_Wide_Character'Val (16#00A665#),
         when 16#0104C7# => Wide_Wide_Character'Val (16#0104EF#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C3# => Wide_Wide_Character'Val (16#0000E3#),
         when 16#0004C7# => Wide_Wide_Character'Val (16#0004C8#),
         when 16#00A764# => Wide_Wide_Character'Val (16#00A765#),
         when 16#0104C6# => Wide_Wide_Character'Val (16#0104EE#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C4# => Wide_Wide_Character'Val (16#0000E4#),
         when 16#0001C5# => Wide_Wide_Character'Val (16#0001C6#),
         when 16#0004C0# => Wide_Wide_Character'Val (16#0004CF#),
         when 16#001EDA# => Wide_Wide_Character'Val (16#001EDB#),
         when 16#001FDB# => Wide_Wide_Character'Val (16#001F77#),
         when 16#00A662# => Wide_Wide_Character'Val (16#00A663#),
         when 16#0104C1# => Wide_Wide_Character'Val (16#0104E9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C5# => Wide_Wide_Character'Val (16#0000E5#),
         when 16#0001C4# => Wide_Wide_Character'Val (16#0001C6#),
         when 16#0004C1# => Wide_Wide_Character'Val (16#0004C2#),
         when 16#001FDA# => Wide_Wide_Character'Val (16#001F76#),
         when 16#00A762# => Wide_Wide_Character'Val (16#00A763#),
         when 16#00FF3A# => Wide_Wide_Character'Val (16#00FF5A#),
         when 16#0104C0# => Wide_Wide_Character'Val (16#0104E8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C6# => Wide_Wide_Character'Val (16#0000E6#),
         when 16#0001C7# => Wide_Wide_Character'Val (16#0001C9#),
         when 16#001ED8# => Wide_Wide_Character'Val (16#001ED9#),
         when 16#001FD9# => Wide_Wide_Character'Val (16#001FD1#),
         when 16#00A660# => Wide_Wide_Character'Val (16#00A661#),
         when 16#00FF39# => Wide_Wide_Character'Val (16#00FF59#),
         when 16#0104C3# => Wide_Wide_Character'Val (16#0104EB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C7# => Wide_Wide_Character'Val (16#0000E7#),
         when 16#0004C3# => Wide_Wide_Character'Val (16#0004C4#),
         when 16#001FD8# => Wide_Wide_Character'Val (16#001FD0#),
         when 16#002CEB# => Wide_Wide_Character'Val (16#002CEC#),
         when 16#00A760# => Wide_Wide_Character'Val (16#00A761#),
         when 16#00FF38# => Wide_Wide_Character'Val (16#00FF58#),
         when 16#0104C2# => Wide_Wide_Character'Val (16#0104EA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C8# => Wide_Wide_Character'Val (16#0000E8#),
         when 16#001ED6# => Wide_Wide_Character'Val (16#001ED7#),
         when 16#00FF37# => Wide_Wide_Character'Val (16#00FF57#),
         when 16#0104CD# => Wide_Wide_Character'Val (16#0104F5#),
         when 16#01E920# => Wide_Wide_Character'Val (16#01E942#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_C9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000C9# => Wide_Wide_Character'Val (16#0000E9#),
         when 16#0001C8# => Wide_Wide_Character'Val (16#0001C9#),
         when 16#0004CD# => Wide_Wide_Character'Val (16#0004CE#),
         when 16#00A76E# => Wide_Wide_Character'Val (16#00A76F#),
         when 16#00FF36# => Wide_Wide_Character'Val (16#00FF56#),
         when 16#0104CC# => Wide_Wide_Character'Val (16#0104F4#),
         when 16#01E921# => Wide_Wide_Character'Val (16#01E943#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CA# => Wide_Wide_Character'Val (16#0000EA#),
         when 16#0001CB# => Wide_Wide_Character'Val (16#0001CC#),
         when 16#001ED4# => Wide_Wide_Character'Val (16#001ED5#),
         when 16#00A66C# => Wide_Wide_Character'Val (16#00A66D#),
         when 16#00FF35# => Wide_Wide_Character'Val (16#00FF55#),
         when 16#0104CF# => Wide_Wide_Character'Val (16#0104F7#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CB# => Wide_Wide_Character'Val (16#0000EB#),
         when 16#0001CA# => Wide_Wide_Character'Val (16#0001CC#),
         when 16#00A76C# => Wide_Wide_Character'Val (16#00A76D#),
         when 16#00FF34# => Wide_Wide_Character'Val (16#00FF54#),
         when 16#0104CE# => Wide_Wide_Character'Val (16#0104F6#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CC# => Wide_Wide_Character'Val (16#0000EC#),
         when 16#0001CD# => Wide_Wide_Character'Val (16#0001CE#),
         when 16#0003CF# => Wide_Wide_Character'Val (16#0003D7#),
         when 16#001ED2# => Wide_Wide_Character'Val (16#001ED3#),
         when 16#002CE0# => Wide_Wide_Character'Val (16#002CE1#),
         when 16#00A66A# => Wide_Wide_Character'Val (16#00A66B#),
         when 16#00FF33# => Wide_Wide_Character'Val (16#00FF53#),
         when 16#0104C9# => Wide_Wide_Character'Val (16#0104F1#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CD (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CD# => Wide_Wide_Character'Val (16#0000ED#),
         when 16#0004C9# => Wide_Wide_Character'Val (16#0004CA#),
         when 16#00A76A# => Wide_Wide_Character'Val (16#00A76B#),
         when 16#00FF32# => Wide_Wide_Character'Val (16#00FF52#),
         when 16#0104C8# => Wide_Wide_Character'Val (16#0104F0#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CE# => Wide_Wide_Character'Val (16#0000EE#),
         when 16#0001CF# => Wide_Wide_Character'Val (16#0001D0#),
         when 16#001ED0# => Wide_Wide_Character'Val (16#001ED1#),
         when 16#002CE2# => Wide_Wide_Character'Val (16#002CE3#),
         when 16#00A668# => Wide_Wide_Character'Val (16#00A669#),
         when 16#00FF31# => Wide_Wide_Character'Val (16#00FF51#),
         when 16#0104CB# => Wide_Wide_Character'Val (16#0104F3#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_CF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000CF# => Wide_Wide_Character'Val (16#0000EF#),
         when 16#0004CB# => Wide_Wide_Character'Val (16#0004CC#),
         when 16#00A768# => Wide_Wide_Character'Val (16#00A769#),
         when 16#00FF30# => Wide_Wide_Character'Val (16#00FF50#),
         when 16#0104CA# => Wide_Wide_Character'Val (16#0104F2#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D0# => Wide_Wide_Character'Val (16#0000F0#),
         when 16#0001D1# => Wide_Wide_Character'Val (16#0001D2#),
         when 16#0004D4# => Wide_Wide_Character'Val (16#0004D5#),
         when 16#0010C0# => Wide_Wide_Character'Val (16#002D20#),
         when 16#001ECE# => Wide_Wide_Character'Val (16#001ECF#),
         when 16#00AB7B# => Wide_Wide_Character'Val (16#0013AB#),
         when 16#00FF2F# => Wide_Wide_Character'Val (16#00FF4F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D1# => Wide_Wide_Character'Val (16#0000F1#),
         when 16#0010C1# => Wide_Wide_Character'Val (16#002D21#),
         when 16#00AB7A# => Wide_Wide_Character'Val (16#0013AA#),
         when 16#00FF2E# => Wide_Wide_Character'Val (16#00FF4E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D2# => Wide_Wide_Character'Val (16#0000F2#),
         when 16#0001D3# => Wide_Wide_Character'Val (16#0001D4#),
         when 16#0003D1# => Wide_Wide_Character'Val (16#0003B8#),
         when 16#0004D6# => Wide_Wide_Character'Val (16#0004D7#),
         when 16#0010C2# => Wide_Wide_Character'Val (16#002D22#),
         when 16#001ECC# => Wide_Wide_Character'Val (16#001ECD#),
         when 16#00AB79# => Wide_Wide_Character'Val (16#0013A9#),
         when 16#00FF2D# => Wide_Wide_Character'Val (16#00FF4D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D3# => Wide_Wide_Character'Val (16#0000F3#),
         when 16#0003D0# => Wide_Wide_Character'Val (16#0003B2#),
         when 16#0010C3# => Wide_Wide_Character'Val (16#002D23#),
         when 16#001FCC# => Wide_Wide_Character'Val (16#001FC3#),
         when 16#00AB78# => Wide_Wide_Character'Val (16#0013A8#),
         when 16#00FF2C# => Wide_Wide_Character'Val (16#00FF4C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D4# => Wide_Wide_Character'Val (16#0000F4#),
         when 16#0001D5# => Wide_Wide_Character'Val (16#0001D6#),
         when 16#0004D0# => Wide_Wide_Character'Val (16#0004D1#),
         when 16#0010C4# => Wide_Wide_Character'Val (16#002D24#),
         when 16#001ECA# => Wide_Wide_Character'Val (16#001ECB#),
         when 16#001FCB# => Wide_Wide_Character'Val (16#001F75#),
         when 16#00AB7F# => Wide_Wide_Character'Val (16#0013AF#),
         when 16#00FF2B# => Wide_Wide_Character'Val (16#00FF4B#),
         when 16#0104D1# => Wide_Wide_Character'Val (16#0104F9#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D5# => Wide_Wide_Character'Val (16#0000F5#),
         when 16#0003D6# => Wide_Wide_Character'Val (16#0003C0#),
         when 16#0010C5# => Wide_Wide_Character'Val (16#002D25#),
         when 16#001FCA# => Wide_Wide_Character'Val (16#001F74#),
         when 16#00AB7E# => Wide_Wide_Character'Val (16#0013AE#),
         when 16#00FF2A# => Wide_Wide_Character'Val (16#00FF4A#),
         when 16#0104D0# => Wide_Wide_Character'Val (16#0104F8#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D6# => Wide_Wide_Character'Val (16#0000F6#),
         when 16#0001D7# => Wide_Wide_Character'Val (16#0001D8#),
         when 16#0003D5# => Wide_Wide_Character'Val (16#0003C6#),
         when 16#0004D2# => Wide_Wide_Character'Val (16#0004D3#),
         when 16#001EC8# => Wide_Wide_Character'Val (16#001EC9#),
         when 16#001FC9# => Wide_Wide_Character'Val (16#001F73#),
         when 16#00AB7D# => Wide_Wide_Character'Val (16#0013AD#),
         when 16#00FF29# => Wide_Wide_Character'Val (16#00FF49#),
         when 16#0104D3# => Wide_Wide_Character'Val (16#0104FB#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0010C7# => Wide_Wide_Character'Val (16#002D27#),
         when 16#001FC8# => Wide_Wide_Character'Val (16#001F72#),
         when 16#00AB7C# => Wide_Wide_Character'Val (16#0013AC#),
         when 16#00FF28# => Wide_Wide_Character'Val (16#00FF48#),
         when 16#0104D2# => Wide_Wide_Character'Val (16#0104FA#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D8# => Wide_Wide_Character'Val (16#0000F8#),
         when 16#0001D9# => Wide_Wide_Character'Val (16#0001DA#),
         when 16#0004DC# => Wide_Wide_Character'Val (16#0004DD#),
         when 16#001EC6# => Wide_Wide_Character'Val (16#001EC7#),
         when 16#00AB73# => Wide_Wide_Character'Val (16#0013A3#),
         when 16#00FF27# => Wide_Wide_Character'Val (16#00FF47#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_D9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000D9# => Wide_Wide_Character'Val (16#0000F9#),
         when 16#0003DA# => Wide_Wide_Character'Val (16#0003DB#),
         when 16#00A77E# => Wide_Wide_Character'Val (16#00A77F#),
         when 16#00AB72# => Wide_Wide_Character'Val (16#0013A2#),
         when 16#00FF26# => Wide_Wide_Character'Val (16#00FF46#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000DA# => Wide_Wide_Character'Val (16#0000FA#),
         when 16#0001DB# => Wide_Wide_Character'Val (16#0001DC#),
         when 16#0004DE# => Wide_Wide_Character'Val (16#0004DF#),
         when 16#001EC4# => Wide_Wide_Character'Val (16#001EC5#),
         when 16#00A77D# => Wide_Wide_Character'Val (16#001D79#),
         when 16#00AB71# => Wide_Wide_Character'Val (16#0013A1#),
         when 16#00FF25# => Wide_Wide_Character'Val (16#00FF45#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000DB# => Wide_Wide_Character'Val (16#0000FB#),
         when 16#0003D8# => Wide_Wide_Character'Val (16#0003D9#),
         when 16#00AB70# => Wide_Wide_Character'Val (16#0013A0#),
         when 16#00FF24# => Wide_Wide_Character'Val (16#00FF44#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000DC# => Wide_Wide_Character'Val (16#0000FC#),
         when 16#0004D8# => Wide_Wide_Character'Val (16#0004D9#),
         when 16#001EC2# => Wide_Wide_Character'Val (16#001EC3#),
         when 16#00A77B# => Wide_Wide_Character'Val (16#00A77C#),
         when 16#00AB77# => Wide_Wide_Character'Val (16#0013A7#),
         when 16#00FF23# => Wide_Wide_Character'Val (16#00FF43#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DD (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000DD# => Wide_Wide_Character'Val (16#0000FD#),
         when 16#0003DE# => Wide_Wide_Character'Val (16#0003DF#),
         when 16#0010CD# => Wide_Wide_Character'Val (16#002D2D#),
         when 16#00AB76# => Wide_Wide_Character'Val (16#0013A6#),
         when 16#00FF22# => Wide_Wide_Character'Val (16#00FF42#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0000DE# => Wide_Wide_Character'Val (16#0000FE#),
         when 16#0004DA# => Wide_Wide_Character'Val (16#0004DB#),
         when 16#001EC0# => Wide_Wide_Character'Val (16#001EC1#),
         when 16#002CF2# => Wide_Wide_Character'Val (16#002CF3#),
         when 16#00A779# => Wide_Wide_Character'Val (16#00A77A#),
         when 16#00AB75# => Wide_Wide_Character'Val (16#0013A5#),
         when 16#00FF21# => Wide_Wide_Character'Val (16#00FF41#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_DF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001DE# => Wide_Wide_Character'Val (16#0001DF#),
         when 16#0003DC# => Wide_Wide_Character'Val (16#0003DD#),
         when 16#00AB74# => Wide_Wide_Character'Val (16#0013A4#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004E4# => Wide_Wide_Character'Val (16#0004E5#),
         when 16#001EFE# => Wide_Wide_Character'Val (16#001EFF#),
         when 16#0024C4# => Wide_Wide_Character'Val (16#0024DE#),
         when 16#002CCC# => Wide_Wide_Character'Val (16#002CCD#),
         when 16#00A646# => Wide_Wide_Character'Val (16#00A647#),
         when 16#01E908# => Wide_Wide_Character'Val (16#01E92A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001E0# => Wide_Wide_Character'Val (16#0001E1#),
         when 16#0003E2# => Wide_Wide_Character'Val (16#0003E3#),
         when 16#0024C5# => Wide_Wide_Character'Val (16#0024DF#),
         when 16#00A746# => Wide_Wide_Character'Val (16#00A747#),
         when 16#01E909# => Wide_Wide_Character'Val (16#01E92B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004E6# => Wide_Wide_Character'Val (16#0004E7#),
         when 16#001EFC# => Wide_Wide_Character'Val (16#001EFD#),
         when 16#0024C6# => Wide_Wide_Character'Val (16#0024E0#),
         when 16#002CCE# => Wide_Wide_Character'Val (16#002CCF#),
         when 16#00A644# => Wide_Wide_Character'Val (16#00A645#),
         when 16#01E90A# => Wide_Wide_Character'Val (16#01E92C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001E2# => Wide_Wide_Character'Val (16#0001E3#),
         when 16#0003E0# => Wide_Wide_Character'Val (16#0003E1#),
         when 16#001FFC# => Wide_Wide_Character'Val (16#001FF3#),
         when 16#0024C7# => Wide_Wide_Character'Val (16#0024E1#),
         when 16#00A744# => Wide_Wide_Character'Val (16#00A745#),
         when 16#01E90B# => Wide_Wide_Character'Val (16#01E92D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004E0# => Wide_Wide_Character'Val (16#0004E1#),
         when 16#001EFA# => Wide_Wide_Character'Val (16#001EFB#),
         when 16#001FFB# => Wide_Wide_Character'Val (16#001F7D#),
         when 16#0024C0# => Wide_Wide_Character'Val (16#0024DA#),
         when 16#002CC8# => Wide_Wide_Character'Val (16#002CC9#),
         when 16#00A642# => Wide_Wide_Character'Val (16#00A643#),
         when 16#01E90C# => Wide_Wide_Character'Val (16#01E92E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001E4# => Wide_Wide_Character'Val (16#0001E5#),
         when 16#0003E6# => Wide_Wide_Character'Val (16#0003E7#),
         when 16#001FFA# => Wide_Wide_Character'Val (16#001F7C#),
         when 16#0024C1# => Wide_Wide_Character'Val (16#0024DB#),
         when 16#00A742# => Wide_Wide_Character'Val (16#00A743#),
         when 16#01E90D# => Wide_Wide_Character'Val (16#01E92F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004E2# => Wide_Wide_Character'Val (16#0004E3#),
         when 16#001EF8# => Wide_Wide_Character'Val (16#001EF9#),
         when 16#001FF9# => Wide_Wide_Character'Val (16#001F79#),
         when 16#0024C2# => Wide_Wide_Character'Val (16#0024DC#),
         when 16#002CCA# => Wide_Wide_Character'Val (16#002CCB#),
         when 16#00A640# => Wide_Wide_Character'Val (16#00A641#),
         when 16#01E90E# => Wide_Wide_Character'Val (16#01E930#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001E6# => Wide_Wide_Character'Val (16#0001E7#),
         when 16#0003E4# => Wide_Wide_Character'Val (16#0003E5#),
         when 16#001FF8# => Wide_Wide_Character'Val (16#001F78#),
         when 16#0024C3# => Wide_Wide_Character'Val (16#0024DD#),
         when 16#00A740# => Wide_Wide_Character'Val (16#00A741#),
         when 16#01E90F# => Wide_Wide_Character'Val (16#01E931#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004EC# => Wide_Wide_Character'Val (16#0004ED#),
         when 16#0013FB# => Wide_Wide_Character'Val (16#0013F3#),
         when 16#001EF6# => Wide_Wide_Character'Val (16#001EF7#),
         when 16#0024CC# => Wide_Wide_Character'Val (16#0024E6#),
         when 16#002CC4# => Wide_Wide_Character'Val (16#002CC5#),
         when 16#00A64E# => Wide_Wide_Character'Val (16#00A64F#),
         when 16#01E900# => Wide_Wide_Character'Val (16#01E922#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_E9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001E8# => Wide_Wide_Character'Val (16#0001E9#),
         when 16#0003EA# => Wide_Wide_Character'Val (16#0003EB#),
         when 16#0013FA# => Wide_Wide_Character'Val (16#0013F2#),
         when 16#0024CD# => Wide_Wide_Character'Val (16#0024E7#),
         when 16#00A74E# => Wide_Wide_Character'Val (16#00A74F#),
         when 16#01E901# => Wide_Wide_Character'Val (16#01E923#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_EA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004EE# => Wide_Wide_Character'Val (16#0004EF#),
         when 16#0013F9# => Wide_Wide_Character'Val (16#0013F1#),
         when 16#001EF4# => Wide_Wide_Character'Val (16#001EF5#),
         when 16#0024CE# => Wide_Wide_Character'Val (16#0024E8#),
         when 16#002CC6# => Wide_Wide_Character'Val (16#002CC7#),
         when 16#00A64C# => Wide_Wide_Character'Val (16#00A64D#),
         when 16#01E902# => Wide_Wide_Character'Val (16#01E924#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_EB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001EA# => Wide_Wide_Character'Val (16#0001EB#),
         when 16#0003E8# => Wide_Wide_Character'Val (16#0003E9#),
         when 16#0013F8# => Wide_Wide_Character'Val (16#0013F0#),
         when 16#0024CF# => Wide_Wide_Character'Val (16#0024E9#),
         when 16#00A74C# => Wide_Wide_Character'Val (16#00A74D#),
         when 16#01E903# => Wide_Wide_Character'Val (16#01E925#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_EC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004E8# => Wide_Wide_Character'Val (16#0004E9#),
         when 16#001EF2# => Wide_Wide_Character'Val (16#001EF3#),
         when 16#0024C8# => Wide_Wide_Character'Val (16#0024E2#),
         when 16#002CC0# => Wide_Wide_Character'Val (16#002CC1#),
         when 16#00A64A# => Wide_Wide_Character'Val (16#00A64B#),
         when 16#01E904# => Wide_Wide_Character'Val (16#01E926#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_ED (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001EC# => Wide_Wide_Character'Val (16#0001ED#),
         when 16#0003EE# => Wide_Wide_Character'Val (16#0003EF#),
         when 16#0024C9# => Wide_Wide_Character'Val (16#0024E3#),
         when 16#00A74A# => Wide_Wide_Character'Val (16#00A74B#),
         when 16#01E905# => Wide_Wide_Character'Val (16#01E927#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_EE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004EA# => Wide_Wide_Character'Val (16#0004EB#),
         when 16#0013FD# => Wide_Wide_Character'Val (16#0013F5#),
         when 16#001EF0# => Wide_Wide_Character'Val (16#001EF1#),
         when 16#0024CA# => Wide_Wide_Character'Val (16#0024E4#),
         when 16#002CC2# => Wide_Wide_Character'Val (16#002CC3#),
         when 16#00A648# => Wide_Wide_Character'Val (16#00A649#),
         when 16#01E906# => Wide_Wide_Character'Val (16#01E928#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_EF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001EE# => Wide_Wide_Character'Val (16#0001EF#),
         when 16#0003EC# => Wide_Wide_Character'Val (16#0003ED#),
         when 16#0013FC# => Wide_Wide_Character'Val (16#0013F4#),
         when 16#0024CB# => Wide_Wide_Character'Val (16#0024E5#),
         when 16#00A748# => Wide_Wide_Character'Val (16#00A749#),
         when 16#01E907# => Wide_Wide_Character'Val (16#01E929#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F0 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F1# => Wide_Wide_Character'Val (16#0001F3#),
         when 16#0004F4# => Wide_Wide_Character'Val (16#0004F5#),
         when 16#001EEE# => Wide_Wide_Character'Val (16#001EEF#),
         when 16#002CDC# => Wide_Wide_Character'Val (16#002CDD#),
         when 16#00A656# => Wide_Wide_Character'Val (16#00A657#),
         when 16#01E918# => Wide_Wide_Character'Val (16#01E93A#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F1 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#00A756# => Wide_Wide_Character'Val (16#00A757#),
         when 16#01E919# => Wide_Wide_Character'Val (16#01E93B#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F2 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003F1# => Wide_Wide_Character'Val (16#0003C1#),
         when 16#0004F6# => Wide_Wide_Character'Val (16#0004F7#),
         when 16#001EEC# => Wide_Wide_Character'Val (16#001EED#),
         when 16#002CDE# => Wide_Wide_Character'Val (16#002CDF#),
         when 16#00A654# => Wide_Wide_Character'Val (16#00A655#),
         when 16#01E91A# => Wide_Wide_Character'Val (16#01E93C#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F3 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F2# => Wide_Wide_Character'Val (16#0001F3#),
         when 16#0003F0# => Wide_Wide_Character'Val (16#0003BA#),
         when 16#001FEC# => Wide_Wide_Character'Val (16#001FE5#),
         when 16#00A754# => Wide_Wide_Character'Val (16#00A755#),
         when 16#01E91B# => Wide_Wide_Character'Val (16#01E93D#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F4 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003F7# => Wide_Wide_Character'Val (16#0003F8#),
         when 16#0004F0# => Wide_Wide_Character'Val (16#0004F1#),
         when 16#001EEA# => Wide_Wide_Character'Val (16#001EEB#),
         when 16#001FEB# => Wide_Wide_Character'Val (16#001F7B#),
         when 16#002CD8# => Wide_Wide_Character'Val (16#002CD9#),
         when 16#00A652# => Wide_Wide_Character'Val (16#00A653#),
         when 16#01E91C# => Wide_Wide_Character'Val (16#01E93E#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F5 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F4# => Wide_Wide_Character'Val (16#0001F5#),
         when 16#001FEA# => Wide_Wide_Character'Val (16#001F7A#),
         when 16#00A752# => Wide_Wide_Character'Val (16#00A753#),
         when 16#01E91D# => Wide_Wide_Character'Val (16#01E93F#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F6 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F7# => Wide_Wide_Character'Val (16#0001BF#),
         when 16#0003F5# => Wide_Wide_Character'Val (16#0003B5#),
         when 16#0004F2# => Wide_Wide_Character'Val (16#0004F3#),
         when 16#001EE8# => Wide_Wide_Character'Val (16#001EE9#),
         when 16#001FE9# => Wide_Wide_Character'Val (16#001FE1#),
         when 16#002CDA# => Wide_Wide_Character'Val (16#002CDB#),
         when 16#00A650# => Wide_Wide_Character'Val (16#00A651#),
         when 16#01E91E# => Wide_Wide_Character'Val (16#01E940#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F7 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F6# => Wide_Wide_Character'Val (16#000195#),
         when 16#0003F4# => Wide_Wide_Character'Val (16#0003B8#),
         when 16#001FE8# => Wide_Wide_Character'Val (16#001FE0#),
         when 16#00A750# => Wide_Wide_Character'Val (16#00A751#),
         when 16#01E91F# => Wide_Wide_Character'Val (16#01E941#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F8 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0004FC# => Wide_Wide_Character'Val (16#0004FD#),
         when 16#001EE6# => Wide_Wide_Character'Val (16#001EE7#),
         when 16#002CD4# => Wide_Wide_Character'Val (16#002CD5#),
         when 16#00A65E# => Wide_Wide_Character'Val (16#00A65F#),
         when 16#01E910# => Wide_Wide_Character'Val (16#01E932#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_F9 (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001F8# => Wide_Wide_Character'Val (16#0001F9#),
         when 16#0003FA# => Wide_Wide_Character'Val (16#0003FB#),
         when 16#00A75E# => Wide_Wide_Character'Val (16#00A75F#),
         when 16#01E911# => Wide_Wide_Character'Val (16#01E933#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FA (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003F9# => Wide_Wide_Character'Val (16#0003F2#),
         when 16#0004FE# => Wide_Wide_Character'Val (16#0004FF#),
         when 16#001EE4# => Wide_Wide_Character'Val (16#001EE5#),
         when 16#002CD6# => Wide_Wide_Character'Val (16#002CD7#),
         when 16#00A65C# => Wide_Wide_Character'Val (16#00A65D#),
         when 16#01E912# => Wide_Wide_Character'Val (16#01E934#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FB (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001FA# => Wide_Wide_Character'Val (16#0001FB#),
         when 16#00A75C# => Wide_Wide_Character'Val (16#00A75D#),
         when 16#01E913# => Wide_Wide_Character'Val (16#01E935#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FC (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003FF# => Wide_Wide_Character'Val (16#00037D#),
         when 16#0004F8# => Wide_Wide_Character'Val (16#0004F9#),
         when 16#001EE2# => Wide_Wide_Character'Val (16#001EE3#),
         when 16#002CD0# => Wide_Wide_Character'Val (16#002CD1#),
         when 16#00A65A# => Wide_Wide_Character'Val (16#00A65B#),
         when 16#01E914# => Wide_Wide_Character'Val (16#01E936#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FD (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001FC# => Wide_Wide_Character'Val (16#0001FD#),
         when 16#0003FE# => Wide_Wide_Character'Val (16#00037C#),
         when 16#00A75A# => Wide_Wide_Character'Val (16#00A75B#),
         when 16#01E915# => Wide_Wide_Character'Val (16#01E937#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FE (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0003FD# => Wide_Wide_Character'Val (16#00037B#),
         when 16#0004FA# => Wide_Wide_Character'Val (16#0004FB#),
         when 16#001EE0# => Wide_Wide_Character'Val (16#001EE1#),
         when 16#002CD2# => Wide_Wide_Character'Val (16#002CD3#),
         when 16#00A658# => Wide_Wide_Character'Val (16#00A659#),
         when 16#01E916# => Wide_Wide_Character'Val (16#01E938#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;

   function Bucket_FF (C: Codepoint) return Wide_Wide_Character is
      (case C is
         when 16#0001FE# => Wide_Wide_Character'Val (16#0001FF#),
         when 16#00A758# => Wide_Wide_Character'Val (16#00A759#),
         when 16#01E917# => Wide_Wide_Character'Val (16#01E939#),

         when others => Wide_Wide_Character'Val (C))
      with Inline;


begin
   -- This shouldn't happen..
   if Wide_Wide_Character'Pos(C) > 16#10FFFF# then
      return C;
   end if;


   declare
      CP: constant Codepoint 
         := Codepoint (Wide_Wide_Character'Pos (C));
      K: constant Key_Hash := Hash (CP);
   begin
      case K is
         when 16#00# => return Bucket_00 (CP);
         when 16#01# => return Bucket_01 (CP);
         when 16#02# => return Bucket_02 (CP);
         when 16#03# => return Bucket_03 (CP);
         when 16#04# => return Bucket_04 (CP);
         when 16#05# => return Bucket_05 (CP);
         when 16#06# => return Bucket_06 (CP);
         when 16#07# => return Bucket_07 (CP);
         when 16#08# => return Bucket_08 (CP);
         when 16#09# => return Bucket_09 (CP);
         when 16#0A# => return Bucket_0A (CP);
         when 16#0B# => return Bucket_0B (CP);
         when 16#0C# => return Bucket_0C (CP);
         when 16#0D# => return Bucket_0D (CP);
         when 16#0E# => return Bucket_0E (CP);
         when 16#0F# => return Bucket_0F (CP);
         when 16#10# => return Bucket_10 (CP);
         when 16#11# => return Bucket_11 (CP);
         when 16#12# => return Bucket_12 (CP);
         when 16#13# => return Bucket_13 (CP);
         when 16#14# => return Bucket_14 (CP);
         when 16#15# => return Bucket_15 (CP);
         when 16#16# => return Bucket_16 (CP);
         when 16#17# => return Bucket_17 (CP);
         when 16#18# => return Bucket_18 (CP);
         when 16#19# => return Bucket_19 (CP);
         when 16#1A# => return Bucket_1A (CP);
         when 16#1B# => return Bucket_1B (CP);
         when 16#1C# => return Bucket_1C (CP);
         when 16#1D# => return Bucket_1D (CP);
         when 16#1E# => return Bucket_1E (CP);
         when 16#1F# => return Bucket_1F (CP);
         when 16#20# => return Bucket_20 (CP);
         when 16#21# => return Bucket_21 (CP);
         when 16#22# => return Bucket_22 (CP);
         when 16#23# => return Bucket_23 (CP);
         when 16#24# => return Bucket_24 (CP);
         when 16#25# => return Bucket_25 (CP);
         when 16#26# => return Bucket_26 (CP);
         when 16#27# => return Bucket_27 (CP);
         when 16#28# => return Bucket_28 (CP);
         when 16#29# => return Bucket_29 (CP);
         when 16#2A# => return Bucket_2A (CP);
         when 16#2B# => return Bucket_2B (CP);
         when 16#2C# => return Bucket_2C (CP);
         when 16#2D# => return Bucket_2D (CP);
         when 16#2E# => return Bucket_2E (CP);
         when 16#2F# => return Bucket_2F (CP);
         when 16#30# => return Bucket_30 (CP);
         when 16#31# => return Bucket_31 (CP);
         when 16#32# => return Bucket_32 (CP);
         when 16#33# => return Bucket_33 (CP);
         when 16#34# => return Bucket_34 (CP);
         when 16#35# => return Bucket_35 (CP);
         when 16#36# => return Bucket_36 (CP);
         when 16#37# => return Bucket_37 (CP);
         when 16#38# => return Bucket_38 (CP);
         when 16#39# => return Bucket_39 (CP);
         when 16#3A# => return Bucket_3A (CP);
         when 16#3B# => return Bucket_3B (CP);
         when 16#3C# => return Bucket_3C (CP);
         when 16#3D# => return Bucket_3D (CP);
         when 16#3E# => return Bucket_3E (CP);
         when 16#3F# => return Bucket_3F (CP);
         when 16#40# => return Bucket_40 (CP);
         when 16#41# => return Bucket_41 (CP);
         when 16#42# => return Bucket_42 (CP);
         when 16#43# => return Bucket_43 (CP);
         when 16#44# => return Bucket_44 (CP);
         when 16#45# => return Bucket_45 (CP);
         when 16#46# => return Bucket_46 (CP);
         when 16#47# => return Bucket_47 (CP);
         when 16#48# => return Bucket_48 (CP);
         when 16#49# => return Bucket_49 (CP);
         when 16#4A# => return Bucket_4A (CP);
         when 16#4B# => return Bucket_4B (CP);
         when 16#4C# => return Bucket_4C (CP);
         when 16#4D# => return Bucket_4D (CP);
         when 16#4E# => return Bucket_4E (CP);
         when 16#4F# => return Bucket_4F (CP);
         when 16#50# => return Bucket_50 (CP);
         when 16#51# => return Bucket_51 (CP);
         when 16#52# => return Bucket_52 (CP);
         when 16#53# => return Bucket_53 (CP);
         when 16#54# => return Bucket_54 (CP);
         when 16#55# => return Bucket_55 (CP);
         when 16#56# => return Bucket_56 (CP);
         when 16#57# => return Bucket_57 (CP);
         when 16#58# => return Bucket_58 (CP);
         when 16#59# => return Bucket_59 (CP);
         when 16#5A# => return Bucket_5A (CP);
         when 16#5B# => return Bucket_5B (CP);
         when 16#5C# => return Bucket_5C (CP);
         when 16#5D# => return Bucket_5D (CP);
         when 16#5E# => return Bucket_5E (CP);
         when 16#5F# => return Bucket_5F (CP);
         when 16#60# => return Bucket_60 (CP);
         when 16#61# => return Bucket_61 (CP);
         when 16#62# => return Bucket_62 (CP);
         when 16#63# => return Bucket_63 (CP);
         when 16#64# => return Bucket_64 (CP);
         when 16#65# => return Bucket_65 (CP);
         when 16#66# => return Bucket_66 (CP);
         when 16#67# => return Bucket_67 (CP);
         when 16#68# => return Bucket_68 (CP);
         when 16#69# => return Bucket_69 (CP);
         when 16#6A# => return Bucket_6A (CP);
         when 16#6B# => return Bucket_6B (CP);
         when 16#6C# => return Bucket_6C (CP);
         when 16#6D# => return Bucket_6D (CP);
         when 16#6E# => return Bucket_6E (CP);
         when 16#6F# => return Bucket_6F (CP);
         when 16#70# => return Bucket_70 (CP);
         when 16#71# => return Bucket_71 (CP);
         when 16#72# => return Bucket_72 (CP);
         when 16#73# => return Bucket_73 (CP);
         when 16#74# => return Bucket_74 (CP);
         when 16#75# => return Bucket_75 (CP);
         when 16#76# => return Bucket_76 (CP);
         when 16#77# => return Bucket_77 (CP);
         when 16#78# => return Bucket_78 (CP);
         when 16#79# => return Bucket_79 (CP);
         when 16#7A# => return Bucket_7A (CP);
         when 16#7B# => return Bucket_7B (CP);
         when 16#7C# => return Bucket_7C (CP);
         when 16#7D# => return Bucket_7D (CP);
         when 16#7E# => return Bucket_7E (CP);
         when 16#7F# => return Bucket_7F (CP);
         when 16#80# => return Bucket_80 (CP);
         when 16#81# => return Bucket_81 (CP);
         when 16#82# => return Bucket_82 (CP);
         when 16#83# => return Bucket_83 (CP);
         when 16#84# => return Bucket_84 (CP);
         when 16#85# => return Bucket_85 (CP);
         when 16#86# => return Bucket_86 (CP);
         when 16#87# => return Bucket_87 (CP);
         when 16#88# => return Bucket_88 (CP);
         when 16#89# => return Bucket_89 (CP);
         when 16#8A# => return Bucket_8A (CP);
         when 16#8B# => return Bucket_8B (CP);
         when 16#8C# => return Bucket_8C (CP);
         when 16#8D# => return Bucket_8D (CP);
         when 16#8E# => return Bucket_8E (CP);
         when 16#8F# => return Bucket_8F (CP);
         when 16#90# => return Bucket_90 (CP);
         when 16#91# => return Bucket_91 (CP);
         when 16#92# => return Bucket_92 (CP);
         when 16#93# => return Bucket_93 (CP);
         when 16#94# => return Bucket_94 (CP);
         when 16#95# => return Bucket_95 (CP);
         when 16#96# => return Bucket_96 (CP);
         when 16#97# => return Bucket_97 (CP);
         when 16#98# => return Bucket_98 (CP);
         when 16#99# => return Bucket_99 (CP);
         when 16#9A# => return Bucket_9A (CP);
         when 16#9B# => return Bucket_9B (CP);
         when 16#9C# => return Bucket_9C (CP);
         when 16#9D# => return Bucket_9D (CP);
         when 16#9E# => return Bucket_9E (CP);
         when 16#9F# => return Bucket_9F (CP);
         when 16#A0# => return Bucket_A0 (CP);
         when 16#A1# => return Bucket_A1 (CP);
         when 16#A2# => return Bucket_A2 (CP);
         when 16#A3# => return Bucket_A3 (CP);
         when 16#A4# => return Bucket_A4 (CP);
         when 16#A5# => return Bucket_A5 (CP);
         when 16#A6# => return Bucket_A6 (CP);
         when 16#A7# => return Bucket_A7 (CP);
         when 16#A8# => return Bucket_A8 (CP);
         when 16#A9# => return Bucket_A9 (CP);
         when 16#AA# => return Bucket_AA (CP);
         when 16#AB# => return Bucket_AB (CP);
         when 16#AC# => return Bucket_AC (CP);
         when 16#AD# => return Bucket_AD (CP);
         when 16#AE# => return Bucket_AE (CP);
         when 16#AF# => return Bucket_AF (CP);
         when 16#B0# => return Bucket_B0 (CP);
         when 16#B1# => return Bucket_B1 (CP);
         when 16#B2# => return Bucket_B2 (CP);
         when 16#B3# => return Bucket_B3 (CP);
         when 16#B4# => return Bucket_B4 (CP);
         when 16#B5# => return Bucket_B5 (CP);
         when 16#B6# => return Bucket_B6 (CP);
         when 16#B7# => return Bucket_B7 (CP);
         when 16#B8# => return Bucket_B8 (CP);
         when 16#B9# => return Bucket_B9 (CP);
         when 16#BA# => return Bucket_BA (CP);
         when 16#BB# => return Bucket_BB (CP);
         when 16#BC# => return Bucket_BC (CP);
         when 16#BD# => return Bucket_BD (CP);
         when 16#BE# => return Bucket_BE (CP);
         when 16#BF# => return Bucket_BF (CP);
         when 16#C0# => return Bucket_C0 (CP);
         when 16#C1# => return Bucket_C1 (CP);
         when 16#C2# => return Bucket_C2 (CP);
         when 16#C3# => return Bucket_C3 (CP);
         when 16#C4# => return Bucket_C4 (CP);
         when 16#C5# => return Bucket_C5 (CP);
         when 16#C6# => return Bucket_C6 (CP);
         when 16#C7# => return Bucket_C7 (CP);
         when 16#C8# => return Bucket_C8 (CP);
         when 16#C9# => return Bucket_C9 (CP);
         when 16#CA# => return Bucket_CA (CP);
         when 16#CB# => return Bucket_CB (CP);
         when 16#CC# => return Bucket_CC (CP);
         when 16#CD# => return Bucket_CD (CP);
         when 16#CE# => return Bucket_CE (CP);
         when 16#CF# => return Bucket_CF (CP);
         when 16#D0# => return Bucket_D0 (CP);
         when 16#D1# => return Bucket_D1 (CP);
         when 16#D2# => return Bucket_D2 (CP);
         when 16#D3# => return Bucket_D3 (CP);
         when 16#D4# => return Bucket_D4 (CP);
         when 16#D5# => return Bucket_D5 (CP);
         when 16#D6# => return Bucket_D6 (CP);
         when 16#D7# => return Bucket_D7 (CP);
         when 16#D8# => return Bucket_D8 (CP);
         when 16#D9# => return Bucket_D9 (CP);
         when 16#DA# => return Bucket_DA (CP);
         when 16#DB# => return Bucket_DB (CP);
         when 16#DC# => return Bucket_DC (CP);
         when 16#DD# => return Bucket_DD (CP);
         when 16#DE# => return Bucket_DE (CP);
         when 16#DF# => return Bucket_DF (CP);
         when 16#E0# => return Bucket_E0 (CP);
         when 16#E1# => return Bucket_E1 (CP);
         when 16#E2# => return Bucket_E2 (CP);
         when 16#E3# => return Bucket_E3 (CP);
         when 16#E4# => return Bucket_E4 (CP);
         when 16#E5# => return Bucket_E5 (CP);
         when 16#E6# => return Bucket_E6 (CP);
         when 16#E7# => return Bucket_E7 (CP);
         when 16#E8# => return Bucket_E8 (CP);
         when 16#E9# => return Bucket_E9 (CP);
         when 16#EA# => return Bucket_EA (CP);
         when 16#EB# => return Bucket_EB (CP);
         when 16#EC# => return Bucket_EC (CP);
         when 16#ED# => return Bucket_ED (CP);
         when 16#EE# => return Bucket_EE (CP);
         when 16#EF# => return Bucket_EF (CP);
         when 16#F0# => return Bucket_F0 (CP);
         when 16#F1# => return Bucket_F1 (CP);
         when 16#F2# => return Bucket_F2 (CP);
         when 16#F3# => return Bucket_F3 (CP);
         when 16#F4# => return Bucket_F4 (CP);
         when 16#F5# => return Bucket_F5 (CP);
         when 16#F6# => return Bucket_F6 (CP);
         when 16#F7# => return Bucket_F7 (CP);
         when 16#F8# => return Bucket_F8 (CP);
         when 16#F9# => return Bucket_F9 (CP);
         when 16#FA# => return Bucket_FA (CP);
         when 16#FB# => return Bucket_FB (CP);
         when 16#FC# => return Bucket_FC (CP);
         when 16#FD# => return Bucket_FD (CP);
         when 16#FE# => return Bucket_FE (CP);
         when 16#FF# => return Bucket_FF (CP);
      end case;
   end;

end Unicode.Case_Folding.Simple;
