------------------------------------------------------------------------------
--                                                                          --
--                             Unicode Utilities                            --
--                                                                          --
--                      General Category Query Utility                      --
--                                                                          --
-- ------------------------------------------------------------------------ --
--                                                                          --
--  Copyright (C) 2019, ANNEXI-STRAYLINE Trans-Human Ltd.                   --
--  All rights reserved.                                                    --
--                                                                          --
--  Original Contributors:                                                  --
--  * Richard Wai (ANNEXI-STRAYLINE)                                        --
--                                                                          --
--  Redistribution and use in source and binary forms, with or without      --
--  modification, are permitted provided that the following conditions are  --
--  met:                                                                    --
--                                                                          --
--      * Redistributions of source code must retain the above copyright    --
--        notice, this list of conditions and the following disclaimer.     --
--                                                                          --
--      * Redistributions in binary form must reproduce the above copyright --
--        notice, this list of conditions and the following disclaimer in   --
--        the documentation and/or other materials provided with the        --
--        distribution.                                                     --
--                                                                          --
--      * Neither the name of the copyright holder nor the names of its     --
--        contributors may be used to endorse or promote products derived   --
--        from this software without specific prior written permission.     --
--                                                                          --
--  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS     --
--  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT       --
--  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A --
--  PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT      --
--  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,   --
--  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT        --
--  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,   --
--  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY   --
--  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT     --
--  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE   --
--  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.    --
--                                                                          --
------------------------------------------------------------------------------

-- Generated: 2019-08-13
-- UnicodeData.txt source:
-- https://www.unicode.org/Public/UCD/latest/ucd/UnicodeData.txt

-- ********** THIS FILE IS AUTOMATICALLY GENERATED ********* --
--  - See Unicode.UCD.Generate_General_Category_Body -  --


-- UnicodeData.txt Load Statistics --
--  LETTER_UPPERCASE          (Lu) = 1788
--  LETTER_LOWERCASE          (Ll) = 2151
--  LETTER_TITLECASE          (Lt) = 31
--  LETTER_MODIFIER           (Lm) = 259
--  LETTER_OTHER              (Lo) = 121414
--  MARK_NONSPACING           (Mn) = 1826
--  MARK_SPACING_COMBINING    (Mc) = 429
--  MARK_ENCLOSING            (Me) = 13
--  NUMBER_DECIMAL_DIGIT      (Nd) = 630
--  NUMBER_LETTER             (Nl) = 236
--  NUMBER_OTHER              (No) = 888
--  PUNCTUATION_CONNECTOR     (Pc) = 10
--  PUNCTUATION_DASH          (Pd) = 24
--  PUNCTUATION_OPEN          (Ps) = 75
--  PUNCTUATION_CLOSE         (Pe) = 73
--  PUNCTUATION_INITIAL_QUOTE (Pi) = 12
--  PUNCTUATION_FINAL_QUOTE   (Pf) = 10
--  PUNCTUATION_OTHER         (Po) = 588
--  SYMBOL_MATH               (Sm) = 948
--  SYMBOL_CURRENCY           (Sc) = 62
--  SYMBOL_MODIFIER           (Sk) = 121
--  SYMBOL_OTHER              (So) = 6161
--  SEPARATOR_SPACE           (Zs) = 17
--  SEPARATOR_LINE            (Zl) = 1
--  SEPARATOR_PARAGRAPH       (Zp) = 1
--  OTHER_CONTROL             (Cc) = 65
--  OTHER_FORMAT              (Cf) = 161
--  OTHER_SURROGATE           (Cs) = 2048
--  OTHER_PRIVATE_USE         (Co) = 137468
--  OTHER_NOT_ASSIGNED        (Cn) = 836602
----------------------------------------------
--  Grand Total                    = 1114112
--
-- Sanity Checks --
--  [PASS] Grand total = 16#110000# (U+000000 .. U+10FFFF)
--  [PASS] Total loaded ( 277510 ) = Hash table totals excluding Cn ( 277510 )


package body Unicode.General_Category is
   type Codepoint is mod 2**24;


   function Plane_00_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#000000# .. 16#00001F# => OTHER_CONTROL,
         when 16#000020#               => SEPARATOR_SPACE,
         when 16#000021# .. 16#000023# => PUNCTUATION_OTHER,
         when 16#000024#               => SYMBOL_CURRENCY,
         when 16#000025# .. 16#000027# => PUNCTUATION_OTHER,
         when 16#000028#               => PUNCTUATION_OPEN,
         when 16#000029#               => PUNCTUATION_CLOSE,
         when 16#00002A#               => PUNCTUATION_OTHER,
         when 16#00002B#               => SYMBOL_MATH,
         when 16#00002C#               => PUNCTUATION_OTHER,
         when 16#00002D#               => PUNCTUATION_DASH,
         when 16#00002E# .. 16#00002F# => PUNCTUATION_OTHER,
         when 16#000030# .. 16#000039# => NUMBER_DECIMAL_DIGIT,
         when 16#00003A# .. 16#00003B# => PUNCTUATION_OTHER,
         when 16#00003C# .. 16#00003E# => SYMBOL_MATH,
         when 16#00003F# .. 16#000040# => PUNCTUATION_OTHER,
         when 16#000041# .. 16#00005A# => LETTER_UPPERCASE,
         when 16#00005B#               => PUNCTUATION_OPEN,
         when 16#00005C#               => PUNCTUATION_OTHER,
         when 16#00005D#               => PUNCTUATION_CLOSE,
         when 16#00005E#               => SYMBOL_MODIFIER,
         when 16#00005F#               => PUNCTUATION_CONNECTOR,
         when 16#000060#               => SYMBOL_MODIFIER,
         when 16#000061# .. 16#00007A# => LETTER_LOWERCASE,
         when 16#00007B#               => PUNCTUATION_OPEN,
         when 16#00007C#               => SYMBOL_MATH,
         when 16#00007D#               => PUNCTUATION_CLOSE,
         when 16#00007E#               => SYMBOL_MATH,
         when 16#00007F# .. 16#00009F# => OTHER_CONTROL,
         when 16#0000A0#               => SEPARATOR_SPACE,
         when 16#0000A1#               => PUNCTUATION_OTHER,
         when 16#0000A2# .. 16#0000A5# => SYMBOL_CURRENCY,
         when 16#0000A6#               => SYMBOL_OTHER,
         when 16#0000A7#               => PUNCTUATION_OTHER,
         when 16#0000A8#               => SYMBOL_MODIFIER,
         when 16#0000A9#               => SYMBOL_OTHER,
         when 16#0000AA#               => LETTER_OTHER,
         when 16#0000AB#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#0000AC#               => SYMBOL_MATH,
         when 16#0000AD#               => OTHER_FORMAT,
         when 16#0000AE#               => SYMBOL_OTHER,
         when 16#0000AF#               => SYMBOL_MODIFIER,
         when 16#0000B0#               => SYMBOL_OTHER,
         when 16#0000B1#               => SYMBOL_MATH,
         when 16#0000B2# .. 16#0000B3# => NUMBER_OTHER,
         when 16#0000B4#               => SYMBOL_MODIFIER,
         when 16#0000B5#               => LETTER_LOWERCASE,
         when 16#0000B6# .. 16#0000B7# => PUNCTUATION_OTHER,
         when 16#0000B8#               => SYMBOL_MODIFIER,
         when 16#0000B9#               => NUMBER_OTHER,
         when 16#0000BA#               => LETTER_OTHER,
         when 16#0000BB#               => PUNCTUATION_FINAL_QUOTE,
         when 16#0000BC# .. 16#0000BE# => NUMBER_OTHER,
         when 16#0000BF#               => PUNCTUATION_OTHER,
         when 16#0000C0# .. 16#0000D6# => LETTER_UPPERCASE,
         when 16#0000D7#               => SYMBOL_MATH,
         when 16#0000D8# .. 16#0000DE# => LETTER_UPPERCASE,
         when 16#0000DF# .. 16#0000F6# => LETTER_LOWERCASE,
         when 16#0000F7#               => SYMBOL_MATH,
         when 16#0000F8# .. 16#0000FF# => LETTER_LOWERCASE,
         when 16#000100#               => LETTER_UPPERCASE,
         when 16#000101#               => LETTER_LOWERCASE,
         when 16#000102#               => LETTER_UPPERCASE,
         when 16#000103#               => LETTER_LOWERCASE,
         when 16#000104#               => LETTER_UPPERCASE,
         when 16#000105#               => LETTER_LOWERCASE,
         when 16#000106#               => LETTER_UPPERCASE,
         when 16#000107#               => LETTER_LOWERCASE,
         when 16#000108#               => LETTER_UPPERCASE,
         when 16#000109#               => LETTER_LOWERCASE,
         when 16#00010A#               => LETTER_UPPERCASE,
         when 16#00010B#               => LETTER_LOWERCASE,
         when 16#00010C#               => LETTER_UPPERCASE,
         when 16#00010D#               => LETTER_LOWERCASE,
         when 16#00010E#               => LETTER_UPPERCASE,
         when 16#00010F#               => LETTER_LOWERCASE,
         when 16#000110#               => LETTER_UPPERCASE,
         when 16#000111#               => LETTER_LOWERCASE,
         when 16#000112#               => LETTER_UPPERCASE,
         when 16#000113#               => LETTER_LOWERCASE,
         when 16#000114#               => LETTER_UPPERCASE,
         when 16#000115#               => LETTER_LOWERCASE,
         when 16#000116#               => LETTER_UPPERCASE,
         when 16#000117#               => LETTER_LOWERCASE,
         when 16#000118#               => LETTER_UPPERCASE,
         when 16#000119#               => LETTER_LOWERCASE,
         when 16#00011A#               => LETTER_UPPERCASE,
         when 16#00011B#               => LETTER_LOWERCASE,
         when 16#00011C#               => LETTER_UPPERCASE,
         when 16#00011D#               => LETTER_LOWERCASE,
         when 16#00011E#               => LETTER_UPPERCASE,
         when 16#00011F#               => LETTER_LOWERCASE,
         when 16#000120#               => LETTER_UPPERCASE,
         when 16#000121#               => LETTER_LOWERCASE,
         when 16#000122#               => LETTER_UPPERCASE,
         when 16#000123#               => LETTER_LOWERCASE,
         when 16#000124#               => LETTER_UPPERCASE,
         when 16#000125#               => LETTER_LOWERCASE,
         when 16#000126#               => LETTER_UPPERCASE,
         when 16#000127#               => LETTER_LOWERCASE,
         when 16#000128#               => LETTER_UPPERCASE,
         when 16#000129#               => LETTER_LOWERCASE,
         when 16#00012A#               => LETTER_UPPERCASE,
         when 16#00012B#               => LETTER_LOWERCASE,
         when 16#00012C#               => LETTER_UPPERCASE,
         when 16#00012D#               => LETTER_LOWERCASE,
         when 16#00012E#               => LETTER_UPPERCASE,
         when 16#00012F#               => LETTER_LOWERCASE,
         when 16#000130#               => LETTER_UPPERCASE,
         when 16#000131#               => LETTER_LOWERCASE,
         when 16#000132#               => LETTER_UPPERCASE,
         when 16#000133#               => LETTER_LOWERCASE,
         when 16#000134#               => LETTER_UPPERCASE,
         when 16#000135#               => LETTER_LOWERCASE,
         when 16#000136#               => LETTER_UPPERCASE,
         when 16#000137# .. 16#000138# => LETTER_LOWERCASE,
         when 16#000139#               => LETTER_UPPERCASE,
         when 16#00013A#               => LETTER_LOWERCASE,
         when 16#00013B#               => LETTER_UPPERCASE,
         when 16#00013C#               => LETTER_LOWERCASE,
         when 16#00013D#               => LETTER_UPPERCASE,
         when 16#00013E#               => LETTER_LOWERCASE,
         when 16#00013F#               => LETTER_UPPERCASE,
         when 16#000140#               => LETTER_LOWERCASE,
         when 16#000141#               => LETTER_UPPERCASE,
         when 16#000142#               => LETTER_LOWERCASE,
         when 16#000143#               => LETTER_UPPERCASE,
         when 16#000144#               => LETTER_LOWERCASE,
         when 16#000145#               => LETTER_UPPERCASE,
         when 16#000146#               => LETTER_LOWERCASE,
         when 16#000147#               => LETTER_UPPERCASE,
         when 16#000148# .. 16#000149# => LETTER_LOWERCASE,
         when 16#00014A#               => LETTER_UPPERCASE,
         when 16#00014B#               => LETTER_LOWERCASE,
         when 16#00014C#               => LETTER_UPPERCASE,
         when 16#00014D#               => LETTER_LOWERCASE,
         when 16#00014E#               => LETTER_UPPERCASE,
         when 16#00014F#               => LETTER_LOWERCASE,
         when 16#000150#               => LETTER_UPPERCASE,
         when 16#000151#               => LETTER_LOWERCASE,
         when 16#000152#               => LETTER_UPPERCASE,
         when 16#000153#               => LETTER_LOWERCASE,
         when 16#000154#               => LETTER_UPPERCASE,
         when 16#000155#               => LETTER_LOWERCASE,
         when 16#000156#               => LETTER_UPPERCASE,
         when 16#000157#               => LETTER_LOWERCASE,
         when 16#000158#               => LETTER_UPPERCASE,
         when 16#000159#               => LETTER_LOWERCASE,
         when 16#00015A#               => LETTER_UPPERCASE,
         when 16#00015B#               => LETTER_LOWERCASE,
         when 16#00015C#               => LETTER_UPPERCASE,
         when 16#00015D#               => LETTER_LOWERCASE,
         when 16#00015E#               => LETTER_UPPERCASE,
         when 16#00015F#               => LETTER_LOWERCASE,
         when 16#000160#               => LETTER_UPPERCASE,
         when 16#000161#               => LETTER_LOWERCASE,
         when 16#000162#               => LETTER_UPPERCASE,
         when 16#000163#               => LETTER_LOWERCASE,
         when 16#000164#               => LETTER_UPPERCASE,
         when 16#000165#               => LETTER_LOWERCASE,
         when 16#000166#               => LETTER_UPPERCASE,
         when 16#000167#               => LETTER_LOWERCASE,
         when 16#000168#               => LETTER_UPPERCASE,
         when 16#000169#               => LETTER_LOWERCASE,
         when 16#00016A#               => LETTER_UPPERCASE,
         when 16#00016B#               => LETTER_LOWERCASE,
         when 16#00016C#               => LETTER_UPPERCASE,
         when 16#00016D#               => LETTER_LOWERCASE,
         when 16#00016E#               => LETTER_UPPERCASE,
         when 16#00016F#               => LETTER_LOWERCASE,
         when 16#000170#               => LETTER_UPPERCASE,
         when 16#000171#               => LETTER_LOWERCASE,
         when 16#000172#               => LETTER_UPPERCASE,
         when 16#000173#               => LETTER_LOWERCASE,
         when 16#000174#               => LETTER_UPPERCASE,
         when 16#000175#               => LETTER_LOWERCASE,
         when 16#000176#               => LETTER_UPPERCASE,
         when 16#000177#               => LETTER_LOWERCASE,
         when 16#000178# .. 16#000179# => LETTER_UPPERCASE,
         when 16#00017A#               => LETTER_LOWERCASE,
         when 16#00017B#               => LETTER_UPPERCASE,
         when 16#00017C#               => LETTER_LOWERCASE,
         when 16#00017D#               => LETTER_UPPERCASE,
         when 16#00017E# .. 16#000180# => LETTER_LOWERCASE,
         when 16#000181# .. 16#000182# => LETTER_UPPERCASE,
         when 16#000183#               => LETTER_LOWERCASE,
         when 16#000184#               => LETTER_UPPERCASE,
         when 16#000185#               => LETTER_LOWERCASE,
         when 16#000186# .. 16#000187# => LETTER_UPPERCASE,
         when 16#000188#               => LETTER_LOWERCASE,
         when 16#000189# .. 16#00018B# => LETTER_UPPERCASE,
         when 16#00018C# .. 16#00018D# => LETTER_LOWERCASE,
         when 16#00018E# .. 16#000191# => LETTER_UPPERCASE,
         when 16#000192#               => LETTER_LOWERCASE,
         when 16#000193# .. 16#000194# => LETTER_UPPERCASE,
         when 16#000195#               => LETTER_LOWERCASE,
         when 16#000196# .. 16#000198# => LETTER_UPPERCASE,
         when 16#000199# .. 16#00019B# => LETTER_LOWERCASE,
         when 16#00019C# .. 16#00019D# => LETTER_UPPERCASE,
         when 16#00019E#               => LETTER_LOWERCASE,
         when 16#00019F# .. 16#0001A0# => LETTER_UPPERCASE,
         when 16#0001A1#               => LETTER_LOWERCASE,
         when 16#0001A2#               => LETTER_UPPERCASE,
         when 16#0001A3#               => LETTER_LOWERCASE,
         when 16#0001A4#               => LETTER_UPPERCASE,
         when 16#0001A5#               => LETTER_LOWERCASE,
         when 16#0001A6# .. 16#0001A7# => LETTER_UPPERCASE,
         when 16#0001A8#               => LETTER_LOWERCASE,
         when 16#0001A9#               => LETTER_UPPERCASE,
         when 16#0001AA# .. 16#0001AB# => LETTER_LOWERCASE,
         when 16#0001AC#               => LETTER_UPPERCASE,
         when 16#0001AD#               => LETTER_LOWERCASE,
         when 16#0001AE# .. 16#0001AF# => LETTER_UPPERCASE,
         when 16#0001B0#               => LETTER_LOWERCASE,
         when 16#0001B1# .. 16#0001B3# => LETTER_UPPERCASE,
         when 16#0001B4#               => LETTER_LOWERCASE,
         when 16#0001B5#               => LETTER_UPPERCASE,
         when 16#0001B6#               => LETTER_LOWERCASE,
         when 16#0001B7# .. 16#0001B8# => LETTER_UPPERCASE,
         when 16#0001B9# .. 16#0001BA# => LETTER_LOWERCASE,
         when 16#0001BB#               => LETTER_OTHER,
         when 16#0001BC#               => LETTER_UPPERCASE,
         when 16#0001BD# .. 16#0001BF# => LETTER_LOWERCASE,
         when 16#0001C0# .. 16#0001C3# => LETTER_OTHER,
         when 16#0001C4#               => LETTER_UPPERCASE,
         when 16#0001C5#               => LETTER_TITLECASE,
         when 16#0001C6#               => LETTER_LOWERCASE,
         when 16#0001C7#               => LETTER_UPPERCASE,
         when 16#0001C8#               => LETTER_TITLECASE,
         when 16#0001C9#               => LETTER_LOWERCASE,
         when 16#0001CA#               => LETTER_UPPERCASE,
         when 16#0001CB#               => LETTER_TITLECASE,
         when 16#0001CC#               => LETTER_LOWERCASE,
         when 16#0001CD#               => LETTER_UPPERCASE,
         when 16#0001CE#               => LETTER_LOWERCASE,
         when 16#0001CF#               => LETTER_UPPERCASE,
         when 16#0001D0#               => LETTER_LOWERCASE,
         when 16#0001D1#               => LETTER_UPPERCASE,
         when 16#0001D2#               => LETTER_LOWERCASE,
         when 16#0001D3#               => LETTER_UPPERCASE,
         when 16#0001D4#               => LETTER_LOWERCASE,
         when 16#0001D5#               => LETTER_UPPERCASE,
         when 16#0001D6#               => LETTER_LOWERCASE,
         when 16#0001D7#               => LETTER_UPPERCASE,
         when 16#0001D8#               => LETTER_LOWERCASE,
         when 16#0001D9#               => LETTER_UPPERCASE,
         when 16#0001DA#               => LETTER_LOWERCASE,
         when 16#0001DB#               => LETTER_UPPERCASE,
         when 16#0001DC# .. 16#0001DD# => LETTER_LOWERCASE,
         when 16#0001DE#               => LETTER_UPPERCASE,
         when 16#0001DF#               => LETTER_LOWERCASE,
         when 16#0001E0#               => LETTER_UPPERCASE,
         when 16#0001E1#               => LETTER_LOWERCASE,
         when 16#0001E2#               => LETTER_UPPERCASE,
         when 16#0001E3#               => LETTER_LOWERCASE,
         when 16#0001E4#               => LETTER_UPPERCASE,
         when 16#0001E5#               => LETTER_LOWERCASE,
         when 16#0001E6#               => LETTER_UPPERCASE,
         when 16#0001E7#               => LETTER_LOWERCASE,
         when 16#0001E8#               => LETTER_UPPERCASE,
         when 16#0001E9#               => LETTER_LOWERCASE,
         when 16#0001EA#               => LETTER_UPPERCASE,
         when 16#0001EB#               => LETTER_LOWERCASE,
         when 16#0001EC#               => LETTER_UPPERCASE,
         when 16#0001ED#               => LETTER_LOWERCASE,
         when 16#0001EE#               => LETTER_UPPERCASE,
         when 16#0001EF# .. 16#0001F0# => LETTER_LOWERCASE,
         when 16#0001F1#               => LETTER_UPPERCASE,
         when 16#0001F2#               => LETTER_TITLECASE,
         when 16#0001F3#               => LETTER_LOWERCASE,
         when 16#0001F4#               => LETTER_UPPERCASE,
         when 16#0001F5#               => LETTER_LOWERCASE,
         when 16#0001F6# .. 16#0001F8# => LETTER_UPPERCASE,
         when 16#0001F9#               => LETTER_LOWERCASE,
         when 16#0001FA#               => LETTER_UPPERCASE,
         when 16#0001FB#               => LETTER_LOWERCASE,
         when 16#0001FC#               => LETTER_UPPERCASE,
         when 16#0001FD#               => LETTER_LOWERCASE,
         when 16#0001FE#               => LETTER_UPPERCASE,
         when 16#0001FF#               => LETTER_LOWERCASE,
         when 16#000200#               => LETTER_UPPERCASE,
         when 16#000201#               => LETTER_LOWERCASE,
         when 16#000202#               => LETTER_UPPERCASE,
         when 16#000203#               => LETTER_LOWERCASE,
         when 16#000204#               => LETTER_UPPERCASE,
         when 16#000205#               => LETTER_LOWERCASE,
         when 16#000206#               => LETTER_UPPERCASE,
         when 16#000207#               => LETTER_LOWERCASE,
         when 16#000208#               => LETTER_UPPERCASE,
         when 16#000209#               => LETTER_LOWERCASE,
         when 16#00020A#               => LETTER_UPPERCASE,
         when 16#00020B#               => LETTER_LOWERCASE,
         when 16#00020C#               => LETTER_UPPERCASE,
         when 16#00020D#               => LETTER_LOWERCASE,
         when 16#00020E#               => LETTER_UPPERCASE,
         when 16#00020F#               => LETTER_LOWERCASE,
         when 16#000210#               => LETTER_UPPERCASE,
         when 16#000211#               => LETTER_LOWERCASE,
         when 16#000212#               => LETTER_UPPERCASE,
         when 16#000213#               => LETTER_LOWERCASE,
         when 16#000214#               => LETTER_UPPERCASE,
         when 16#000215#               => LETTER_LOWERCASE,
         when 16#000216#               => LETTER_UPPERCASE,
         when 16#000217#               => LETTER_LOWERCASE,
         when 16#000218#               => LETTER_UPPERCASE,
         when 16#000219#               => LETTER_LOWERCASE,
         when 16#00021A#               => LETTER_UPPERCASE,
         when 16#00021B#               => LETTER_LOWERCASE,
         when 16#00021C#               => LETTER_UPPERCASE,
         when 16#00021D#               => LETTER_LOWERCASE,
         when 16#00021E#               => LETTER_UPPERCASE,
         when 16#00021F#               => LETTER_LOWERCASE,
         when 16#000220#               => LETTER_UPPERCASE,
         when 16#000221#               => LETTER_LOWERCASE,
         when 16#000222#               => LETTER_UPPERCASE,
         when 16#000223#               => LETTER_LOWERCASE,
         when 16#000224#               => LETTER_UPPERCASE,
         when 16#000225#               => LETTER_LOWERCASE,
         when 16#000226#               => LETTER_UPPERCASE,
         when 16#000227#               => LETTER_LOWERCASE,
         when 16#000228#               => LETTER_UPPERCASE,
         when 16#000229#               => LETTER_LOWERCASE,
         when 16#00022A#               => LETTER_UPPERCASE,
         when 16#00022B#               => LETTER_LOWERCASE,
         when 16#00022C#               => LETTER_UPPERCASE,
         when 16#00022D#               => LETTER_LOWERCASE,
         when 16#00022E#               => LETTER_UPPERCASE,
         when 16#00022F#               => LETTER_LOWERCASE,
         when 16#000230#               => LETTER_UPPERCASE,
         when 16#000231#               => LETTER_LOWERCASE,
         when 16#000232#               => LETTER_UPPERCASE,
         when 16#000233# .. 16#000239# => LETTER_LOWERCASE,
         when 16#00023A# .. 16#00023B# => LETTER_UPPERCASE,
         when 16#00023C#               => LETTER_LOWERCASE,
         when 16#00023D# .. 16#00023E# => LETTER_UPPERCASE,
         when 16#00023F# .. 16#000240# => LETTER_LOWERCASE,
         when 16#000241#               => LETTER_UPPERCASE,
         when 16#000242#               => LETTER_LOWERCASE,
         when 16#000243# .. 16#000246# => LETTER_UPPERCASE,
         when 16#000247#               => LETTER_LOWERCASE,
         when 16#000248#               => LETTER_UPPERCASE,
         when 16#000249#               => LETTER_LOWERCASE,
         when 16#00024A#               => LETTER_UPPERCASE,
         when 16#00024B#               => LETTER_LOWERCASE,
         when 16#00024C#               => LETTER_UPPERCASE,
         when 16#00024D#               => LETTER_LOWERCASE,
         when 16#00024E#               => LETTER_UPPERCASE,
         when 16#00024F# .. 16#000293# => LETTER_LOWERCASE,
         when 16#000294#               => LETTER_OTHER,
         when 16#000295# .. 16#0002AF# => LETTER_LOWERCASE,
         when 16#0002B0# .. 16#0002C1# => LETTER_MODIFIER,
         when 16#0002C2# .. 16#0002C5# => SYMBOL_MODIFIER,
         when 16#0002C6# .. 16#0002D1# => LETTER_MODIFIER,
         when 16#0002D2# .. 16#0002DF# => SYMBOL_MODIFIER,
         when 16#0002E0# .. 16#0002E4# => LETTER_MODIFIER,
         when 16#0002E5# .. 16#0002EB# => SYMBOL_MODIFIER,
         when 16#0002EC#               => LETTER_MODIFIER,
         when 16#0002ED#               => SYMBOL_MODIFIER,
         when 16#0002EE#               => LETTER_MODIFIER,
         when 16#0002EF# .. 16#0002FF# => SYMBOL_MODIFIER,
         when 16#000300# .. 16#00036F# => MARK_NONSPACING,
         when 16#000370#               => LETTER_UPPERCASE,
         when 16#000371#               => LETTER_LOWERCASE,
         when 16#000372#               => LETTER_UPPERCASE,
         when 16#000373#               => LETTER_LOWERCASE,
         when 16#000374#               => LETTER_MODIFIER,
         when 16#000375#               => SYMBOL_MODIFIER,
         when 16#000376#               => LETTER_UPPERCASE,
         when 16#000377#               => LETTER_LOWERCASE,
         when 16#00037A#               => LETTER_MODIFIER,
         when 16#00037B# .. 16#00037D# => LETTER_LOWERCASE,
         when 16#00037E#               => PUNCTUATION_OTHER,
         when 16#00037F#               => LETTER_UPPERCASE,
         when 16#000384# .. 16#000385# => SYMBOL_MODIFIER,
         when 16#000386#               => LETTER_UPPERCASE,
         when 16#000387#               => PUNCTUATION_OTHER,
         when 16#000388# .. 16#00038A# => LETTER_UPPERCASE,
         when 16#00038C#               => LETTER_UPPERCASE,
         when 16#00038E# .. 16#00038F# => LETTER_UPPERCASE,
         when 16#000390#               => LETTER_LOWERCASE,
         when 16#000391# .. 16#0003A1# => LETTER_UPPERCASE,
         when 16#0003A3# .. 16#0003AB# => LETTER_UPPERCASE,
         when 16#0003AC# .. 16#0003CE# => LETTER_LOWERCASE,
         when 16#0003CF#               => LETTER_UPPERCASE,
         when 16#0003D0# .. 16#0003D1# => LETTER_LOWERCASE,
         when 16#0003D2# .. 16#0003D4# => LETTER_UPPERCASE,
         when 16#0003D5# .. 16#0003D7# => LETTER_LOWERCASE,
         when 16#0003D8#               => LETTER_UPPERCASE,
         when 16#0003D9#               => LETTER_LOWERCASE,
         when 16#0003DA#               => LETTER_UPPERCASE,
         when 16#0003DB#               => LETTER_LOWERCASE,
         when 16#0003DC#               => LETTER_UPPERCASE,
         when 16#0003DD#               => LETTER_LOWERCASE,
         when 16#0003DE#               => LETTER_UPPERCASE,
         when 16#0003DF#               => LETTER_LOWERCASE,
         when 16#0003E0#               => LETTER_UPPERCASE,
         when 16#0003E1#               => LETTER_LOWERCASE,
         when 16#0003E2#               => LETTER_UPPERCASE,
         when 16#0003E3#               => LETTER_LOWERCASE,
         when 16#0003E4#               => LETTER_UPPERCASE,
         when 16#0003E5#               => LETTER_LOWERCASE,
         when 16#0003E6#               => LETTER_UPPERCASE,
         when 16#0003E7#               => LETTER_LOWERCASE,
         when 16#0003E8#               => LETTER_UPPERCASE,
         when 16#0003E9#               => LETTER_LOWERCASE,
         when 16#0003EA#               => LETTER_UPPERCASE,
         when 16#0003EB#               => LETTER_LOWERCASE,
         when 16#0003EC#               => LETTER_UPPERCASE,
         when 16#0003ED#               => LETTER_LOWERCASE,
         when 16#0003EE#               => LETTER_UPPERCASE,
         when 16#0003EF# .. 16#0003F3# => LETTER_LOWERCASE,
         when 16#0003F4#               => LETTER_UPPERCASE,
         when 16#0003F5#               => LETTER_LOWERCASE,
         when 16#0003F6#               => SYMBOL_MATH,
         when 16#0003F7#               => LETTER_UPPERCASE,
         when 16#0003F8#               => LETTER_LOWERCASE,
         when 16#0003F9# .. 16#0003FA# => LETTER_UPPERCASE,
         when 16#0003FB# .. 16#0003FC# => LETTER_LOWERCASE,
         when 16#0003FD# .. 16#00042F# => LETTER_UPPERCASE,
         when 16#000430# .. 16#00045F# => LETTER_LOWERCASE,
         when 16#000460#               => LETTER_UPPERCASE,
         when 16#000461#               => LETTER_LOWERCASE,
         when 16#000462#               => LETTER_UPPERCASE,
         when 16#000463#               => LETTER_LOWERCASE,
         when 16#000464#               => LETTER_UPPERCASE,
         when 16#000465#               => LETTER_LOWERCASE,
         when 16#000466#               => LETTER_UPPERCASE,
         when 16#000467#               => LETTER_LOWERCASE,
         when 16#000468#               => LETTER_UPPERCASE,
         when 16#000469#               => LETTER_LOWERCASE,
         when 16#00046A#               => LETTER_UPPERCASE,
         when 16#00046B#               => LETTER_LOWERCASE,
         when 16#00046C#               => LETTER_UPPERCASE,
         when 16#00046D#               => LETTER_LOWERCASE,
         when 16#00046E#               => LETTER_UPPERCASE,
         when 16#00046F#               => LETTER_LOWERCASE,
         when 16#000470#               => LETTER_UPPERCASE,
         when 16#000471#               => LETTER_LOWERCASE,
         when 16#000472#               => LETTER_UPPERCASE,
         when 16#000473#               => LETTER_LOWERCASE,
         when 16#000474#               => LETTER_UPPERCASE,
         when 16#000475#               => LETTER_LOWERCASE,
         when 16#000476#               => LETTER_UPPERCASE,
         when 16#000477#               => LETTER_LOWERCASE,
         when 16#000478#               => LETTER_UPPERCASE,
         when 16#000479#               => LETTER_LOWERCASE,
         when 16#00047A#               => LETTER_UPPERCASE,
         when 16#00047B#               => LETTER_LOWERCASE,
         when 16#00047C#               => LETTER_UPPERCASE,
         when 16#00047D#               => LETTER_LOWERCASE,
         when 16#00047E#               => LETTER_UPPERCASE,
         when 16#00047F#               => LETTER_LOWERCASE,
         when 16#000480#               => LETTER_UPPERCASE,
         when 16#000481#               => LETTER_LOWERCASE,
         when 16#000482#               => SYMBOL_OTHER,
         when 16#000483# .. 16#000487# => MARK_NONSPACING,
         when 16#000488# .. 16#000489# => MARK_ENCLOSING,
         when 16#00048A#               => LETTER_UPPERCASE,
         when 16#00048B#               => LETTER_LOWERCASE,
         when 16#00048C#               => LETTER_UPPERCASE,
         when 16#00048D#               => LETTER_LOWERCASE,
         when 16#00048E#               => LETTER_UPPERCASE,
         when 16#00048F#               => LETTER_LOWERCASE,
         when 16#000490#               => LETTER_UPPERCASE,
         when 16#000491#               => LETTER_LOWERCASE,
         when 16#000492#               => LETTER_UPPERCASE,
         when 16#000493#               => LETTER_LOWERCASE,
         when 16#000494#               => LETTER_UPPERCASE,
         when 16#000495#               => LETTER_LOWERCASE,
         when 16#000496#               => LETTER_UPPERCASE,
         when 16#000497#               => LETTER_LOWERCASE,
         when 16#000498#               => LETTER_UPPERCASE,
         when 16#000499#               => LETTER_LOWERCASE,
         when 16#00049A#               => LETTER_UPPERCASE,
         when 16#00049B#               => LETTER_LOWERCASE,
         when 16#00049C#               => LETTER_UPPERCASE,
         when 16#00049D#               => LETTER_LOWERCASE,
         when 16#00049E#               => LETTER_UPPERCASE,
         when 16#00049F#               => LETTER_LOWERCASE,
         when 16#0004A0#               => LETTER_UPPERCASE,
         when 16#0004A1#               => LETTER_LOWERCASE,
         when 16#0004A2#               => LETTER_UPPERCASE,
         when 16#0004A3#               => LETTER_LOWERCASE,
         when 16#0004A4#               => LETTER_UPPERCASE,
         when 16#0004A5#               => LETTER_LOWERCASE,
         when 16#0004A6#               => LETTER_UPPERCASE,
         when 16#0004A7#               => LETTER_LOWERCASE,
         when 16#0004A8#               => LETTER_UPPERCASE,
         when 16#0004A9#               => LETTER_LOWERCASE,
         when 16#0004AA#               => LETTER_UPPERCASE,
         when 16#0004AB#               => LETTER_LOWERCASE,
         when 16#0004AC#               => LETTER_UPPERCASE,
         when 16#0004AD#               => LETTER_LOWERCASE,
         when 16#0004AE#               => LETTER_UPPERCASE,
         when 16#0004AF#               => LETTER_LOWERCASE,
         when 16#0004B0#               => LETTER_UPPERCASE,
         when 16#0004B1#               => LETTER_LOWERCASE,
         when 16#0004B2#               => LETTER_UPPERCASE,
         when 16#0004B3#               => LETTER_LOWERCASE,
         when 16#0004B4#               => LETTER_UPPERCASE,
         when 16#0004B5#               => LETTER_LOWERCASE,
         when 16#0004B6#               => LETTER_UPPERCASE,
         when 16#0004B7#               => LETTER_LOWERCASE,
         when 16#0004B8#               => LETTER_UPPERCASE,
         when 16#0004B9#               => LETTER_LOWERCASE,
         when 16#0004BA#               => LETTER_UPPERCASE,
         when 16#0004BB#               => LETTER_LOWERCASE,
         when 16#0004BC#               => LETTER_UPPERCASE,
         when 16#0004BD#               => LETTER_LOWERCASE,
         when 16#0004BE#               => LETTER_UPPERCASE,
         when 16#0004BF#               => LETTER_LOWERCASE,
         when 16#0004C0# .. 16#0004C1# => LETTER_UPPERCASE,
         when 16#0004C2#               => LETTER_LOWERCASE,
         when 16#0004C3#               => LETTER_UPPERCASE,
         when 16#0004C4#               => LETTER_LOWERCASE,
         when 16#0004C5#               => LETTER_UPPERCASE,
         when 16#0004C6#               => LETTER_LOWERCASE,
         when 16#0004C7#               => LETTER_UPPERCASE,
         when 16#0004C8#               => LETTER_LOWERCASE,
         when 16#0004C9#               => LETTER_UPPERCASE,
         when 16#0004CA#               => LETTER_LOWERCASE,
         when 16#0004CB#               => LETTER_UPPERCASE,
         when 16#0004CC#               => LETTER_LOWERCASE,
         when 16#0004CD#               => LETTER_UPPERCASE,
         when 16#0004CE# .. 16#0004CF# => LETTER_LOWERCASE,
         when 16#0004D0#               => LETTER_UPPERCASE,
         when 16#0004D1#               => LETTER_LOWERCASE,
         when 16#0004D2#               => LETTER_UPPERCASE,
         when 16#0004D3#               => LETTER_LOWERCASE,
         when 16#0004D4#               => LETTER_UPPERCASE,
         when 16#0004D5#               => LETTER_LOWERCASE,
         when 16#0004D6#               => LETTER_UPPERCASE,
         when 16#0004D7#               => LETTER_LOWERCASE,
         when 16#0004D8#               => LETTER_UPPERCASE,
         when 16#0004D9#               => LETTER_LOWERCASE,
         when 16#0004DA#               => LETTER_UPPERCASE,
         when 16#0004DB#               => LETTER_LOWERCASE,
         when 16#0004DC#               => LETTER_UPPERCASE,
         when 16#0004DD#               => LETTER_LOWERCASE,
         when 16#0004DE#               => LETTER_UPPERCASE,
         when 16#0004DF#               => LETTER_LOWERCASE,
         when 16#0004E0#               => LETTER_UPPERCASE,
         when 16#0004E1#               => LETTER_LOWERCASE,
         when 16#0004E2#               => LETTER_UPPERCASE,
         when 16#0004E3#               => LETTER_LOWERCASE,
         when 16#0004E4#               => LETTER_UPPERCASE,
         when 16#0004E5#               => LETTER_LOWERCASE,
         when 16#0004E6#               => LETTER_UPPERCASE,
         when 16#0004E7#               => LETTER_LOWERCASE,
         when 16#0004E8#               => LETTER_UPPERCASE,
         when 16#0004E9#               => LETTER_LOWERCASE,
         when 16#0004EA#               => LETTER_UPPERCASE,
         when 16#0004EB#               => LETTER_LOWERCASE,
         when 16#0004EC#               => LETTER_UPPERCASE,
         when 16#0004ED#               => LETTER_LOWERCASE,
         when 16#0004EE#               => LETTER_UPPERCASE,
         when 16#0004EF#               => LETTER_LOWERCASE,
         when 16#0004F0#               => LETTER_UPPERCASE,
         when 16#0004F1#               => LETTER_LOWERCASE,
         when 16#0004F2#               => LETTER_UPPERCASE,
         when 16#0004F3#               => LETTER_LOWERCASE,
         when 16#0004F4#               => LETTER_UPPERCASE,
         when 16#0004F5#               => LETTER_LOWERCASE,
         when 16#0004F6#               => LETTER_UPPERCASE,
         when 16#0004F7#               => LETTER_LOWERCASE,
         when 16#0004F8#               => LETTER_UPPERCASE,
         when 16#0004F9#               => LETTER_LOWERCASE,
         when 16#0004FA#               => LETTER_UPPERCASE,
         when 16#0004FB#               => LETTER_LOWERCASE,
         when 16#0004FC#               => LETTER_UPPERCASE,
         when 16#0004FD#               => LETTER_LOWERCASE,
         when 16#0004FE#               => LETTER_UPPERCASE,
         when 16#0004FF#               => LETTER_LOWERCASE,
         when 16#000500#               => LETTER_UPPERCASE,
         when 16#000501#               => LETTER_LOWERCASE,
         when 16#000502#               => LETTER_UPPERCASE,
         when 16#000503#               => LETTER_LOWERCASE,
         when 16#000504#               => LETTER_UPPERCASE,
         when 16#000505#               => LETTER_LOWERCASE,
         when 16#000506#               => LETTER_UPPERCASE,
         when 16#000507#               => LETTER_LOWERCASE,
         when 16#000508#               => LETTER_UPPERCASE,
         when 16#000509#               => LETTER_LOWERCASE,
         when 16#00050A#               => LETTER_UPPERCASE,
         when 16#00050B#               => LETTER_LOWERCASE,
         when 16#00050C#               => LETTER_UPPERCASE,
         when 16#00050D#               => LETTER_LOWERCASE,
         when 16#00050E#               => LETTER_UPPERCASE,
         when 16#00050F#               => LETTER_LOWERCASE,
         when 16#000510#               => LETTER_UPPERCASE,
         when 16#000511#               => LETTER_LOWERCASE,
         when 16#000512#               => LETTER_UPPERCASE,
         when 16#000513#               => LETTER_LOWERCASE,
         when 16#000514#               => LETTER_UPPERCASE,
         when 16#000515#               => LETTER_LOWERCASE,
         when 16#000516#               => LETTER_UPPERCASE,
         when 16#000517#               => LETTER_LOWERCASE,
         when 16#000518#               => LETTER_UPPERCASE,
         when 16#000519#               => LETTER_LOWERCASE,
         when 16#00051A#               => LETTER_UPPERCASE,
         when 16#00051B#               => LETTER_LOWERCASE,
         when 16#00051C#               => LETTER_UPPERCASE,
         when 16#00051D#               => LETTER_LOWERCASE,
         when 16#00051E#               => LETTER_UPPERCASE,
         when 16#00051F#               => LETTER_LOWERCASE,
         when 16#000520#               => LETTER_UPPERCASE,
         when 16#000521#               => LETTER_LOWERCASE,
         when 16#000522#               => LETTER_UPPERCASE,
         when 16#000523#               => LETTER_LOWERCASE,
         when 16#000524#               => LETTER_UPPERCASE,
         when 16#000525#               => LETTER_LOWERCASE,
         when 16#000526#               => LETTER_UPPERCASE,
         when 16#000527#               => LETTER_LOWERCASE,
         when 16#000528#               => LETTER_UPPERCASE,
         when 16#000529#               => LETTER_LOWERCASE,
         when 16#00052A#               => LETTER_UPPERCASE,
         when 16#00052B#               => LETTER_LOWERCASE,
         when 16#00052C#               => LETTER_UPPERCASE,
         when 16#00052D#               => LETTER_LOWERCASE,
         when 16#00052E#               => LETTER_UPPERCASE,
         when 16#00052F#               => LETTER_LOWERCASE,
         when 16#000531# .. 16#000556# => LETTER_UPPERCASE,
         when 16#000559#               => LETTER_MODIFIER,
         when 16#00055A# .. 16#00055F# => PUNCTUATION_OTHER,
         when 16#000560# .. 16#000588# => LETTER_LOWERCASE,
         when 16#000589#               => PUNCTUATION_OTHER,
         when 16#00058A#               => PUNCTUATION_DASH,
         when 16#00058D# .. 16#00058E# => SYMBOL_OTHER,
         when 16#00058F#               => SYMBOL_CURRENCY,
         when 16#000591# .. 16#0005BD# => MARK_NONSPACING,
         when 16#0005BE#               => PUNCTUATION_DASH,
         when 16#0005BF#               => MARK_NONSPACING,
         when 16#0005C0#               => PUNCTUATION_OTHER,
         when 16#0005C1# .. 16#0005C2# => MARK_NONSPACING,
         when 16#0005C3#               => PUNCTUATION_OTHER,
         when 16#0005C4# .. 16#0005C5# => MARK_NONSPACING,
         when 16#0005C6#               => PUNCTUATION_OTHER,
         when 16#0005C7#               => MARK_NONSPACING,
         when 16#0005D0# .. 16#0005EA# => LETTER_OTHER,
         when 16#0005EF# .. 16#0005F2# => LETTER_OTHER,
         when 16#0005F3# .. 16#0005F4# => PUNCTUATION_OTHER,
         when 16#000600# .. 16#000605# => OTHER_FORMAT,
         when 16#000606# .. 16#000608# => SYMBOL_MATH,
         when 16#000609# .. 16#00060A# => PUNCTUATION_OTHER,
         when 16#00060B#               => SYMBOL_CURRENCY,
         when 16#00060C# .. 16#00060D# => PUNCTUATION_OTHER,
         when 16#00060E# .. 16#00060F# => SYMBOL_OTHER,
         when 16#000610# .. 16#00061A# => MARK_NONSPACING,
         when 16#00061B#               => PUNCTUATION_OTHER,
         when 16#00061C#               => OTHER_FORMAT,
         when 16#00061E# .. 16#00061F# => PUNCTUATION_OTHER,
         when 16#000620# .. 16#00063F# => LETTER_OTHER,
         when 16#000640#               => LETTER_MODIFIER,
         when 16#000641# .. 16#00064A# => LETTER_OTHER,
         when 16#00064B# .. 16#00065F# => MARK_NONSPACING,
         when 16#000660# .. 16#000669# => NUMBER_DECIMAL_DIGIT,
         when 16#00066A# .. 16#00066D# => PUNCTUATION_OTHER,
         when 16#00066E# .. 16#00066F# => LETTER_OTHER,
         when 16#000670#               => MARK_NONSPACING,
         when 16#000671# .. 16#0006D3# => LETTER_OTHER,
         when 16#0006D4#               => PUNCTUATION_OTHER,
         when 16#0006D5#               => LETTER_OTHER,
         when 16#0006D6# .. 16#0006DC# => MARK_NONSPACING,
         when 16#0006DD#               => OTHER_FORMAT,
         when 16#0006DE#               => SYMBOL_OTHER,
         when 16#0006DF# .. 16#0006E4# => MARK_NONSPACING,
         when 16#0006E5# .. 16#0006E6# => LETTER_MODIFIER,
         when 16#0006E7# .. 16#0006E8# => MARK_NONSPACING,
         when 16#0006E9#               => SYMBOL_OTHER,
         when 16#0006EA# .. 16#0006ED# => MARK_NONSPACING,
         when 16#0006EE# .. 16#0006EF# => LETTER_OTHER,
         when 16#0006F0# .. 16#0006F9# => NUMBER_DECIMAL_DIGIT,
         when 16#0006FA# .. 16#0006FC# => LETTER_OTHER,
         when 16#0006FD# .. 16#0006FE# => SYMBOL_OTHER,
         when 16#0006FF#               => LETTER_OTHER,
         when 16#000700# .. 16#00070D# => PUNCTUATION_OTHER,
         when 16#00070F#               => OTHER_FORMAT,
         when 16#000710#               => LETTER_OTHER,
         when 16#000711#               => MARK_NONSPACING,
         when 16#000712# .. 16#00072F# => LETTER_OTHER,
         when 16#000730# .. 16#00074A# => MARK_NONSPACING,
         when 16#00074D# .. 16#0007A5# => LETTER_OTHER,
         when 16#0007A6# .. 16#0007B0# => MARK_NONSPACING,
         when 16#0007B1#               => LETTER_OTHER,
         when 16#0007C0# .. 16#0007C9# => NUMBER_DECIMAL_DIGIT,
         when 16#0007CA# .. 16#0007EA# => LETTER_OTHER,
         when 16#0007EB# .. 16#0007F3# => MARK_NONSPACING,
         when 16#0007F4# .. 16#0007F5# => LETTER_MODIFIER,
         when 16#0007F6#               => SYMBOL_OTHER,
         when 16#0007F7# .. 16#0007F9# => PUNCTUATION_OTHER,
         when 16#0007FA#               => LETTER_MODIFIER,
         when 16#0007FD#               => MARK_NONSPACING,
         when 16#0007FE# .. 16#0007FF# => SYMBOL_CURRENCY,
         when 16#000800# .. 16#000815# => LETTER_OTHER,
         when 16#000816# .. 16#000819# => MARK_NONSPACING,
         when 16#00081A#               => LETTER_MODIFIER,
         when 16#00081B# .. 16#000823# => MARK_NONSPACING,
         when 16#000824#               => LETTER_MODIFIER,
         when 16#000825# .. 16#000827# => MARK_NONSPACING,
         when 16#000828#               => LETTER_MODIFIER,
         when 16#000829# .. 16#00082D# => MARK_NONSPACING,
         when 16#000830# .. 16#00083E# => PUNCTUATION_OTHER,
         when 16#000840# .. 16#000858# => LETTER_OTHER,
         when 16#000859# .. 16#00085B# => MARK_NONSPACING,
         when 16#00085E#               => PUNCTUATION_OTHER,
         when 16#000860# .. 16#00086A# => LETTER_OTHER,
         when 16#0008A0# .. 16#0008B4# => LETTER_OTHER,
         when 16#0008B6# .. 16#0008BD# => LETTER_OTHER,
         when 16#0008D3# .. 16#0008E1# => MARK_NONSPACING,
         when 16#0008E2#               => OTHER_FORMAT,
         when 16#0008E3# .. 16#000902# => MARK_NONSPACING,
         when 16#000903#               => MARK_SPACING_COMBINING,
         when 16#000904# .. 16#000939# => LETTER_OTHER,
         when 16#00093A#               => MARK_NONSPACING,
         when 16#00093B#               => MARK_SPACING_COMBINING,
         when 16#00093C#               => MARK_NONSPACING,
         when 16#00093D#               => LETTER_OTHER,
         when 16#00093E# .. 16#000940# => MARK_SPACING_COMBINING,
         when 16#000941# .. 16#000948# => MARK_NONSPACING,
         when 16#000949# .. 16#00094C# => MARK_SPACING_COMBINING,
         when 16#00094D#               => MARK_NONSPACING,
         when 16#00094E# .. 16#00094F# => MARK_SPACING_COMBINING,
         when 16#000950#               => LETTER_OTHER,
         when 16#000951# .. 16#000957# => MARK_NONSPACING,
         when 16#000958# .. 16#000961# => LETTER_OTHER,
         when 16#000962# .. 16#000963# => MARK_NONSPACING,
         when 16#000964# .. 16#000965# => PUNCTUATION_OTHER,
         when 16#000966# .. 16#00096F# => NUMBER_DECIMAL_DIGIT,
         when 16#000970#               => PUNCTUATION_OTHER,
         when 16#000971#               => LETTER_MODIFIER,
         when 16#000972# .. 16#000980# => LETTER_OTHER,
         when 16#000981#               => MARK_NONSPACING,
         when 16#000982# .. 16#000983# => MARK_SPACING_COMBINING,
         when 16#000985# .. 16#00098C# => LETTER_OTHER,
         when 16#00098F# .. 16#000990# => LETTER_OTHER,
         when 16#000993# .. 16#0009A8# => LETTER_OTHER,
         when 16#0009AA# .. 16#0009B0# => LETTER_OTHER,
         when 16#0009B2#               => LETTER_OTHER,
         when 16#0009B6# .. 16#0009B9# => LETTER_OTHER,
         when 16#0009BC#               => MARK_NONSPACING,
         when 16#0009BD#               => LETTER_OTHER,
         when 16#0009BE# .. 16#0009C0# => MARK_SPACING_COMBINING,
         when 16#0009C1# .. 16#0009C4# => MARK_NONSPACING,
         when 16#0009C7# .. 16#0009C8# => MARK_SPACING_COMBINING,
         when 16#0009CB# .. 16#0009CC# => MARK_SPACING_COMBINING,
         when 16#0009CD#               => MARK_NONSPACING,
         when 16#0009CE#               => LETTER_OTHER,
         when 16#0009D7#               => MARK_SPACING_COMBINING,
         when 16#0009DC# .. 16#0009DD# => LETTER_OTHER,
         when 16#0009DF# .. 16#0009E1# => LETTER_OTHER,
         when 16#0009E2# .. 16#0009E3# => MARK_NONSPACING,
         when 16#0009E6# .. 16#0009EF# => NUMBER_DECIMAL_DIGIT,
         when 16#0009F0# .. 16#0009F1# => LETTER_OTHER,
         when 16#0009F2# .. 16#0009F3# => SYMBOL_CURRENCY,
         when 16#0009F4# .. 16#0009F9# => NUMBER_OTHER,
         when 16#0009FA#               => SYMBOL_OTHER,
         when 16#0009FB#               => SYMBOL_CURRENCY,
         when 16#0009FC#               => LETTER_OTHER,
         when 16#0009FD#               => PUNCTUATION_OTHER,
         when 16#0009FE#               => MARK_NONSPACING,
         when 16#000A01# .. 16#000A02# => MARK_NONSPACING,
         when 16#000A03#               => MARK_SPACING_COMBINING,
         when 16#000A05# .. 16#000A0A# => LETTER_OTHER,
         when 16#000A0F# .. 16#000A10# => LETTER_OTHER,
         when 16#000A13# .. 16#000A28# => LETTER_OTHER,
         when 16#000A2A# .. 16#000A30# => LETTER_OTHER,
         when 16#000A32# .. 16#000A33# => LETTER_OTHER,
         when 16#000A35# .. 16#000A36# => LETTER_OTHER,
         when 16#000A38# .. 16#000A39# => LETTER_OTHER,
         when 16#000A3C#               => MARK_NONSPACING,
         when 16#000A3E# .. 16#000A40# => MARK_SPACING_COMBINING,
         when 16#000A41# .. 16#000A42# => MARK_NONSPACING,
         when 16#000A47# .. 16#000A48# => MARK_NONSPACING,
         when 16#000A4B# .. 16#000A4D# => MARK_NONSPACING,
         when 16#000A51#               => MARK_NONSPACING,
         when 16#000A59# .. 16#000A5C# => LETTER_OTHER,
         when 16#000A5E#               => LETTER_OTHER,
         when 16#000A66# .. 16#000A6F# => NUMBER_DECIMAL_DIGIT,
         when 16#000A70# .. 16#000A71# => MARK_NONSPACING,
         when 16#000A72# .. 16#000A74# => LETTER_OTHER,
         when 16#000A75#               => MARK_NONSPACING,
         when 16#000A76#               => PUNCTUATION_OTHER,
         when 16#000A81# .. 16#000A82# => MARK_NONSPACING,
         when 16#000A83#               => MARK_SPACING_COMBINING,
         when 16#000A85# .. 16#000A8D# => LETTER_OTHER,
         when 16#000A8F# .. 16#000A91# => LETTER_OTHER,
         when 16#000A93# .. 16#000AA8# => LETTER_OTHER,
         when 16#000AAA# .. 16#000AB0# => LETTER_OTHER,
         when 16#000AB2# .. 16#000AB3# => LETTER_OTHER,
         when 16#000AB5# .. 16#000AB9# => LETTER_OTHER,
         when 16#000ABC#               => MARK_NONSPACING,
         when 16#000ABD#               => LETTER_OTHER,
         when 16#000ABE# .. 16#000AC0# => MARK_SPACING_COMBINING,
         when 16#000AC1# .. 16#000AC5# => MARK_NONSPACING,
         when 16#000AC7# .. 16#000AC8# => MARK_NONSPACING,
         when 16#000AC9#               => MARK_SPACING_COMBINING,
         when 16#000ACB# .. 16#000ACC# => MARK_SPACING_COMBINING,
         when 16#000ACD#               => MARK_NONSPACING,
         when 16#000AD0#               => LETTER_OTHER,
         when 16#000AE0# .. 16#000AE1# => LETTER_OTHER,
         when 16#000AE2# .. 16#000AE3# => MARK_NONSPACING,
         when 16#000AE6# .. 16#000AEF# => NUMBER_DECIMAL_DIGIT,
         when 16#000AF0#               => PUNCTUATION_OTHER,
         when 16#000AF1#               => SYMBOL_CURRENCY,
         when 16#000AF9#               => LETTER_OTHER,
         when 16#000AFA# .. 16#000AFF# => MARK_NONSPACING,
         when 16#000B01#               => MARK_NONSPACING,
         when 16#000B02# .. 16#000B03# => MARK_SPACING_COMBINING,
         when 16#000B05# .. 16#000B0C# => LETTER_OTHER,
         when 16#000B0F# .. 16#000B10# => LETTER_OTHER,
         when 16#000B13# .. 16#000B28# => LETTER_OTHER,
         when 16#000B2A# .. 16#000B30# => LETTER_OTHER,
         when 16#000B32# .. 16#000B33# => LETTER_OTHER,
         when 16#000B35# .. 16#000B39# => LETTER_OTHER,
         when 16#000B3C#               => MARK_NONSPACING,
         when 16#000B3D#               => LETTER_OTHER,
         when 16#000B3E#               => MARK_SPACING_COMBINING,
         when 16#000B3F#               => MARK_NONSPACING,
         when 16#000B40#               => MARK_SPACING_COMBINING,
         when 16#000B41# .. 16#000B44# => MARK_NONSPACING,
         when 16#000B47# .. 16#000B48# => MARK_SPACING_COMBINING,
         when 16#000B4B# .. 16#000B4C# => MARK_SPACING_COMBINING,
         when 16#000B4D#               => MARK_NONSPACING,
         when 16#000B56#               => MARK_NONSPACING,
         when 16#000B57#               => MARK_SPACING_COMBINING,
         when 16#000B5C# .. 16#000B5D# => LETTER_OTHER,
         when 16#000B5F# .. 16#000B61# => LETTER_OTHER,
         when 16#000B62# .. 16#000B63# => MARK_NONSPACING,
         when 16#000B66# .. 16#000B6F# => NUMBER_DECIMAL_DIGIT,
         when 16#000B70#               => SYMBOL_OTHER,
         when 16#000B71#               => LETTER_OTHER,
         when 16#000B72# .. 16#000B77# => NUMBER_OTHER,
         when 16#000B82#               => MARK_NONSPACING,
         when 16#000B83#               => LETTER_OTHER,
         when 16#000B85# .. 16#000B8A# => LETTER_OTHER,
         when 16#000B8E# .. 16#000B90# => LETTER_OTHER,
         when 16#000B92# .. 16#000B95# => LETTER_OTHER,
         when 16#000B99# .. 16#000B9A# => LETTER_OTHER,
         when 16#000B9C#               => LETTER_OTHER,
         when 16#000B9E# .. 16#000B9F# => LETTER_OTHER,
         when 16#000BA3# .. 16#000BA4# => LETTER_OTHER,
         when 16#000BA8# .. 16#000BAA# => LETTER_OTHER,
         when 16#000BAE# .. 16#000BB9# => LETTER_OTHER,
         when 16#000BBE# .. 16#000BBF# => MARK_SPACING_COMBINING,
         when 16#000BC0#               => MARK_NONSPACING,
         when 16#000BC1# .. 16#000BC2# => MARK_SPACING_COMBINING,
         when 16#000BC6# .. 16#000BC8# => MARK_SPACING_COMBINING,
         when 16#000BCA# .. 16#000BCC# => MARK_SPACING_COMBINING,
         when 16#000BCD#               => MARK_NONSPACING,
         when 16#000BD0#               => LETTER_OTHER,
         when 16#000BD7#               => MARK_SPACING_COMBINING,
         when 16#000BE6# .. 16#000BEF# => NUMBER_DECIMAL_DIGIT,
         when 16#000BF0# .. 16#000BF2# => NUMBER_OTHER,
         when 16#000BF3# .. 16#000BF8# => SYMBOL_OTHER,
         when 16#000BF9#               => SYMBOL_CURRENCY,
         when 16#000BFA#               => SYMBOL_OTHER,
         when 16#000C00#               => MARK_NONSPACING,
         when 16#000C01# .. 16#000C03# => MARK_SPACING_COMBINING,
         when 16#000C04#               => MARK_NONSPACING,
         when 16#000C05# .. 16#000C0C# => LETTER_OTHER,
         when 16#000C0E# .. 16#000C10# => LETTER_OTHER,
         when 16#000C12# .. 16#000C28# => LETTER_OTHER,
         when 16#000C2A# .. 16#000C39# => LETTER_OTHER,
         when 16#000C3D#               => LETTER_OTHER,
         when 16#000C3E# .. 16#000C40# => MARK_NONSPACING,
         when 16#000C41# .. 16#000C44# => MARK_SPACING_COMBINING,
         when 16#000C46# .. 16#000C48# => MARK_NONSPACING,
         when 16#000C4A# .. 16#000C4D# => MARK_NONSPACING,
         when 16#000C55# .. 16#000C56# => MARK_NONSPACING,
         when 16#000C58# .. 16#000C5A# => LETTER_OTHER,
         when 16#000C60# .. 16#000C61# => LETTER_OTHER,
         when 16#000C62# .. 16#000C63# => MARK_NONSPACING,
         when 16#000C66# .. 16#000C6F# => NUMBER_DECIMAL_DIGIT,
         when 16#000C77#               => PUNCTUATION_OTHER,
         when 16#000C78# .. 16#000C7E# => NUMBER_OTHER,
         when 16#000C7F#               => SYMBOL_OTHER,
         when 16#000C80#               => LETTER_OTHER,
         when 16#000C81#               => MARK_NONSPACING,
         when 16#000C82# .. 16#000C83# => MARK_SPACING_COMBINING,
         when 16#000C84#               => PUNCTUATION_OTHER,
         when 16#000C85# .. 16#000C8C# => LETTER_OTHER,
         when 16#000C8E# .. 16#000C90# => LETTER_OTHER,
         when 16#000C92# .. 16#000CA8# => LETTER_OTHER,
         when 16#000CAA# .. 16#000CB3# => LETTER_OTHER,
         when 16#000CB5# .. 16#000CB9# => LETTER_OTHER,
         when 16#000CBC#               => MARK_NONSPACING,
         when 16#000CBD#               => LETTER_OTHER,
         when 16#000CBE#               => MARK_SPACING_COMBINING,
         when 16#000CBF#               => MARK_NONSPACING,
         when 16#000CC0# .. 16#000CC4# => MARK_SPACING_COMBINING,
         when 16#000CC6#               => MARK_NONSPACING,
         when 16#000CC7# .. 16#000CC8# => MARK_SPACING_COMBINING,
         when 16#000CCA# .. 16#000CCB# => MARK_SPACING_COMBINING,
         when 16#000CCC# .. 16#000CCD# => MARK_NONSPACING,
         when 16#000CD5# .. 16#000CD6# => MARK_SPACING_COMBINING,
         when 16#000CDE#               => LETTER_OTHER,
         when 16#000CE0# .. 16#000CE1# => LETTER_OTHER,
         when 16#000CE2# .. 16#000CE3# => MARK_NONSPACING,
         when 16#000CE6# .. 16#000CEF# => NUMBER_DECIMAL_DIGIT,
         when 16#000CF1# .. 16#000CF2# => LETTER_OTHER,
         when 16#000D00# .. 16#000D01# => MARK_NONSPACING,
         when 16#000D02# .. 16#000D03# => MARK_SPACING_COMBINING,
         when 16#000D05# .. 16#000D0C# => LETTER_OTHER,
         when 16#000D0E# .. 16#000D10# => LETTER_OTHER,
         when 16#000D12# .. 16#000D3A# => LETTER_OTHER,
         when 16#000D3B# .. 16#000D3C# => MARK_NONSPACING,
         when 16#000D3D#               => LETTER_OTHER,
         when 16#000D3E# .. 16#000D40# => MARK_SPACING_COMBINING,
         when 16#000D41# .. 16#000D44# => MARK_NONSPACING,
         when 16#000D46# .. 16#000D48# => MARK_SPACING_COMBINING,
         when 16#000D4A# .. 16#000D4C# => MARK_SPACING_COMBINING,
         when 16#000D4D#               => MARK_NONSPACING,
         when 16#000D4E#               => LETTER_OTHER,
         when 16#000D4F#               => SYMBOL_OTHER,
         when 16#000D54# .. 16#000D56# => LETTER_OTHER,
         when 16#000D57#               => MARK_SPACING_COMBINING,
         when 16#000D58# .. 16#000D5E# => NUMBER_OTHER,
         when 16#000D5F# .. 16#000D61# => LETTER_OTHER,
         when 16#000D62# .. 16#000D63# => MARK_NONSPACING,
         when 16#000D66# .. 16#000D6F# => NUMBER_DECIMAL_DIGIT,
         when 16#000D70# .. 16#000D78# => NUMBER_OTHER,
         when 16#000D79#               => SYMBOL_OTHER,
         when 16#000D7A# .. 16#000D7F# => LETTER_OTHER,
         when 16#000D82# .. 16#000D83# => MARK_SPACING_COMBINING,
         when 16#000D85# .. 16#000D96# => LETTER_OTHER,
         when 16#000D9A# .. 16#000DB1# => LETTER_OTHER,
         when 16#000DB3# .. 16#000DBB# => LETTER_OTHER,
         when 16#000DBD#               => LETTER_OTHER,
         when 16#000DC0# .. 16#000DC6# => LETTER_OTHER,
         when 16#000DCA#               => MARK_NONSPACING,
         when 16#000DCF# .. 16#000DD1# => MARK_SPACING_COMBINING,
         when 16#000DD2# .. 16#000DD4# => MARK_NONSPACING,
         when 16#000DD6#               => MARK_NONSPACING,
         when 16#000DD8# .. 16#000DDF# => MARK_SPACING_COMBINING,
         when 16#000DE6# .. 16#000DEF# => NUMBER_DECIMAL_DIGIT,
         when 16#000DF2# .. 16#000DF3# => MARK_SPACING_COMBINING,
         when 16#000DF4#               => PUNCTUATION_OTHER,
         when 16#000E01# .. 16#000E30# => LETTER_OTHER,
         when 16#000E31#               => MARK_NONSPACING,
         when 16#000E32# .. 16#000E33# => LETTER_OTHER,
         when 16#000E34# .. 16#000E3A# => MARK_NONSPACING,
         when 16#000E3F#               => SYMBOL_CURRENCY,
         when 16#000E40# .. 16#000E45# => LETTER_OTHER,
         when 16#000E46#               => LETTER_MODIFIER,
         when 16#000E47# .. 16#000E4E# => MARK_NONSPACING,
         when 16#000E4F#               => PUNCTUATION_OTHER,
         when 16#000E50# .. 16#000E59# => NUMBER_DECIMAL_DIGIT,
         when 16#000E5A# .. 16#000E5B# => PUNCTUATION_OTHER,
         when 16#000E81# .. 16#000E82# => LETTER_OTHER,
         when 16#000E84#               => LETTER_OTHER,
         when 16#000E86# .. 16#000E8A# => LETTER_OTHER,
         when 16#000E8C# .. 16#000EA3# => LETTER_OTHER,
         when 16#000EA5#               => LETTER_OTHER,
         when 16#000EA7# .. 16#000EB0# => LETTER_OTHER,
         when 16#000EB1#               => MARK_NONSPACING,
         when 16#000EB2# .. 16#000EB3# => LETTER_OTHER,
         when 16#000EB4# .. 16#000EBC# => MARK_NONSPACING,
         when 16#000EBD#               => LETTER_OTHER,
         when 16#000EC0# .. 16#000EC4# => LETTER_OTHER,
         when 16#000EC6#               => LETTER_MODIFIER,
         when 16#000EC8# .. 16#000ECD# => MARK_NONSPACING,
         when 16#000ED0# .. 16#000ED9# => NUMBER_DECIMAL_DIGIT,
         when 16#000EDC# .. 16#000EDF# => LETTER_OTHER,
         when 16#000F00#               => LETTER_OTHER,
         when 16#000F01# .. 16#000F03# => SYMBOL_OTHER,
         when 16#000F04# .. 16#000F12# => PUNCTUATION_OTHER,
         when 16#000F13#               => SYMBOL_OTHER,
         when 16#000F14#               => PUNCTUATION_OTHER,
         when 16#000F15# .. 16#000F17# => SYMBOL_OTHER,
         when 16#000F18# .. 16#000F19# => MARK_NONSPACING,
         when 16#000F1A# .. 16#000F1F# => SYMBOL_OTHER,
         when 16#000F20# .. 16#000F29# => NUMBER_DECIMAL_DIGIT,
         when 16#000F2A# .. 16#000F33# => NUMBER_OTHER,
         when 16#000F34#               => SYMBOL_OTHER,
         when 16#000F35#               => MARK_NONSPACING,
         when 16#000F36#               => SYMBOL_OTHER,
         when 16#000F37#               => MARK_NONSPACING,
         when 16#000F38#               => SYMBOL_OTHER,
         when 16#000F39#               => MARK_NONSPACING,
         when 16#000F3A#               => PUNCTUATION_OPEN,
         when 16#000F3B#               => PUNCTUATION_CLOSE,
         when 16#000F3C#               => PUNCTUATION_OPEN,
         when 16#000F3D#               => PUNCTUATION_CLOSE,
         when 16#000F3E# .. 16#000F3F# => MARK_SPACING_COMBINING,
         when 16#000F40# .. 16#000F47# => LETTER_OTHER,
         when 16#000F49# .. 16#000F6C# => LETTER_OTHER,
         when 16#000F71# .. 16#000F7E# => MARK_NONSPACING,
         when 16#000F7F#               => MARK_SPACING_COMBINING,
         when 16#000F80# .. 16#000F84# => MARK_NONSPACING,
         when 16#000F85#               => PUNCTUATION_OTHER,
         when 16#000F86# .. 16#000F87# => MARK_NONSPACING,
         when 16#000F88# .. 16#000F8C# => LETTER_OTHER,
         when 16#000F8D# .. 16#000F97# => MARK_NONSPACING,
         when 16#000F99# .. 16#000FBC# => MARK_NONSPACING,
         when 16#000FBE# .. 16#000FC5# => SYMBOL_OTHER,
         when 16#000FC6#               => MARK_NONSPACING,
         when 16#000FC7# .. 16#000FCC# => SYMBOL_OTHER,
         when 16#000FCE# .. 16#000FCF# => SYMBOL_OTHER,
         when 16#000FD0# .. 16#000FD4# => PUNCTUATION_OTHER,
         when 16#000FD5# .. 16#000FD8# => SYMBOL_OTHER,
         when 16#000FD9# .. 16#000FDA# => PUNCTUATION_OTHER,
         when 16#001000# .. 16#00102A# => LETTER_OTHER,
         when 16#00102B# .. 16#00102C# => MARK_SPACING_COMBINING,
         when 16#00102D# .. 16#001030# => MARK_NONSPACING,
         when 16#001031#               => MARK_SPACING_COMBINING,
         when 16#001032# .. 16#001037# => MARK_NONSPACING,
         when 16#001038#               => MARK_SPACING_COMBINING,
         when 16#001039# .. 16#00103A# => MARK_NONSPACING,
         when 16#00103B# .. 16#00103C# => MARK_SPACING_COMBINING,
         when 16#00103D# .. 16#00103E# => MARK_NONSPACING,
         when 16#00103F#               => LETTER_OTHER,
         when 16#001040# .. 16#001049# => NUMBER_DECIMAL_DIGIT,
         when 16#00104A# .. 16#00104F# => PUNCTUATION_OTHER,
         when 16#001050# .. 16#001055# => LETTER_OTHER,
         when 16#001056# .. 16#001057# => MARK_SPACING_COMBINING,
         when 16#001058# .. 16#001059# => MARK_NONSPACING,
         when 16#00105A# .. 16#00105D# => LETTER_OTHER,
         when 16#00105E# .. 16#001060# => MARK_NONSPACING,
         when 16#001061#               => LETTER_OTHER,
         when 16#001062# .. 16#001064# => MARK_SPACING_COMBINING,
         when 16#001065# .. 16#001066# => LETTER_OTHER,
         when 16#001067# .. 16#00106D# => MARK_SPACING_COMBINING,
         when 16#00106E# .. 16#001070# => LETTER_OTHER,
         when 16#001071# .. 16#001074# => MARK_NONSPACING,
         when 16#001075# .. 16#001081# => LETTER_OTHER,
         when 16#001082#               => MARK_NONSPACING,
         when 16#001083# .. 16#001084# => MARK_SPACING_COMBINING,
         when 16#001085# .. 16#001086# => MARK_NONSPACING,
         when 16#001087# .. 16#00108C# => MARK_SPACING_COMBINING,
         when 16#00108D#               => MARK_NONSPACING,
         when 16#00108E#               => LETTER_OTHER,
         when 16#00108F#               => MARK_SPACING_COMBINING,
         when 16#001090# .. 16#001099# => NUMBER_DECIMAL_DIGIT,
         when 16#00109A# .. 16#00109C# => MARK_SPACING_COMBINING,
         when 16#00109D#               => MARK_NONSPACING,
         when 16#00109E# .. 16#00109F# => SYMBOL_OTHER,
         when 16#0010A0# .. 16#0010C5# => LETTER_UPPERCASE,
         when 16#0010C7#               => LETTER_UPPERCASE,
         when 16#0010CD#               => LETTER_UPPERCASE,
         when 16#0010D0# .. 16#0010FA# => LETTER_LOWERCASE,
         when 16#0010FB#               => PUNCTUATION_OTHER,
         when 16#0010FC#               => LETTER_MODIFIER,
         when 16#0010FD# .. 16#0010FF# => LETTER_LOWERCASE,
         when 16#001100# .. 16#001248# => LETTER_OTHER,
         when 16#00124A# .. 16#00124D# => LETTER_OTHER,
         when 16#001250# .. 16#001256# => LETTER_OTHER,
         when 16#001258#               => LETTER_OTHER,
         when 16#00125A# .. 16#00125D# => LETTER_OTHER,
         when 16#001260# .. 16#001288# => LETTER_OTHER,
         when 16#00128A# .. 16#00128D# => LETTER_OTHER,
         when 16#001290# .. 16#0012B0# => LETTER_OTHER,
         when 16#0012B2# .. 16#0012B5# => LETTER_OTHER,
         when 16#0012B8# .. 16#0012BE# => LETTER_OTHER,
         when 16#0012C0#               => LETTER_OTHER,
         when 16#0012C2# .. 16#0012C5# => LETTER_OTHER,
         when 16#0012C8# .. 16#0012D6# => LETTER_OTHER,
         when 16#0012D8# .. 16#001310# => LETTER_OTHER,
         when 16#001312# .. 16#001315# => LETTER_OTHER,
         when 16#001318# .. 16#00135A# => LETTER_OTHER,
         when 16#00135D# .. 16#00135F# => MARK_NONSPACING,
         when 16#001360# .. 16#001368# => PUNCTUATION_OTHER,
         when 16#001369# .. 16#00137C# => NUMBER_OTHER,
         when 16#001380# .. 16#00138F# => LETTER_OTHER,
         when 16#001390# .. 16#001399# => SYMBOL_OTHER,
         when 16#0013A0# .. 16#0013F5# => LETTER_UPPERCASE,
         when 16#0013F8# .. 16#0013FD# => LETTER_LOWERCASE,
         when 16#001400#               => PUNCTUATION_DASH,
         when 16#001401# .. 16#00166C# => LETTER_OTHER,
         when 16#00166D#               => SYMBOL_OTHER,
         when 16#00166E#               => PUNCTUATION_OTHER,
         when 16#00166F# .. 16#00167F# => LETTER_OTHER,
         when 16#001680#               => SEPARATOR_SPACE,
         when 16#001681# .. 16#00169A# => LETTER_OTHER,
         when 16#00169B#               => PUNCTUATION_OPEN,
         when 16#00169C#               => PUNCTUATION_CLOSE,
         when 16#0016A0# .. 16#0016EA# => LETTER_OTHER,
         when 16#0016EB# .. 16#0016ED# => PUNCTUATION_OTHER,
         when 16#0016EE# .. 16#0016F0# => NUMBER_LETTER,
         when 16#0016F1# .. 16#0016F8# => LETTER_OTHER,
         when 16#001700# .. 16#00170C# => LETTER_OTHER,
         when 16#00170E# .. 16#001711# => LETTER_OTHER,
         when 16#001712# .. 16#001714# => MARK_NONSPACING,
         when 16#001720# .. 16#001731# => LETTER_OTHER,
         when 16#001732# .. 16#001734# => MARK_NONSPACING,
         when 16#001735# .. 16#001736# => PUNCTUATION_OTHER,
         when 16#001740# .. 16#001751# => LETTER_OTHER,
         when 16#001752# .. 16#001753# => MARK_NONSPACING,
         when 16#001760# .. 16#00176C# => LETTER_OTHER,
         when 16#00176E# .. 16#001770# => LETTER_OTHER,
         when 16#001772# .. 16#001773# => MARK_NONSPACING,
         when 16#001780# .. 16#0017B3# => LETTER_OTHER,
         when 16#0017B4# .. 16#0017B5# => MARK_NONSPACING,
         when 16#0017B6#               => MARK_SPACING_COMBINING,
         when 16#0017B7# .. 16#0017BD# => MARK_NONSPACING,
         when 16#0017BE# .. 16#0017C5# => MARK_SPACING_COMBINING,
         when 16#0017C6#               => MARK_NONSPACING,
         when 16#0017C7# .. 16#0017C8# => MARK_SPACING_COMBINING,
         when 16#0017C9# .. 16#0017D3# => MARK_NONSPACING,
         when 16#0017D4# .. 16#0017D6# => PUNCTUATION_OTHER,
         when 16#0017D7#               => LETTER_MODIFIER,
         when 16#0017D8# .. 16#0017DA# => PUNCTUATION_OTHER,
         when 16#0017DB#               => SYMBOL_CURRENCY,
         when 16#0017DC#               => LETTER_OTHER,
         when 16#0017DD#               => MARK_NONSPACING,
         when 16#0017E0# .. 16#0017E9# => NUMBER_DECIMAL_DIGIT,
         when 16#0017F0# .. 16#0017F9# => NUMBER_OTHER,
         when 16#001800# .. 16#001805# => PUNCTUATION_OTHER,
         when 16#001806#               => PUNCTUATION_DASH,
         when 16#001807# .. 16#00180A# => PUNCTUATION_OTHER,
         when 16#00180B# .. 16#00180D# => MARK_NONSPACING,
         when 16#00180E#               => OTHER_FORMAT,
         when 16#001810# .. 16#001819# => NUMBER_DECIMAL_DIGIT,
         when 16#001820# .. 16#001842# => LETTER_OTHER,
         when 16#001843#               => LETTER_MODIFIER,
         when 16#001844# .. 16#001878# => LETTER_OTHER,
         when 16#001880# .. 16#001884# => LETTER_OTHER,
         when 16#001885# .. 16#001886# => MARK_NONSPACING,
         when 16#001887# .. 16#0018A8# => LETTER_OTHER,
         when 16#0018A9#               => MARK_NONSPACING,
         when 16#0018AA#               => LETTER_OTHER,
         when 16#0018B0# .. 16#0018F5# => LETTER_OTHER,
         when 16#001900# .. 16#00191E# => LETTER_OTHER,
         when 16#001920# .. 16#001922# => MARK_NONSPACING,
         when 16#001923# .. 16#001926# => MARK_SPACING_COMBINING,
         when 16#001927# .. 16#001928# => MARK_NONSPACING,
         when 16#001929# .. 16#00192B# => MARK_SPACING_COMBINING,
         when 16#001930# .. 16#001931# => MARK_SPACING_COMBINING,
         when 16#001932#               => MARK_NONSPACING,
         when 16#001933# .. 16#001938# => MARK_SPACING_COMBINING,
         when 16#001939# .. 16#00193B# => MARK_NONSPACING,
         when 16#001940#               => SYMBOL_OTHER,
         when 16#001944# .. 16#001945# => PUNCTUATION_OTHER,
         when 16#001946# .. 16#00194F# => NUMBER_DECIMAL_DIGIT,
         when 16#001950# .. 16#00196D# => LETTER_OTHER,
         when 16#001970# .. 16#001974# => LETTER_OTHER,
         when 16#001980# .. 16#0019AB# => LETTER_OTHER,
         when 16#0019B0# .. 16#0019C9# => LETTER_OTHER,
         when 16#0019D0# .. 16#0019D9# => NUMBER_DECIMAL_DIGIT,
         when 16#0019DA#               => NUMBER_OTHER,
         when 16#0019DE# .. 16#0019FF# => SYMBOL_OTHER,
         when 16#001A00# .. 16#001A16# => LETTER_OTHER,
         when 16#001A17# .. 16#001A18# => MARK_NONSPACING,
         when 16#001A19# .. 16#001A1A# => MARK_SPACING_COMBINING,
         when 16#001A1B#               => MARK_NONSPACING,
         when 16#001A1E# .. 16#001A1F# => PUNCTUATION_OTHER,
         when 16#001A20# .. 16#001A54# => LETTER_OTHER,
         when 16#001A55#               => MARK_SPACING_COMBINING,
         when 16#001A56#               => MARK_NONSPACING,
         when 16#001A57#               => MARK_SPACING_COMBINING,
         when 16#001A58# .. 16#001A5E# => MARK_NONSPACING,
         when 16#001A60#               => MARK_NONSPACING,
         when 16#001A61#               => MARK_SPACING_COMBINING,
         when 16#001A62#               => MARK_NONSPACING,
         when 16#001A63# .. 16#001A64# => MARK_SPACING_COMBINING,
         when 16#001A65# .. 16#001A6C# => MARK_NONSPACING,
         when 16#001A6D# .. 16#001A72# => MARK_SPACING_COMBINING,
         when 16#001A73# .. 16#001A7C# => MARK_NONSPACING,
         when 16#001A7F#               => MARK_NONSPACING,
         when 16#001A80# .. 16#001A89# => NUMBER_DECIMAL_DIGIT,
         when 16#001A90# .. 16#001A99# => NUMBER_DECIMAL_DIGIT,
         when 16#001AA0# .. 16#001AA6# => PUNCTUATION_OTHER,
         when 16#001AA7#               => LETTER_MODIFIER,
         when 16#001AA8# .. 16#001AAD# => PUNCTUATION_OTHER,
         when 16#001AB0# .. 16#001ABD# => MARK_NONSPACING,
         when 16#001ABE#               => MARK_ENCLOSING,
         when 16#001B00# .. 16#001B03# => MARK_NONSPACING,
         when 16#001B04#               => MARK_SPACING_COMBINING,
         when 16#001B05# .. 16#001B33# => LETTER_OTHER,
         when 16#001B34#               => MARK_NONSPACING,
         when 16#001B35#               => MARK_SPACING_COMBINING,
         when 16#001B36# .. 16#001B3A# => MARK_NONSPACING,
         when 16#001B3B#               => MARK_SPACING_COMBINING,
         when 16#001B3C#               => MARK_NONSPACING,
         when 16#001B3D# .. 16#001B41# => MARK_SPACING_COMBINING,
         when 16#001B42#               => MARK_NONSPACING,
         when 16#001B43# .. 16#001B44# => MARK_SPACING_COMBINING,
         when 16#001B45# .. 16#001B4B# => LETTER_OTHER,
         when 16#001B50# .. 16#001B59# => NUMBER_DECIMAL_DIGIT,
         when 16#001B5A# .. 16#001B60# => PUNCTUATION_OTHER,
         when 16#001B61# .. 16#001B6A# => SYMBOL_OTHER,
         when 16#001B6B# .. 16#001B73# => MARK_NONSPACING,
         when 16#001B74# .. 16#001B7C# => SYMBOL_OTHER,
         when 16#001B80# .. 16#001B81# => MARK_NONSPACING,
         when 16#001B82#               => MARK_SPACING_COMBINING,
         when 16#001B83# .. 16#001BA0# => LETTER_OTHER,
         when 16#001BA1#               => MARK_SPACING_COMBINING,
         when 16#001BA2# .. 16#001BA5# => MARK_NONSPACING,
         when 16#001BA6# .. 16#001BA7# => MARK_SPACING_COMBINING,
         when 16#001BA8# .. 16#001BA9# => MARK_NONSPACING,
         when 16#001BAA#               => MARK_SPACING_COMBINING,
         when 16#001BAB# .. 16#001BAD# => MARK_NONSPACING,
         when 16#001BAE# .. 16#001BAF# => LETTER_OTHER,
         when 16#001BB0# .. 16#001BB9# => NUMBER_DECIMAL_DIGIT,
         when 16#001BBA# .. 16#001BE5# => LETTER_OTHER,
         when 16#001BE6#               => MARK_NONSPACING,
         when 16#001BE7#               => MARK_SPACING_COMBINING,
         when 16#001BE8# .. 16#001BE9# => MARK_NONSPACING,
         when 16#001BEA# .. 16#001BEC# => MARK_SPACING_COMBINING,
         when 16#001BED#               => MARK_NONSPACING,
         when 16#001BEE#               => MARK_SPACING_COMBINING,
         when 16#001BEF# .. 16#001BF1# => MARK_NONSPACING,
         when 16#001BF2# .. 16#001BF3# => MARK_SPACING_COMBINING,
         when 16#001BFC# .. 16#001BFF# => PUNCTUATION_OTHER,
         when 16#001C00# .. 16#001C23# => LETTER_OTHER,
         when 16#001C24# .. 16#001C2B# => MARK_SPACING_COMBINING,
         when 16#001C2C# .. 16#001C33# => MARK_NONSPACING,
         when 16#001C34# .. 16#001C35# => MARK_SPACING_COMBINING,
         when 16#001C36# .. 16#001C37# => MARK_NONSPACING,
         when 16#001C3B# .. 16#001C3F# => PUNCTUATION_OTHER,
         when 16#001C40# .. 16#001C49# => NUMBER_DECIMAL_DIGIT,
         when 16#001C4D# .. 16#001C4F# => LETTER_OTHER,
         when 16#001C50# .. 16#001C59# => NUMBER_DECIMAL_DIGIT,
         when 16#001C5A# .. 16#001C77# => LETTER_OTHER,
         when 16#001C78# .. 16#001C7D# => LETTER_MODIFIER,
         when 16#001C7E# .. 16#001C7F# => PUNCTUATION_OTHER,
         when 16#001C80# .. 16#001C88# => LETTER_LOWERCASE,
         when 16#001C90# .. 16#001CBA# => LETTER_UPPERCASE,
         when 16#001CBD# .. 16#001CBF# => LETTER_UPPERCASE,
         when 16#001CC0# .. 16#001CC7# => PUNCTUATION_OTHER,
         when 16#001CD0# .. 16#001CD2# => MARK_NONSPACING,
         when 16#001CD3#               => PUNCTUATION_OTHER,
         when 16#001CD4# .. 16#001CE0# => MARK_NONSPACING,
         when 16#001CE1#               => MARK_SPACING_COMBINING,
         when 16#001CE2# .. 16#001CE8# => MARK_NONSPACING,
         when 16#001CE9# .. 16#001CEC# => LETTER_OTHER,
         when 16#001CED#               => MARK_NONSPACING,
         when 16#001CEE# .. 16#001CF3# => LETTER_OTHER,
         when 16#001CF4#               => MARK_NONSPACING,
         when 16#001CF5# .. 16#001CF6# => LETTER_OTHER,
         when 16#001CF7#               => MARK_SPACING_COMBINING,
         when 16#001CF8# .. 16#001CF9# => MARK_NONSPACING,
         when 16#001CFA#               => LETTER_OTHER,
         when 16#001D00# .. 16#001D2B# => LETTER_LOWERCASE,
         when 16#001D2C# .. 16#001D6A# => LETTER_MODIFIER,
         when 16#001D6B# .. 16#001D77# => LETTER_LOWERCASE,
         when 16#001D78#               => LETTER_MODIFIER,
         when 16#001D79# .. 16#001D9A# => LETTER_LOWERCASE,
         when 16#001D9B# .. 16#001DBF# => LETTER_MODIFIER,
         when 16#001DC0# .. 16#001DF9# => MARK_NONSPACING,
         when 16#001DFB# .. 16#001DFF# => MARK_NONSPACING,
         when 16#001E00#               => LETTER_UPPERCASE,
         when 16#001E01#               => LETTER_LOWERCASE,
         when 16#001E02#               => LETTER_UPPERCASE,
         when 16#001E03#               => LETTER_LOWERCASE,
         when 16#001E04#               => LETTER_UPPERCASE,
         when 16#001E05#               => LETTER_LOWERCASE,
         when 16#001E06#               => LETTER_UPPERCASE,
         when 16#001E07#               => LETTER_LOWERCASE,
         when 16#001E08#               => LETTER_UPPERCASE,
         when 16#001E09#               => LETTER_LOWERCASE,
         when 16#001E0A#               => LETTER_UPPERCASE,
         when 16#001E0B#               => LETTER_LOWERCASE,
         when 16#001E0C#               => LETTER_UPPERCASE,
         when 16#001E0D#               => LETTER_LOWERCASE,
         when 16#001E0E#               => LETTER_UPPERCASE,
         when 16#001E0F#               => LETTER_LOWERCASE,
         when 16#001E10#               => LETTER_UPPERCASE,
         when 16#001E11#               => LETTER_LOWERCASE,
         when 16#001E12#               => LETTER_UPPERCASE,
         when 16#001E13#               => LETTER_LOWERCASE,
         when 16#001E14#               => LETTER_UPPERCASE,
         when 16#001E15#               => LETTER_LOWERCASE,
         when 16#001E16#               => LETTER_UPPERCASE,
         when 16#001E17#               => LETTER_LOWERCASE,
         when 16#001E18#               => LETTER_UPPERCASE,
         when 16#001E19#               => LETTER_LOWERCASE,
         when 16#001E1A#               => LETTER_UPPERCASE,
         when 16#001E1B#               => LETTER_LOWERCASE,
         when 16#001E1C#               => LETTER_UPPERCASE,
         when 16#001E1D#               => LETTER_LOWERCASE,
         when 16#001E1E#               => LETTER_UPPERCASE,
         when 16#001E1F#               => LETTER_LOWERCASE,
         when 16#001E20#               => LETTER_UPPERCASE,
         when 16#001E21#               => LETTER_LOWERCASE,
         when 16#001E22#               => LETTER_UPPERCASE,
         when 16#001E23#               => LETTER_LOWERCASE,
         when 16#001E24#               => LETTER_UPPERCASE,
         when 16#001E25#               => LETTER_LOWERCASE,
         when 16#001E26#               => LETTER_UPPERCASE,
         when 16#001E27#               => LETTER_LOWERCASE,
         when 16#001E28#               => LETTER_UPPERCASE,
         when 16#001E29#               => LETTER_LOWERCASE,
         when 16#001E2A#               => LETTER_UPPERCASE,
         when 16#001E2B#               => LETTER_LOWERCASE,
         when 16#001E2C#               => LETTER_UPPERCASE,
         when 16#001E2D#               => LETTER_LOWERCASE,
         when 16#001E2E#               => LETTER_UPPERCASE,
         when 16#001E2F#               => LETTER_LOWERCASE,
         when 16#001E30#               => LETTER_UPPERCASE,
         when 16#001E31#               => LETTER_LOWERCASE,
         when 16#001E32#               => LETTER_UPPERCASE,
         when 16#001E33#               => LETTER_LOWERCASE,
         when 16#001E34#               => LETTER_UPPERCASE,
         when 16#001E35#               => LETTER_LOWERCASE,
         when 16#001E36#               => LETTER_UPPERCASE,
         when 16#001E37#               => LETTER_LOWERCASE,
         when 16#001E38#               => LETTER_UPPERCASE,
         when 16#001E39#               => LETTER_LOWERCASE,
         when 16#001E3A#               => LETTER_UPPERCASE,
         when 16#001E3B#               => LETTER_LOWERCASE,
         when 16#001E3C#               => LETTER_UPPERCASE,
         when 16#001E3D#               => LETTER_LOWERCASE,
         when 16#001E3E#               => LETTER_UPPERCASE,
         when 16#001E3F#               => LETTER_LOWERCASE,
         when 16#001E40#               => LETTER_UPPERCASE,
         when 16#001E41#               => LETTER_LOWERCASE,
         when 16#001E42#               => LETTER_UPPERCASE,
         when 16#001E43#               => LETTER_LOWERCASE,
         when 16#001E44#               => LETTER_UPPERCASE,
         when 16#001E45#               => LETTER_LOWERCASE,
         when 16#001E46#               => LETTER_UPPERCASE,
         when 16#001E47#               => LETTER_LOWERCASE,
         when 16#001E48#               => LETTER_UPPERCASE,
         when 16#001E49#               => LETTER_LOWERCASE,
         when 16#001E4A#               => LETTER_UPPERCASE,
         when 16#001E4B#               => LETTER_LOWERCASE,
         when 16#001E4C#               => LETTER_UPPERCASE,
         when 16#001E4D#               => LETTER_LOWERCASE,
         when 16#001E4E#               => LETTER_UPPERCASE,
         when 16#001E4F#               => LETTER_LOWERCASE,
         when 16#001E50#               => LETTER_UPPERCASE,
         when 16#001E51#               => LETTER_LOWERCASE,
         when 16#001E52#               => LETTER_UPPERCASE,
         when 16#001E53#               => LETTER_LOWERCASE,
         when 16#001E54#               => LETTER_UPPERCASE,
         when 16#001E55#               => LETTER_LOWERCASE,
         when 16#001E56#               => LETTER_UPPERCASE,
         when 16#001E57#               => LETTER_LOWERCASE,
         when 16#001E58#               => LETTER_UPPERCASE,
         when 16#001E59#               => LETTER_LOWERCASE,
         when 16#001E5A#               => LETTER_UPPERCASE,
         when 16#001E5B#               => LETTER_LOWERCASE,
         when 16#001E5C#               => LETTER_UPPERCASE,
         when 16#001E5D#               => LETTER_LOWERCASE,
         when 16#001E5E#               => LETTER_UPPERCASE,
         when 16#001E5F#               => LETTER_LOWERCASE,
         when 16#001E60#               => LETTER_UPPERCASE,
         when 16#001E61#               => LETTER_LOWERCASE,
         when 16#001E62#               => LETTER_UPPERCASE,
         when 16#001E63#               => LETTER_LOWERCASE,
         when 16#001E64#               => LETTER_UPPERCASE,
         when 16#001E65#               => LETTER_LOWERCASE,
         when 16#001E66#               => LETTER_UPPERCASE,
         when 16#001E67#               => LETTER_LOWERCASE,
         when 16#001E68#               => LETTER_UPPERCASE,
         when 16#001E69#               => LETTER_LOWERCASE,
         when 16#001E6A#               => LETTER_UPPERCASE,
         when 16#001E6B#               => LETTER_LOWERCASE,
         when 16#001E6C#               => LETTER_UPPERCASE,
         when 16#001E6D#               => LETTER_LOWERCASE,
         when 16#001E6E#               => LETTER_UPPERCASE,
         when 16#001E6F#               => LETTER_LOWERCASE,
         when 16#001E70#               => LETTER_UPPERCASE,
         when 16#001E71#               => LETTER_LOWERCASE,
         when 16#001E72#               => LETTER_UPPERCASE,
         when 16#001E73#               => LETTER_LOWERCASE,
         when 16#001E74#               => LETTER_UPPERCASE,
         when 16#001E75#               => LETTER_LOWERCASE,
         when 16#001E76#               => LETTER_UPPERCASE,
         when 16#001E77#               => LETTER_LOWERCASE,
         when 16#001E78#               => LETTER_UPPERCASE,
         when 16#001E79#               => LETTER_LOWERCASE,
         when 16#001E7A#               => LETTER_UPPERCASE,
         when 16#001E7B#               => LETTER_LOWERCASE,
         when 16#001E7C#               => LETTER_UPPERCASE,
         when 16#001E7D#               => LETTER_LOWERCASE,
         when 16#001E7E#               => LETTER_UPPERCASE,
         when 16#001E7F#               => LETTER_LOWERCASE,
         when 16#001E80#               => LETTER_UPPERCASE,
         when 16#001E81#               => LETTER_LOWERCASE,
         when 16#001E82#               => LETTER_UPPERCASE,
         when 16#001E83#               => LETTER_LOWERCASE,
         when 16#001E84#               => LETTER_UPPERCASE,
         when 16#001E85#               => LETTER_LOWERCASE,
         when 16#001E86#               => LETTER_UPPERCASE,
         when 16#001E87#               => LETTER_LOWERCASE,
         when 16#001E88#               => LETTER_UPPERCASE,
         when 16#001E89#               => LETTER_LOWERCASE,
         when 16#001E8A#               => LETTER_UPPERCASE,
         when 16#001E8B#               => LETTER_LOWERCASE,
         when 16#001E8C#               => LETTER_UPPERCASE,
         when 16#001E8D#               => LETTER_LOWERCASE,
         when 16#001E8E#               => LETTER_UPPERCASE,
         when 16#001E8F#               => LETTER_LOWERCASE,
         when 16#001E90#               => LETTER_UPPERCASE,
         when 16#001E91#               => LETTER_LOWERCASE,
         when 16#001E92#               => LETTER_UPPERCASE,
         when 16#001E93#               => LETTER_LOWERCASE,
         when 16#001E94#               => LETTER_UPPERCASE,
         when 16#001E95# .. 16#001E9D# => LETTER_LOWERCASE,
         when 16#001E9E#               => LETTER_UPPERCASE,
         when 16#001E9F#               => LETTER_LOWERCASE,
         when 16#001EA0#               => LETTER_UPPERCASE,
         when 16#001EA1#               => LETTER_LOWERCASE,
         when 16#001EA2#               => LETTER_UPPERCASE,
         when 16#001EA3#               => LETTER_LOWERCASE,
         when 16#001EA4#               => LETTER_UPPERCASE,
         when 16#001EA5#               => LETTER_LOWERCASE,
         when 16#001EA6#               => LETTER_UPPERCASE,
         when 16#001EA7#               => LETTER_LOWERCASE,
         when 16#001EA8#               => LETTER_UPPERCASE,
         when 16#001EA9#               => LETTER_LOWERCASE,
         when 16#001EAA#               => LETTER_UPPERCASE,
         when 16#001EAB#               => LETTER_LOWERCASE,
         when 16#001EAC#               => LETTER_UPPERCASE,
         when 16#001EAD#               => LETTER_LOWERCASE,
         when 16#001EAE#               => LETTER_UPPERCASE,
         when 16#001EAF#               => LETTER_LOWERCASE,
         when 16#001EB0#               => LETTER_UPPERCASE,
         when 16#001EB1#               => LETTER_LOWERCASE,
         when 16#001EB2#               => LETTER_UPPERCASE,
         when 16#001EB3#               => LETTER_LOWERCASE,
         when 16#001EB4#               => LETTER_UPPERCASE,
         when 16#001EB5#               => LETTER_LOWERCASE,
         when 16#001EB6#               => LETTER_UPPERCASE,
         when 16#001EB7#               => LETTER_LOWERCASE,
         when 16#001EB8#               => LETTER_UPPERCASE,
         when 16#001EB9#               => LETTER_LOWERCASE,
         when 16#001EBA#               => LETTER_UPPERCASE,
         when 16#001EBB#               => LETTER_LOWERCASE,
         when 16#001EBC#               => LETTER_UPPERCASE,
         when 16#001EBD#               => LETTER_LOWERCASE,
         when 16#001EBE#               => LETTER_UPPERCASE,
         when 16#001EBF#               => LETTER_LOWERCASE,
         when 16#001EC0#               => LETTER_UPPERCASE,
         when 16#001EC1#               => LETTER_LOWERCASE,
         when 16#001EC2#               => LETTER_UPPERCASE,
         when 16#001EC3#               => LETTER_LOWERCASE,
         when 16#001EC4#               => LETTER_UPPERCASE,
         when 16#001EC5#               => LETTER_LOWERCASE,
         when 16#001EC6#               => LETTER_UPPERCASE,
         when 16#001EC7#               => LETTER_LOWERCASE,
         when 16#001EC8#               => LETTER_UPPERCASE,
         when 16#001EC9#               => LETTER_LOWERCASE,
         when 16#001ECA#               => LETTER_UPPERCASE,
         when 16#001ECB#               => LETTER_LOWERCASE,
         when 16#001ECC#               => LETTER_UPPERCASE,
         when 16#001ECD#               => LETTER_LOWERCASE,
         when 16#001ECE#               => LETTER_UPPERCASE,
         when 16#001ECF#               => LETTER_LOWERCASE,
         when 16#001ED0#               => LETTER_UPPERCASE,
         when 16#001ED1#               => LETTER_LOWERCASE,
         when 16#001ED2#               => LETTER_UPPERCASE,
         when 16#001ED3#               => LETTER_LOWERCASE,
         when 16#001ED4#               => LETTER_UPPERCASE,
         when 16#001ED5#               => LETTER_LOWERCASE,
         when 16#001ED6#               => LETTER_UPPERCASE,
         when 16#001ED7#               => LETTER_LOWERCASE,
         when 16#001ED8#               => LETTER_UPPERCASE,
         when 16#001ED9#               => LETTER_LOWERCASE,
         when 16#001EDA#               => LETTER_UPPERCASE,
         when 16#001EDB#               => LETTER_LOWERCASE,
         when 16#001EDC#               => LETTER_UPPERCASE,
         when 16#001EDD#               => LETTER_LOWERCASE,
         when 16#001EDE#               => LETTER_UPPERCASE,
         when 16#001EDF#               => LETTER_LOWERCASE,
         when 16#001EE0#               => LETTER_UPPERCASE,
         when 16#001EE1#               => LETTER_LOWERCASE,
         when 16#001EE2#               => LETTER_UPPERCASE,
         when 16#001EE3#               => LETTER_LOWERCASE,
         when 16#001EE4#               => LETTER_UPPERCASE,
         when 16#001EE5#               => LETTER_LOWERCASE,
         when 16#001EE6#               => LETTER_UPPERCASE,
         when 16#001EE7#               => LETTER_LOWERCASE,
         when 16#001EE8#               => LETTER_UPPERCASE,
         when 16#001EE9#               => LETTER_LOWERCASE,
         when 16#001EEA#               => LETTER_UPPERCASE,
         when 16#001EEB#               => LETTER_LOWERCASE,
         when 16#001EEC#               => LETTER_UPPERCASE,
         when 16#001EED#               => LETTER_LOWERCASE,
         when 16#001EEE#               => LETTER_UPPERCASE,
         when 16#001EEF#               => LETTER_LOWERCASE,
         when 16#001EF0#               => LETTER_UPPERCASE,
         when 16#001EF1#               => LETTER_LOWERCASE,
         when 16#001EF2#               => LETTER_UPPERCASE,
         when 16#001EF3#               => LETTER_LOWERCASE,
         when 16#001EF4#               => LETTER_UPPERCASE,
         when 16#001EF5#               => LETTER_LOWERCASE,
         when 16#001EF6#               => LETTER_UPPERCASE,
         when 16#001EF7#               => LETTER_LOWERCASE,
         when 16#001EF8#               => LETTER_UPPERCASE,
         when 16#001EF9#               => LETTER_LOWERCASE,
         when 16#001EFA#               => LETTER_UPPERCASE,
         when 16#001EFB#               => LETTER_LOWERCASE,
         when 16#001EFC#               => LETTER_UPPERCASE,
         when 16#001EFD#               => LETTER_LOWERCASE,
         when 16#001EFE#               => LETTER_UPPERCASE,
         when 16#001EFF# .. 16#001F07# => LETTER_LOWERCASE,
         when 16#001F08# .. 16#001F0F# => LETTER_UPPERCASE,
         when 16#001F10# .. 16#001F15# => LETTER_LOWERCASE,
         when 16#001F18# .. 16#001F1D# => LETTER_UPPERCASE,
         when 16#001F20# .. 16#001F27# => LETTER_LOWERCASE,
         when 16#001F28# .. 16#001F2F# => LETTER_UPPERCASE,
         when 16#001F30# .. 16#001F37# => LETTER_LOWERCASE,
         when 16#001F38# .. 16#001F3F# => LETTER_UPPERCASE,
         when 16#001F40# .. 16#001F45# => LETTER_LOWERCASE,
         when 16#001F48# .. 16#001F4D# => LETTER_UPPERCASE,
         when 16#001F50# .. 16#001F57# => LETTER_LOWERCASE,
         when 16#001F59#               => LETTER_UPPERCASE,
         when 16#001F5B#               => LETTER_UPPERCASE,
         when 16#001F5D#               => LETTER_UPPERCASE,
         when 16#001F5F#               => LETTER_UPPERCASE,
         when 16#001F60# .. 16#001F67# => LETTER_LOWERCASE,
         when 16#001F68# .. 16#001F6F# => LETTER_UPPERCASE,
         when 16#001F70# .. 16#001F7D# => LETTER_LOWERCASE,
         when 16#001F80# .. 16#001F87# => LETTER_LOWERCASE,
         when 16#001F88# .. 16#001F8F# => LETTER_TITLECASE,
         when 16#001F90# .. 16#001F97# => LETTER_LOWERCASE,
         when 16#001F98# .. 16#001F9F# => LETTER_TITLECASE,
         when 16#001FA0# .. 16#001FA7# => LETTER_LOWERCASE,
         when 16#001FA8# .. 16#001FAF# => LETTER_TITLECASE,
         when 16#001FB0# .. 16#001FB4# => LETTER_LOWERCASE,
         when 16#001FB6# .. 16#001FB7# => LETTER_LOWERCASE,
         when 16#001FB8# .. 16#001FBB# => LETTER_UPPERCASE,
         when 16#001FBC#               => LETTER_TITLECASE,
         when 16#001FBD#               => SYMBOL_MODIFIER,
         when 16#001FBE#               => LETTER_LOWERCASE,
         when 16#001FBF# .. 16#001FC1# => SYMBOL_MODIFIER,
         when 16#001FC2# .. 16#001FC4# => LETTER_LOWERCASE,
         when 16#001FC6# .. 16#001FC7# => LETTER_LOWERCASE,
         when 16#001FC8# .. 16#001FCB# => LETTER_UPPERCASE,
         when 16#001FCC#               => LETTER_TITLECASE,
         when 16#001FCD# .. 16#001FCF# => SYMBOL_MODIFIER,
         when 16#001FD0# .. 16#001FD3# => LETTER_LOWERCASE,
         when 16#001FD6# .. 16#001FD7# => LETTER_LOWERCASE,
         when 16#001FD8# .. 16#001FDB# => LETTER_UPPERCASE,
         when 16#001FDD# .. 16#001FDF# => SYMBOL_MODIFIER,
         when 16#001FE0# .. 16#001FE7# => LETTER_LOWERCASE,
         when 16#001FE8# .. 16#001FEC# => LETTER_UPPERCASE,
         when 16#001FED# .. 16#001FEF# => SYMBOL_MODIFIER,
         when 16#001FF2# .. 16#001FF4# => LETTER_LOWERCASE,
         when 16#001FF6# .. 16#001FF7# => LETTER_LOWERCASE,
         when 16#001FF8# .. 16#001FFB# => LETTER_UPPERCASE,
         when 16#001FFC#               => LETTER_TITLECASE,
         when 16#001FFD# .. 16#001FFE# => SYMBOL_MODIFIER,
         when 16#002000# .. 16#00200A# => SEPARATOR_SPACE,
         when 16#00200B# .. 16#00200F# => OTHER_FORMAT,
         when 16#002010# .. 16#002015# => PUNCTUATION_DASH,
         when 16#002016# .. 16#002017# => PUNCTUATION_OTHER,
         when 16#002018#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002019#               => PUNCTUATION_FINAL_QUOTE,
         when 16#00201A#               => PUNCTUATION_OPEN,
         when 16#00201B# .. 16#00201C# => PUNCTUATION_INITIAL_QUOTE,
         when 16#00201D#               => PUNCTUATION_FINAL_QUOTE,
         when 16#00201E#               => PUNCTUATION_OPEN,
         when 16#00201F#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002020# .. 16#002027# => PUNCTUATION_OTHER,
         when 16#002028#               => SEPARATOR_LINE,
         when 16#002029#               => SEPARATOR_PARAGRAPH,
         when 16#00202A# .. 16#00202E# => OTHER_FORMAT,
         when 16#00202F#               => SEPARATOR_SPACE,
         when 16#002030# .. 16#002038# => PUNCTUATION_OTHER,
         when 16#002039#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#00203A#               => PUNCTUATION_FINAL_QUOTE,
         when 16#00203B# .. 16#00203E# => PUNCTUATION_OTHER,
         when 16#00203F# .. 16#002040# => PUNCTUATION_CONNECTOR,
         when 16#002041# .. 16#002043# => PUNCTUATION_OTHER,
         when 16#002044#               => SYMBOL_MATH,
         when 16#002045#               => PUNCTUATION_OPEN,
         when 16#002046#               => PUNCTUATION_CLOSE,
         when 16#002047# .. 16#002051# => PUNCTUATION_OTHER,
         when 16#002052#               => SYMBOL_MATH,
         when 16#002053#               => PUNCTUATION_OTHER,
         when 16#002054#               => PUNCTUATION_CONNECTOR,
         when 16#002055# .. 16#00205E# => PUNCTUATION_OTHER,
         when 16#00205F#               => SEPARATOR_SPACE,
         when 16#002060# .. 16#002064# => OTHER_FORMAT,
         when 16#002066# .. 16#00206F# => OTHER_FORMAT,
         when 16#002070#               => NUMBER_OTHER,
         when 16#002071#               => LETTER_MODIFIER,
         when 16#002074# .. 16#002079# => NUMBER_OTHER,
         when 16#00207A# .. 16#00207C# => SYMBOL_MATH,
         when 16#00207D#               => PUNCTUATION_OPEN,
         when 16#00207E#               => PUNCTUATION_CLOSE,
         when 16#00207F#               => LETTER_MODIFIER,
         when 16#002080# .. 16#002089# => NUMBER_OTHER,
         when 16#00208A# .. 16#00208C# => SYMBOL_MATH,
         when 16#00208D#               => PUNCTUATION_OPEN,
         when 16#00208E#               => PUNCTUATION_CLOSE,
         when 16#002090# .. 16#00209C# => LETTER_MODIFIER,
         when 16#0020A0# .. 16#0020BF# => SYMBOL_CURRENCY,
         when 16#0020D0# .. 16#0020DC# => MARK_NONSPACING,
         when 16#0020DD# .. 16#0020E0# => MARK_ENCLOSING,
         when 16#0020E1#               => MARK_NONSPACING,
         when 16#0020E2# .. 16#0020E4# => MARK_ENCLOSING,
         when 16#0020E5# .. 16#0020F0# => MARK_NONSPACING,
         when 16#002100# .. 16#002101# => SYMBOL_OTHER,
         when 16#002102#               => LETTER_UPPERCASE,
         when 16#002103# .. 16#002106# => SYMBOL_OTHER,
         when 16#002107#               => LETTER_UPPERCASE,
         when 16#002108# .. 16#002109# => SYMBOL_OTHER,
         when 16#00210A#               => LETTER_LOWERCASE,
         when 16#00210B# .. 16#00210D# => LETTER_UPPERCASE,
         when 16#00210E# .. 16#00210F# => LETTER_LOWERCASE,
         when 16#002110# .. 16#002112# => LETTER_UPPERCASE,
         when 16#002113#               => LETTER_LOWERCASE,
         when 16#002114#               => SYMBOL_OTHER,
         when 16#002115#               => LETTER_UPPERCASE,
         when 16#002116# .. 16#002117# => SYMBOL_OTHER,
         when 16#002118#               => SYMBOL_MATH,
         when 16#002119# .. 16#00211D# => LETTER_UPPERCASE,
         when 16#00211E# .. 16#002123# => SYMBOL_OTHER,
         when 16#002124#               => LETTER_UPPERCASE,
         when 16#002125#               => SYMBOL_OTHER,
         when 16#002126#               => LETTER_UPPERCASE,
         when 16#002127#               => SYMBOL_OTHER,
         when 16#002128#               => LETTER_UPPERCASE,
         when 16#002129#               => SYMBOL_OTHER,
         when 16#00212A# .. 16#00212D# => LETTER_UPPERCASE,
         when 16#00212E#               => SYMBOL_OTHER,
         when 16#00212F#               => LETTER_LOWERCASE,
         when 16#002130# .. 16#002133# => LETTER_UPPERCASE,
         when 16#002134#               => LETTER_LOWERCASE,
         when 16#002135# .. 16#002138# => LETTER_OTHER,
         when 16#002139#               => LETTER_LOWERCASE,
         when 16#00213A# .. 16#00213B# => SYMBOL_OTHER,
         when 16#00213C# .. 16#00213D# => LETTER_LOWERCASE,
         when 16#00213E# .. 16#00213F# => LETTER_UPPERCASE,
         when 16#002140# .. 16#002144# => SYMBOL_MATH,
         when 16#002145#               => LETTER_UPPERCASE,
         when 16#002146# .. 16#002149# => LETTER_LOWERCASE,
         when 16#00214A#               => SYMBOL_OTHER,
         when 16#00214B#               => SYMBOL_MATH,
         when 16#00214C# .. 16#00214D# => SYMBOL_OTHER,
         when 16#00214E#               => LETTER_LOWERCASE,
         when 16#00214F#               => SYMBOL_OTHER,
         when 16#002150# .. 16#00215F# => NUMBER_OTHER,
         when 16#002160# .. 16#002182# => NUMBER_LETTER,
         when 16#002183#               => LETTER_UPPERCASE,
         when 16#002184#               => LETTER_LOWERCASE,
         when 16#002185# .. 16#002188# => NUMBER_LETTER,
         when 16#002189#               => NUMBER_OTHER,
         when 16#00218A# .. 16#00218B# => SYMBOL_OTHER,
         when 16#002190# .. 16#002194# => SYMBOL_MATH,
         when 16#002195# .. 16#002199# => SYMBOL_OTHER,
         when 16#00219A# .. 16#00219B# => SYMBOL_MATH,
         when 16#00219C# .. 16#00219F# => SYMBOL_OTHER,
         when 16#0021A0#               => SYMBOL_MATH,
         when 16#0021A1# .. 16#0021A2# => SYMBOL_OTHER,
         when 16#0021A3#               => SYMBOL_MATH,
         when 16#0021A4# .. 16#0021A5# => SYMBOL_OTHER,
         when 16#0021A6#               => SYMBOL_MATH,
         when 16#0021A7# .. 16#0021AD# => SYMBOL_OTHER,
         when 16#0021AE#               => SYMBOL_MATH,
         when 16#0021AF# .. 16#0021CD# => SYMBOL_OTHER,
         when 16#0021CE# .. 16#0021CF# => SYMBOL_MATH,
         when 16#0021D0# .. 16#0021D1# => SYMBOL_OTHER,
         when 16#0021D2#               => SYMBOL_MATH,
         when 16#0021D3#               => SYMBOL_OTHER,
         when 16#0021D4#               => SYMBOL_MATH,
         when 16#0021D5# .. 16#0021F3# => SYMBOL_OTHER,
         when 16#0021F4# .. 16#0022FF# => SYMBOL_MATH,
         when 16#002300# .. 16#002307# => SYMBOL_OTHER,
         when 16#002308#               => PUNCTUATION_OPEN,
         when 16#002309#               => PUNCTUATION_CLOSE,
         when 16#00230A#               => PUNCTUATION_OPEN,
         when 16#00230B#               => PUNCTUATION_CLOSE,
         when 16#00230C# .. 16#00231F# => SYMBOL_OTHER,
         when 16#002320# .. 16#002321# => SYMBOL_MATH,
         when 16#002322# .. 16#002328# => SYMBOL_OTHER,
         when 16#002329#               => PUNCTUATION_OPEN,
         when 16#00232A#               => PUNCTUATION_CLOSE,
         when 16#00232B# .. 16#00237B# => SYMBOL_OTHER,
         when 16#00237C#               => SYMBOL_MATH,
         when 16#00237D# .. 16#00239A# => SYMBOL_OTHER,
         when 16#00239B# .. 16#0023B3# => SYMBOL_MATH,
         when 16#0023B4# .. 16#0023DB# => SYMBOL_OTHER,
         when 16#0023DC# .. 16#0023E1# => SYMBOL_MATH,
         when 16#0023E2# .. 16#002426# => SYMBOL_OTHER,
         when 16#002440# .. 16#00244A# => SYMBOL_OTHER,
         when 16#002460# .. 16#00249B# => NUMBER_OTHER,
         when 16#00249C# .. 16#0024E9# => SYMBOL_OTHER,
         when 16#0024EA# .. 16#0024FF# => NUMBER_OTHER,
         when 16#002500# .. 16#0025B6# => SYMBOL_OTHER,
         when 16#0025B7#               => SYMBOL_MATH,
         when 16#0025B8# .. 16#0025C0# => SYMBOL_OTHER,
         when 16#0025C1#               => SYMBOL_MATH,
         when 16#0025C2# .. 16#0025F7# => SYMBOL_OTHER,
         when 16#0025F8# .. 16#0025FF# => SYMBOL_MATH,
         when 16#002600# .. 16#00266E# => SYMBOL_OTHER,
         when 16#00266F#               => SYMBOL_MATH,
         when 16#002670# .. 16#002767# => SYMBOL_OTHER,
         when 16#002768#               => PUNCTUATION_OPEN,
         when 16#002769#               => PUNCTUATION_CLOSE,
         when 16#00276A#               => PUNCTUATION_OPEN,
         when 16#00276B#               => PUNCTUATION_CLOSE,
         when 16#00276C#               => PUNCTUATION_OPEN,
         when 16#00276D#               => PUNCTUATION_CLOSE,
         when 16#00276E#               => PUNCTUATION_OPEN,
         when 16#00276F#               => PUNCTUATION_CLOSE,
         when 16#002770#               => PUNCTUATION_OPEN,
         when 16#002771#               => PUNCTUATION_CLOSE,
         when 16#002772#               => PUNCTUATION_OPEN,
         when 16#002773#               => PUNCTUATION_CLOSE,
         when 16#002774#               => PUNCTUATION_OPEN,
         when 16#002775#               => PUNCTUATION_CLOSE,
         when 16#002776# .. 16#002793# => NUMBER_OTHER,
         when 16#002794# .. 16#0027BF# => SYMBOL_OTHER,
         when 16#0027C0# .. 16#0027C4# => SYMBOL_MATH,
         when 16#0027C5#               => PUNCTUATION_OPEN,
         when 16#0027C6#               => PUNCTUATION_CLOSE,
         when 16#0027C7# .. 16#0027E5# => SYMBOL_MATH,
         when 16#0027E6#               => PUNCTUATION_OPEN,
         when 16#0027E7#               => PUNCTUATION_CLOSE,
         when 16#0027E8#               => PUNCTUATION_OPEN,
         when 16#0027E9#               => PUNCTUATION_CLOSE,
         when 16#0027EA#               => PUNCTUATION_OPEN,
         when 16#0027EB#               => PUNCTUATION_CLOSE,
         when 16#0027EC#               => PUNCTUATION_OPEN,
         when 16#0027ED#               => PUNCTUATION_CLOSE,
         when 16#0027EE#               => PUNCTUATION_OPEN,
         when 16#0027EF#               => PUNCTUATION_CLOSE,
         when 16#0027F0# .. 16#0027FF# => SYMBOL_MATH,
         when 16#002800# .. 16#0028FF# => SYMBOL_OTHER,
         when 16#002900# .. 16#002982# => SYMBOL_MATH,
         when 16#002983#               => PUNCTUATION_OPEN,
         when 16#002984#               => PUNCTUATION_CLOSE,
         when 16#002985#               => PUNCTUATION_OPEN,
         when 16#002986#               => PUNCTUATION_CLOSE,
         when 16#002987#               => PUNCTUATION_OPEN,
         when 16#002988#               => PUNCTUATION_CLOSE,
         when 16#002989#               => PUNCTUATION_OPEN,
         when 16#00298A#               => PUNCTUATION_CLOSE,
         when 16#00298B#               => PUNCTUATION_OPEN,
         when 16#00298C#               => PUNCTUATION_CLOSE,
         when 16#00298D#               => PUNCTUATION_OPEN,
         when 16#00298E#               => PUNCTUATION_CLOSE,
         when 16#00298F#               => PUNCTUATION_OPEN,
         when 16#002990#               => PUNCTUATION_CLOSE,
         when 16#002991#               => PUNCTUATION_OPEN,
         when 16#002992#               => PUNCTUATION_CLOSE,
         when 16#002993#               => PUNCTUATION_OPEN,
         when 16#002994#               => PUNCTUATION_CLOSE,
         when 16#002995#               => PUNCTUATION_OPEN,
         when 16#002996#               => PUNCTUATION_CLOSE,
         when 16#002997#               => PUNCTUATION_OPEN,
         when 16#002998#               => PUNCTUATION_CLOSE,
         when 16#002999# .. 16#0029D7# => SYMBOL_MATH,
         when 16#0029D8#               => PUNCTUATION_OPEN,
         when 16#0029D9#               => PUNCTUATION_CLOSE,
         when 16#0029DA#               => PUNCTUATION_OPEN,
         when 16#0029DB#               => PUNCTUATION_CLOSE,
         when 16#0029DC# .. 16#0029FB# => SYMBOL_MATH,
         when 16#0029FC#               => PUNCTUATION_OPEN,
         when 16#0029FD#               => PUNCTUATION_CLOSE,
         when 16#0029FE# .. 16#002AFF# => SYMBOL_MATH,
         when 16#002B00# .. 16#002B2F# => SYMBOL_OTHER,
         when 16#002B30# .. 16#002B44# => SYMBOL_MATH,
         when 16#002B45# .. 16#002B46# => SYMBOL_OTHER,
         when 16#002B47# .. 16#002B4C# => SYMBOL_MATH,
         when 16#002B4D# .. 16#002B73# => SYMBOL_OTHER,
         when 16#002B76# .. 16#002B95# => SYMBOL_OTHER,
         when 16#002B98# .. 16#002BFF# => SYMBOL_OTHER,
         when 16#002C00# .. 16#002C2E# => LETTER_UPPERCASE,
         when 16#002C30# .. 16#002C5E# => LETTER_LOWERCASE,
         when 16#002C60#               => LETTER_UPPERCASE,
         when 16#002C61#               => LETTER_LOWERCASE,
         when 16#002C62# .. 16#002C64# => LETTER_UPPERCASE,
         when 16#002C65# .. 16#002C66# => LETTER_LOWERCASE,
         when 16#002C67#               => LETTER_UPPERCASE,
         when 16#002C68#               => LETTER_LOWERCASE,
         when 16#002C69#               => LETTER_UPPERCASE,
         when 16#002C6A#               => LETTER_LOWERCASE,
         when 16#002C6B#               => LETTER_UPPERCASE,
         when 16#002C6C#               => LETTER_LOWERCASE,
         when 16#002C6D# .. 16#002C70# => LETTER_UPPERCASE,
         when 16#002C71#               => LETTER_LOWERCASE,
         when 16#002C72#               => LETTER_UPPERCASE,
         when 16#002C73# .. 16#002C74# => LETTER_LOWERCASE,
         when 16#002C75#               => LETTER_UPPERCASE,
         when 16#002C76# .. 16#002C7B# => LETTER_LOWERCASE,
         when 16#002C7C# .. 16#002C7D# => LETTER_MODIFIER,
         when 16#002C7E# .. 16#002C80# => LETTER_UPPERCASE,
         when 16#002C81#               => LETTER_LOWERCASE,
         when 16#002C82#               => LETTER_UPPERCASE,
         when 16#002C83#               => LETTER_LOWERCASE,
         when 16#002C84#               => LETTER_UPPERCASE,
         when 16#002C85#               => LETTER_LOWERCASE,
         when 16#002C86#               => LETTER_UPPERCASE,
         when 16#002C87#               => LETTER_LOWERCASE,
         when 16#002C88#               => LETTER_UPPERCASE,
         when 16#002C89#               => LETTER_LOWERCASE,
         when 16#002C8A#               => LETTER_UPPERCASE,
         when 16#002C8B#               => LETTER_LOWERCASE,
         when 16#002C8C#               => LETTER_UPPERCASE,
         when 16#002C8D#               => LETTER_LOWERCASE,
         when 16#002C8E#               => LETTER_UPPERCASE,
         when 16#002C8F#               => LETTER_LOWERCASE,
         when 16#002C90#               => LETTER_UPPERCASE,
         when 16#002C91#               => LETTER_LOWERCASE,
         when 16#002C92#               => LETTER_UPPERCASE,
         when 16#002C93#               => LETTER_LOWERCASE,
         when 16#002C94#               => LETTER_UPPERCASE,
         when 16#002C95#               => LETTER_LOWERCASE,
         when 16#002C96#               => LETTER_UPPERCASE,
         when 16#002C97#               => LETTER_LOWERCASE,
         when 16#002C98#               => LETTER_UPPERCASE,
         when 16#002C99#               => LETTER_LOWERCASE,
         when 16#002C9A#               => LETTER_UPPERCASE,
         when 16#002C9B#               => LETTER_LOWERCASE,
         when 16#002C9C#               => LETTER_UPPERCASE,
         when 16#002C9D#               => LETTER_LOWERCASE,
         when 16#002C9E#               => LETTER_UPPERCASE,
         when 16#002C9F#               => LETTER_LOWERCASE,
         when 16#002CA0#               => LETTER_UPPERCASE,
         when 16#002CA1#               => LETTER_LOWERCASE,
         when 16#002CA2#               => LETTER_UPPERCASE,
         when 16#002CA3#               => LETTER_LOWERCASE,
         when 16#002CA4#               => LETTER_UPPERCASE,
         when 16#002CA5#               => LETTER_LOWERCASE,
         when 16#002CA6#               => LETTER_UPPERCASE,
         when 16#002CA7#               => LETTER_LOWERCASE,
         when 16#002CA8#               => LETTER_UPPERCASE,
         when 16#002CA9#               => LETTER_LOWERCASE,
         when 16#002CAA#               => LETTER_UPPERCASE,
         when 16#002CAB#               => LETTER_LOWERCASE,
         when 16#002CAC#               => LETTER_UPPERCASE,
         when 16#002CAD#               => LETTER_LOWERCASE,
         when 16#002CAE#               => LETTER_UPPERCASE,
         when 16#002CAF#               => LETTER_LOWERCASE,
         when 16#002CB0#               => LETTER_UPPERCASE,
         when 16#002CB1#               => LETTER_LOWERCASE,
         when 16#002CB2#               => LETTER_UPPERCASE,
         when 16#002CB3#               => LETTER_LOWERCASE,
         when 16#002CB4#               => LETTER_UPPERCASE,
         when 16#002CB5#               => LETTER_LOWERCASE,
         when 16#002CB6#               => LETTER_UPPERCASE,
         when 16#002CB7#               => LETTER_LOWERCASE,
         when 16#002CB8#               => LETTER_UPPERCASE,
         when 16#002CB9#               => LETTER_LOWERCASE,
         when 16#002CBA#               => LETTER_UPPERCASE,
         when 16#002CBB#               => LETTER_LOWERCASE,
         when 16#002CBC#               => LETTER_UPPERCASE,
         when 16#002CBD#               => LETTER_LOWERCASE,
         when 16#002CBE#               => LETTER_UPPERCASE,
         when 16#002CBF#               => LETTER_LOWERCASE,
         when 16#002CC0#               => LETTER_UPPERCASE,
         when 16#002CC1#               => LETTER_LOWERCASE,
         when 16#002CC2#               => LETTER_UPPERCASE,
         when 16#002CC3#               => LETTER_LOWERCASE,
         when 16#002CC4#               => LETTER_UPPERCASE,
         when 16#002CC5#               => LETTER_LOWERCASE,
         when 16#002CC6#               => LETTER_UPPERCASE,
         when 16#002CC7#               => LETTER_LOWERCASE,
         when 16#002CC8#               => LETTER_UPPERCASE,
         when 16#002CC9#               => LETTER_LOWERCASE,
         when 16#002CCA#               => LETTER_UPPERCASE,
         when 16#002CCB#               => LETTER_LOWERCASE,
         when 16#002CCC#               => LETTER_UPPERCASE,
         when 16#002CCD#               => LETTER_LOWERCASE,
         when 16#002CCE#               => LETTER_UPPERCASE,
         when 16#002CCF#               => LETTER_LOWERCASE,
         when 16#002CD0#               => LETTER_UPPERCASE,
         when 16#002CD1#               => LETTER_LOWERCASE,
         when 16#002CD2#               => LETTER_UPPERCASE,
         when 16#002CD3#               => LETTER_LOWERCASE,
         when 16#002CD4#               => LETTER_UPPERCASE,
         when 16#002CD5#               => LETTER_LOWERCASE,
         when 16#002CD6#               => LETTER_UPPERCASE,
         when 16#002CD7#               => LETTER_LOWERCASE,
         when 16#002CD8#               => LETTER_UPPERCASE,
         when 16#002CD9#               => LETTER_LOWERCASE,
         when 16#002CDA#               => LETTER_UPPERCASE,
         when 16#002CDB#               => LETTER_LOWERCASE,
         when 16#002CDC#               => LETTER_UPPERCASE,
         when 16#002CDD#               => LETTER_LOWERCASE,
         when 16#002CDE#               => LETTER_UPPERCASE,
         when 16#002CDF#               => LETTER_LOWERCASE,
         when 16#002CE0#               => LETTER_UPPERCASE,
         when 16#002CE1#               => LETTER_LOWERCASE,
         when 16#002CE2#               => LETTER_UPPERCASE,
         when 16#002CE3# .. 16#002CE4# => LETTER_LOWERCASE,
         when 16#002CE5# .. 16#002CEA# => SYMBOL_OTHER,
         when 16#002CEB#               => LETTER_UPPERCASE,
         when 16#002CEC#               => LETTER_LOWERCASE,
         when 16#002CED#               => LETTER_UPPERCASE,
         when 16#002CEE#               => LETTER_LOWERCASE,
         when 16#002CEF# .. 16#002CF1# => MARK_NONSPACING,
         when 16#002CF2#               => LETTER_UPPERCASE,
         when 16#002CF3#               => LETTER_LOWERCASE,
         when 16#002CF9# .. 16#002CFC# => PUNCTUATION_OTHER,
         when 16#002CFD#               => NUMBER_OTHER,
         when 16#002CFE# .. 16#002CFF# => PUNCTUATION_OTHER,
         when 16#002D00# .. 16#002D25# => LETTER_LOWERCASE,
         when 16#002D27#               => LETTER_LOWERCASE,
         when 16#002D2D#               => LETTER_LOWERCASE,
         when 16#002D30# .. 16#002D67# => LETTER_OTHER,
         when 16#002D6F#               => LETTER_MODIFIER,
         when 16#002D70#               => PUNCTUATION_OTHER,
         when 16#002D7F#               => MARK_NONSPACING,
         when 16#002D80# .. 16#002D96# => LETTER_OTHER,
         when 16#002DA0# .. 16#002DA6# => LETTER_OTHER,
         when 16#002DA8# .. 16#002DAE# => LETTER_OTHER,
         when 16#002DB0# .. 16#002DB6# => LETTER_OTHER,
         when 16#002DB8# .. 16#002DBE# => LETTER_OTHER,
         when 16#002DC0# .. 16#002DC6# => LETTER_OTHER,
         when 16#002DC8# .. 16#002DCE# => LETTER_OTHER,
         when 16#002DD0# .. 16#002DD6# => LETTER_OTHER,
         when 16#002DD8# .. 16#002DDE# => LETTER_OTHER,
         when 16#002DE0# .. 16#002DFF# => MARK_NONSPACING,
         when 16#002E00# .. 16#002E01# => PUNCTUATION_OTHER,
         when 16#002E02#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E03#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E04#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E05#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E06# .. 16#002E08# => PUNCTUATION_OTHER,
         when 16#002E09#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E0A#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E0B#               => PUNCTUATION_OTHER,
         when 16#002E0C#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E0D#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E0E# .. 16#002E16# => PUNCTUATION_OTHER,
         when 16#002E17#               => PUNCTUATION_DASH,
         when 16#002E18# .. 16#002E19# => PUNCTUATION_OTHER,
         when 16#002E1A#               => PUNCTUATION_DASH,
         when 16#002E1B#               => PUNCTUATION_OTHER,
         when 16#002E1C#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E1D#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E1E# .. 16#002E1F# => PUNCTUATION_OTHER,
         when 16#002E20#               => PUNCTUATION_INITIAL_QUOTE,
         when 16#002E21#               => PUNCTUATION_FINAL_QUOTE,
         when 16#002E22#               => PUNCTUATION_OPEN,
         when 16#002E23#               => PUNCTUATION_CLOSE,
         when 16#002E24#               => PUNCTUATION_OPEN,
         when 16#002E25#               => PUNCTUATION_CLOSE,
         when 16#002E26#               => PUNCTUATION_OPEN,
         when 16#002E27#               => PUNCTUATION_CLOSE,
         when 16#002E28#               => PUNCTUATION_OPEN,
         when 16#002E29#               => PUNCTUATION_CLOSE,
         when 16#002E2A# .. 16#002E2E# => PUNCTUATION_OTHER,
         when 16#002E2F#               => LETTER_MODIFIER,
         when 16#002E30# .. 16#002E39# => PUNCTUATION_OTHER,
         when 16#002E3A# .. 16#002E3B# => PUNCTUATION_DASH,
         when 16#002E3C# .. 16#002E3F# => PUNCTUATION_OTHER,
         when 16#002E40#               => PUNCTUATION_DASH,
         when 16#002E41#               => PUNCTUATION_OTHER,
         when 16#002E42#               => PUNCTUATION_OPEN,
         when 16#002E43# .. 16#002E4F# => PUNCTUATION_OTHER,
         when 16#002E80# .. 16#002E99# => SYMBOL_OTHER,
         when 16#002E9B# .. 16#002EF3# => SYMBOL_OTHER,
         when 16#002F00# .. 16#002FD5# => SYMBOL_OTHER,
         when 16#002FF0# .. 16#002FFB# => SYMBOL_OTHER,
         when 16#003000#               => SEPARATOR_SPACE,
         when 16#003001# .. 16#003003# => PUNCTUATION_OTHER,
         when 16#003004#               => SYMBOL_OTHER,
         when 16#003005#               => LETTER_MODIFIER,
         when 16#003006#               => LETTER_OTHER,
         when 16#003007#               => NUMBER_LETTER,
         when 16#003008#               => PUNCTUATION_OPEN,
         when 16#003009#               => PUNCTUATION_CLOSE,
         when 16#00300A#               => PUNCTUATION_OPEN,
         when 16#00300B#               => PUNCTUATION_CLOSE,
         when 16#00300C#               => PUNCTUATION_OPEN,
         when 16#00300D#               => PUNCTUATION_CLOSE,
         when 16#00300E#               => PUNCTUATION_OPEN,
         when 16#00300F#               => PUNCTUATION_CLOSE,
         when 16#003010#               => PUNCTUATION_OPEN,
         when 16#003011#               => PUNCTUATION_CLOSE,
         when 16#003012# .. 16#003013# => SYMBOL_OTHER,
         when 16#003014#               => PUNCTUATION_OPEN,
         when 16#003015#               => PUNCTUATION_CLOSE,
         when 16#003016#               => PUNCTUATION_OPEN,
         when 16#003017#               => PUNCTUATION_CLOSE,
         when 16#003018#               => PUNCTUATION_OPEN,
         when 16#003019#               => PUNCTUATION_CLOSE,
         when 16#00301A#               => PUNCTUATION_OPEN,
         when 16#00301B#               => PUNCTUATION_CLOSE,
         when 16#00301C#               => PUNCTUATION_DASH,
         when 16#00301D#               => PUNCTUATION_OPEN,
         when 16#00301E# .. 16#00301F# => PUNCTUATION_CLOSE,
         when 16#003020#               => SYMBOL_OTHER,
         when 16#003021# .. 16#003029# => NUMBER_LETTER,
         when 16#00302A# .. 16#00302D# => MARK_NONSPACING,
         when 16#00302E# .. 16#00302F# => MARK_SPACING_COMBINING,
         when 16#003030#               => PUNCTUATION_DASH,
         when 16#003031# .. 16#003035# => LETTER_MODIFIER,
         when 16#003036# .. 16#003037# => SYMBOL_OTHER,
         when 16#003038# .. 16#00303A# => NUMBER_LETTER,
         when 16#00303B#               => LETTER_MODIFIER,
         when 16#00303C#               => LETTER_OTHER,
         when 16#00303D#               => PUNCTUATION_OTHER,
         when 16#00303E# .. 16#00303F# => SYMBOL_OTHER,
         when 16#003041# .. 16#003096# => LETTER_OTHER,
         when 16#003099# .. 16#00309A# => MARK_NONSPACING,
         when 16#00309B# .. 16#00309C# => SYMBOL_MODIFIER,
         when 16#00309D# .. 16#00309E# => LETTER_MODIFIER,
         when 16#00309F#               => LETTER_OTHER,
         when 16#0030A0#               => PUNCTUATION_DASH,
         when 16#0030A1# .. 16#0030FA# => LETTER_OTHER,
         when 16#0030FB#               => PUNCTUATION_OTHER,
         when 16#0030FC# .. 16#0030FE# => LETTER_MODIFIER,
         when 16#0030FF#               => LETTER_OTHER,
         when 16#003105# .. 16#00312F# => LETTER_OTHER,
         when 16#003131# .. 16#00318E# => LETTER_OTHER,
         when 16#003190# .. 16#003191# => SYMBOL_OTHER,
         when 16#003192# .. 16#003195# => NUMBER_OTHER,
         when 16#003196# .. 16#00319F# => SYMBOL_OTHER,
         when 16#0031A0# .. 16#0031BA# => LETTER_OTHER,
         when 16#0031C0# .. 16#0031E3# => SYMBOL_OTHER,
         when 16#0031F0# .. 16#0031FF# => LETTER_OTHER,
         when 16#003200# .. 16#00321E# => SYMBOL_OTHER,
         when 16#003220# .. 16#003229# => NUMBER_OTHER,
         when 16#00322A# .. 16#003247# => SYMBOL_OTHER,
         when 16#003248# .. 16#00324F# => NUMBER_OTHER,
         when 16#003250#               => SYMBOL_OTHER,
         when 16#003251# .. 16#00325F# => NUMBER_OTHER,
         when 16#003260# .. 16#00327F# => SYMBOL_OTHER,
         when 16#003280# .. 16#003289# => NUMBER_OTHER,
         when 16#00328A# .. 16#0032B0# => SYMBOL_OTHER,
         when 16#0032B1# .. 16#0032BF# => NUMBER_OTHER,
         when 16#0032C0# .. 16#0033FF# => SYMBOL_OTHER,
         when 16#003400# .. 16#004DB5# => LETTER_OTHER,
         when 16#004DC0# .. 16#004DFF# => SYMBOL_OTHER,
         when 16#004E00# .. 16#009FEF# => LETTER_OTHER,
         when 16#00A000# .. 16#00A014# => LETTER_OTHER,
         when 16#00A015#               => LETTER_MODIFIER,
         when 16#00A016# .. 16#00A48C# => LETTER_OTHER,
         when 16#00A490# .. 16#00A4C6# => SYMBOL_OTHER,
         when 16#00A4D0# .. 16#00A4F7# => LETTER_OTHER,
         when 16#00A4F8# .. 16#00A4FD# => LETTER_MODIFIER,
         when 16#00A4FE# .. 16#00A4FF# => PUNCTUATION_OTHER,
         when 16#00A500# .. 16#00A60B# => LETTER_OTHER,
         when 16#00A60C#               => LETTER_MODIFIER,
         when 16#00A60D# .. 16#00A60F# => PUNCTUATION_OTHER,
         when 16#00A610# .. 16#00A61F# => LETTER_OTHER,
         when 16#00A620# .. 16#00A629# => NUMBER_DECIMAL_DIGIT,
         when 16#00A62A# .. 16#00A62B# => LETTER_OTHER,
         when 16#00A640#               => LETTER_UPPERCASE,
         when 16#00A641#               => LETTER_LOWERCASE,
         when 16#00A642#               => LETTER_UPPERCASE,
         when 16#00A643#               => LETTER_LOWERCASE,
         when 16#00A644#               => LETTER_UPPERCASE,
         when 16#00A645#               => LETTER_LOWERCASE,
         when 16#00A646#               => LETTER_UPPERCASE,
         when 16#00A647#               => LETTER_LOWERCASE,
         when 16#00A648#               => LETTER_UPPERCASE,
         when 16#00A649#               => LETTER_LOWERCASE,
         when 16#00A64A#               => LETTER_UPPERCASE,
         when 16#00A64B#               => LETTER_LOWERCASE,
         when 16#00A64C#               => LETTER_UPPERCASE,
         when 16#00A64D#               => LETTER_LOWERCASE,
         when 16#00A64E#               => LETTER_UPPERCASE,
         when 16#00A64F#               => LETTER_LOWERCASE,
         when 16#00A650#               => LETTER_UPPERCASE,
         when 16#00A651#               => LETTER_LOWERCASE,
         when 16#00A652#               => LETTER_UPPERCASE,
         when 16#00A653#               => LETTER_LOWERCASE,
         when 16#00A654#               => LETTER_UPPERCASE,
         when 16#00A655#               => LETTER_LOWERCASE,
         when 16#00A656#               => LETTER_UPPERCASE,
         when 16#00A657#               => LETTER_LOWERCASE,
         when 16#00A658#               => LETTER_UPPERCASE,
         when 16#00A659#               => LETTER_LOWERCASE,
         when 16#00A65A#               => LETTER_UPPERCASE,
         when 16#00A65B#               => LETTER_LOWERCASE,
         when 16#00A65C#               => LETTER_UPPERCASE,
         when 16#00A65D#               => LETTER_LOWERCASE,
         when 16#00A65E#               => LETTER_UPPERCASE,
         when 16#00A65F#               => LETTER_LOWERCASE,
         when 16#00A660#               => LETTER_UPPERCASE,
         when 16#00A661#               => LETTER_LOWERCASE,
         when 16#00A662#               => LETTER_UPPERCASE,
         when 16#00A663#               => LETTER_LOWERCASE,
         when 16#00A664#               => LETTER_UPPERCASE,
         when 16#00A665#               => LETTER_LOWERCASE,
         when 16#00A666#               => LETTER_UPPERCASE,
         when 16#00A667#               => LETTER_LOWERCASE,
         when 16#00A668#               => LETTER_UPPERCASE,
         when 16#00A669#               => LETTER_LOWERCASE,
         when 16#00A66A#               => LETTER_UPPERCASE,
         when 16#00A66B#               => LETTER_LOWERCASE,
         when 16#00A66C#               => LETTER_UPPERCASE,
         when 16#00A66D#               => LETTER_LOWERCASE,
         when 16#00A66E#               => LETTER_OTHER,
         when 16#00A66F#               => MARK_NONSPACING,
         when 16#00A670# .. 16#00A672# => MARK_ENCLOSING,
         when 16#00A673#               => PUNCTUATION_OTHER,
         when 16#00A674# .. 16#00A67D# => MARK_NONSPACING,
         when 16#00A67E#               => PUNCTUATION_OTHER,
         when 16#00A67F#               => LETTER_MODIFIER,
         when 16#00A680#               => LETTER_UPPERCASE,
         when 16#00A681#               => LETTER_LOWERCASE,
         when 16#00A682#               => LETTER_UPPERCASE,
         when 16#00A683#               => LETTER_LOWERCASE,
         when 16#00A684#               => LETTER_UPPERCASE,
         when 16#00A685#               => LETTER_LOWERCASE,
         when 16#00A686#               => LETTER_UPPERCASE,
         when 16#00A687#               => LETTER_LOWERCASE,
         when 16#00A688#               => LETTER_UPPERCASE,
         when 16#00A689#               => LETTER_LOWERCASE,
         when 16#00A68A#               => LETTER_UPPERCASE,
         when 16#00A68B#               => LETTER_LOWERCASE,
         when 16#00A68C#               => LETTER_UPPERCASE,
         when 16#00A68D#               => LETTER_LOWERCASE,
         when 16#00A68E#               => LETTER_UPPERCASE,
         when 16#00A68F#               => LETTER_LOWERCASE,
         when 16#00A690#               => LETTER_UPPERCASE,
         when 16#00A691#               => LETTER_LOWERCASE,
         when 16#00A692#               => LETTER_UPPERCASE,
         when 16#00A693#               => LETTER_LOWERCASE,
         when 16#00A694#               => LETTER_UPPERCASE,
         when 16#00A695#               => LETTER_LOWERCASE,
         when 16#00A696#               => LETTER_UPPERCASE,
         when 16#00A697#               => LETTER_LOWERCASE,
         when 16#00A698#               => LETTER_UPPERCASE,
         when 16#00A699#               => LETTER_LOWERCASE,
         when 16#00A69A#               => LETTER_UPPERCASE,
         when 16#00A69B#               => LETTER_LOWERCASE,
         when 16#00A69C# .. 16#00A69D# => LETTER_MODIFIER,
         when 16#00A69E# .. 16#00A69F# => MARK_NONSPACING,
         when 16#00A6A0# .. 16#00A6E5# => LETTER_OTHER,
         when 16#00A6E6# .. 16#00A6EF# => NUMBER_LETTER,
         when 16#00A6F0# .. 16#00A6F1# => MARK_NONSPACING,
         when 16#00A6F2# .. 16#00A6F7# => PUNCTUATION_OTHER,
         when 16#00A700# .. 16#00A716# => SYMBOL_MODIFIER,
         when 16#00A717# .. 16#00A71F# => LETTER_MODIFIER,
         when 16#00A720# .. 16#00A721# => SYMBOL_MODIFIER,
         when 16#00A722#               => LETTER_UPPERCASE,
         when 16#00A723#               => LETTER_LOWERCASE,
         when 16#00A724#               => LETTER_UPPERCASE,
         when 16#00A725#               => LETTER_LOWERCASE,
         when 16#00A726#               => LETTER_UPPERCASE,
         when 16#00A727#               => LETTER_LOWERCASE,
         when 16#00A728#               => LETTER_UPPERCASE,
         when 16#00A729#               => LETTER_LOWERCASE,
         when 16#00A72A#               => LETTER_UPPERCASE,
         when 16#00A72B#               => LETTER_LOWERCASE,
         when 16#00A72C#               => LETTER_UPPERCASE,
         when 16#00A72D#               => LETTER_LOWERCASE,
         when 16#00A72E#               => LETTER_UPPERCASE,
         when 16#00A72F# .. 16#00A731# => LETTER_LOWERCASE,
         when 16#00A732#               => LETTER_UPPERCASE,
         when 16#00A733#               => LETTER_LOWERCASE,
         when 16#00A734#               => LETTER_UPPERCASE,
         when 16#00A735#               => LETTER_LOWERCASE,
         when 16#00A736#               => LETTER_UPPERCASE,
         when 16#00A737#               => LETTER_LOWERCASE,
         when 16#00A738#               => LETTER_UPPERCASE,
         when 16#00A739#               => LETTER_LOWERCASE,
         when 16#00A73A#               => LETTER_UPPERCASE,
         when 16#00A73B#               => LETTER_LOWERCASE,
         when 16#00A73C#               => LETTER_UPPERCASE,
         when 16#00A73D#               => LETTER_LOWERCASE,
         when 16#00A73E#               => LETTER_UPPERCASE,
         when 16#00A73F#               => LETTER_LOWERCASE,
         when 16#00A740#               => LETTER_UPPERCASE,
         when 16#00A741#               => LETTER_LOWERCASE,
         when 16#00A742#               => LETTER_UPPERCASE,
         when 16#00A743#               => LETTER_LOWERCASE,
         when 16#00A744#               => LETTER_UPPERCASE,
         when 16#00A745#               => LETTER_LOWERCASE,
         when 16#00A746#               => LETTER_UPPERCASE,
         when 16#00A747#               => LETTER_LOWERCASE,
         when 16#00A748#               => LETTER_UPPERCASE,
         when 16#00A749#               => LETTER_LOWERCASE,
         when 16#00A74A#               => LETTER_UPPERCASE,
         when 16#00A74B#               => LETTER_LOWERCASE,
         when 16#00A74C#               => LETTER_UPPERCASE,
         when 16#00A74D#               => LETTER_LOWERCASE,
         when 16#00A74E#               => LETTER_UPPERCASE,
         when 16#00A74F#               => LETTER_LOWERCASE,
         when 16#00A750#               => LETTER_UPPERCASE,
         when 16#00A751#               => LETTER_LOWERCASE,
         when 16#00A752#               => LETTER_UPPERCASE,
         when 16#00A753#               => LETTER_LOWERCASE,
         when 16#00A754#               => LETTER_UPPERCASE,
         when 16#00A755#               => LETTER_LOWERCASE,
         when 16#00A756#               => LETTER_UPPERCASE,
         when 16#00A757#               => LETTER_LOWERCASE,
         when 16#00A758#               => LETTER_UPPERCASE,
         when 16#00A759#               => LETTER_LOWERCASE,
         when 16#00A75A#               => LETTER_UPPERCASE,
         when 16#00A75B#               => LETTER_LOWERCASE,
         when 16#00A75C#               => LETTER_UPPERCASE,
         when 16#00A75D#               => LETTER_LOWERCASE,
         when 16#00A75E#               => LETTER_UPPERCASE,
         when 16#00A75F#               => LETTER_LOWERCASE,
         when 16#00A760#               => LETTER_UPPERCASE,
         when 16#00A761#               => LETTER_LOWERCASE,
         when 16#00A762#               => LETTER_UPPERCASE,
         when 16#00A763#               => LETTER_LOWERCASE,
         when 16#00A764#               => LETTER_UPPERCASE,
         when 16#00A765#               => LETTER_LOWERCASE,
         when 16#00A766#               => LETTER_UPPERCASE,
         when 16#00A767#               => LETTER_LOWERCASE,
         when 16#00A768#               => LETTER_UPPERCASE,
         when 16#00A769#               => LETTER_LOWERCASE,
         when 16#00A76A#               => LETTER_UPPERCASE,
         when 16#00A76B#               => LETTER_LOWERCASE,
         when 16#00A76C#               => LETTER_UPPERCASE,
         when 16#00A76D#               => LETTER_LOWERCASE,
         when 16#00A76E#               => LETTER_UPPERCASE,
         when 16#00A76F#               => LETTER_LOWERCASE,
         when 16#00A770#               => LETTER_MODIFIER,
         when 16#00A771# .. 16#00A778# => LETTER_LOWERCASE,
         when 16#00A779#               => LETTER_UPPERCASE,
         when 16#00A77A#               => LETTER_LOWERCASE,
         when 16#00A77B#               => LETTER_UPPERCASE,
         when 16#00A77C#               => LETTER_LOWERCASE,
         when 16#00A77D# .. 16#00A77E# => LETTER_UPPERCASE,
         when 16#00A77F#               => LETTER_LOWERCASE,
         when 16#00A780#               => LETTER_UPPERCASE,
         when 16#00A781#               => LETTER_LOWERCASE,
         when 16#00A782#               => LETTER_UPPERCASE,
         when 16#00A783#               => LETTER_LOWERCASE,
         when 16#00A784#               => LETTER_UPPERCASE,
         when 16#00A785#               => LETTER_LOWERCASE,
         when 16#00A786#               => LETTER_UPPERCASE,
         when 16#00A787#               => LETTER_LOWERCASE,
         when 16#00A788#               => LETTER_MODIFIER,
         when 16#00A789# .. 16#00A78A# => SYMBOL_MODIFIER,
         when 16#00A78B#               => LETTER_UPPERCASE,
         when 16#00A78C#               => LETTER_LOWERCASE,
         when 16#00A78D#               => LETTER_UPPERCASE,
         when 16#00A78E#               => LETTER_LOWERCASE,
         when 16#00A78F#               => LETTER_OTHER,
         when 16#00A790#               => LETTER_UPPERCASE,
         when 16#00A791#               => LETTER_LOWERCASE,
         when 16#00A792#               => LETTER_UPPERCASE,
         when 16#00A793# .. 16#00A795# => LETTER_LOWERCASE,
         when 16#00A796#               => LETTER_UPPERCASE,
         when 16#00A797#               => LETTER_LOWERCASE,
         when 16#00A798#               => LETTER_UPPERCASE,
         when 16#00A799#               => LETTER_LOWERCASE,
         when 16#00A79A#               => LETTER_UPPERCASE,
         when 16#00A79B#               => LETTER_LOWERCASE,
         when 16#00A79C#               => LETTER_UPPERCASE,
         when 16#00A79D#               => LETTER_LOWERCASE,
         when 16#00A79E#               => LETTER_UPPERCASE,
         when 16#00A79F#               => LETTER_LOWERCASE,
         when 16#00A7A0#               => LETTER_UPPERCASE,
         when 16#00A7A1#               => LETTER_LOWERCASE,
         when 16#00A7A2#               => LETTER_UPPERCASE,
         when 16#00A7A3#               => LETTER_LOWERCASE,
         when 16#00A7A4#               => LETTER_UPPERCASE,
         when 16#00A7A5#               => LETTER_LOWERCASE,
         when 16#00A7A6#               => LETTER_UPPERCASE,
         when 16#00A7A7#               => LETTER_LOWERCASE,
         when 16#00A7A8#               => LETTER_UPPERCASE,
         when 16#00A7A9#               => LETTER_LOWERCASE,
         when 16#00A7AA# .. 16#00A7AE# => LETTER_UPPERCASE,
         when 16#00A7AF#               => LETTER_LOWERCASE,
         when 16#00A7B0# .. 16#00A7B4# => LETTER_UPPERCASE,
         when 16#00A7B5#               => LETTER_LOWERCASE,
         when 16#00A7B6#               => LETTER_UPPERCASE,
         when 16#00A7B7#               => LETTER_LOWERCASE,
         when 16#00A7B8#               => LETTER_UPPERCASE,
         when 16#00A7B9#               => LETTER_LOWERCASE,
         when 16#00A7BA#               => LETTER_UPPERCASE,
         when 16#00A7BB#               => LETTER_LOWERCASE,
         when 16#00A7BC#               => LETTER_UPPERCASE,
         when 16#00A7BD#               => LETTER_LOWERCASE,
         when 16#00A7BE#               => LETTER_UPPERCASE,
         when 16#00A7BF#               => LETTER_LOWERCASE,
         when 16#00A7C2#               => LETTER_UPPERCASE,
         when 16#00A7C3#               => LETTER_LOWERCASE,
         when 16#00A7C4# .. 16#00A7C6# => LETTER_UPPERCASE,
         when 16#00A7F7#               => LETTER_OTHER,
         when 16#00A7F8# .. 16#00A7F9# => LETTER_MODIFIER,
         when 16#00A7FA#               => LETTER_LOWERCASE,
         when 16#00A7FB# .. 16#00A801# => LETTER_OTHER,
         when 16#00A802#               => MARK_NONSPACING,
         when 16#00A803# .. 16#00A805# => LETTER_OTHER,
         when 16#00A806#               => MARK_NONSPACING,
         when 16#00A807# .. 16#00A80A# => LETTER_OTHER,
         when 16#00A80B#               => MARK_NONSPACING,
         when 16#00A80C# .. 16#00A822# => LETTER_OTHER,
         when 16#00A823# .. 16#00A824# => MARK_SPACING_COMBINING,
         when 16#00A825# .. 16#00A826# => MARK_NONSPACING,
         when 16#00A827#               => MARK_SPACING_COMBINING,
         when 16#00A828# .. 16#00A82B# => SYMBOL_OTHER,
         when 16#00A830# .. 16#00A835# => NUMBER_OTHER,
         when 16#00A836# .. 16#00A837# => SYMBOL_OTHER,
         when 16#00A838#               => SYMBOL_CURRENCY,
         when 16#00A839#               => SYMBOL_OTHER,
         when 16#00A840# .. 16#00A873# => LETTER_OTHER,
         when 16#00A874# .. 16#00A877# => PUNCTUATION_OTHER,
         when 16#00A880# .. 16#00A881# => MARK_SPACING_COMBINING,
         when 16#00A882# .. 16#00A8B3# => LETTER_OTHER,
         when 16#00A8B4# .. 16#00A8C3# => MARK_SPACING_COMBINING,
         when 16#00A8C4# .. 16#00A8C5# => MARK_NONSPACING,
         when 16#00A8CE# .. 16#00A8CF# => PUNCTUATION_OTHER,
         when 16#00A8D0# .. 16#00A8D9# => NUMBER_DECIMAL_DIGIT,
         when 16#00A8E0# .. 16#00A8F1# => MARK_NONSPACING,
         when 16#00A8F2# .. 16#00A8F7# => LETTER_OTHER,
         when 16#00A8F8# .. 16#00A8FA# => PUNCTUATION_OTHER,
         when 16#00A8FB#               => LETTER_OTHER,
         when 16#00A8FC#               => PUNCTUATION_OTHER,
         when 16#00A8FD# .. 16#00A8FE# => LETTER_OTHER,
         when 16#00A8FF#               => MARK_NONSPACING,
         when 16#00A900# .. 16#00A909# => NUMBER_DECIMAL_DIGIT,
         when 16#00A90A# .. 16#00A925# => LETTER_OTHER,
         when 16#00A926# .. 16#00A92D# => MARK_NONSPACING,
         when 16#00A92E# .. 16#00A92F# => PUNCTUATION_OTHER,
         when 16#00A930# .. 16#00A946# => LETTER_OTHER,
         when 16#00A947# .. 16#00A951# => MARK_NONSPACING,
         when 16#00A952# .. 16#00A953# => MARK_SPACING_COMBINING,
         when 16#00A95F#               => PUNCTUATION_OTHER,
         when 16#00A960# .. 16#00A97C# => LETTER_OTHER,
         when 16#00A980# .. 16#00A982# => MARK_NONSPACING,
         when 16#00A983#               => MARK_SPACING_COMBINING,
         when 16#00A984# .. 16#00A9B2# => LETTER_OTHER,
         when 16#00A9B3#               => MARK_NONSPACING,
         when 16#00A9B4# .. 16#00A9B5# => MARK_SPACING_COMBINING,
         when 16#00A9B6# .. 16#00A9B9# => MARK_NONSPACING,
         when 16#00A9BA# .. 16#00A9BB# => MARK_SPACING_COMBINING,
         when 16#00A9BC# .. 16#00A9BD# => MARK_NONSPACING,
         when 16#00A9BE# .. 16#00A9C0# => MARK_SPACING_COMBINING,
         when 16#00A9C1# .. 16#00A9CD# => PUNCTUATION_OTHER,
         when 16#00A9CF#               => LETTER_MODIFIER,
         when 16#00A9D0# .. 16#00A9D9# => NUMBER_DECIMAL_DIGIT,
         when 16#00A9DE# .. 16#00A9DF# => PUNCTUATION_OTHER,
         when 16#00A9E0# .. 16#00A9E4# => LETTER_OTHER,
         when 16#00A9E5#               => MARK_NONSPACING,
         when 16#00A9E6#               => LETTER_MODIFIER,
         when 16#00A9E7# .. 16#00A9EF# => LETTER_OTHER,
         when 16#00A9F0# .. 16#00A9F9# => NUMBER_DECIMAL_DIGIT,
         when 16#00A9FA# .. 16#00A9FE# => LETTER_OTHER,
         when 16#00AA00# .. 16#00AA28# => LETTER_OTHER,
         when 16#00AA29# .. 16#00AA2E# => MARK_NONSPACING,
         when 16#00AA2F# .. 16#00AA30# => MARK_SPACING_COMBINING,
         when 16#00AA31# .. 16#00AA32# => MARK_NONSPACING,
         when 16#00AA33# .. 16#00AA34# => MARK_SPACING_COMBINING,
         when 16#00AA35# .. 16#00AA36# => MARK_NONSPACING,
         when 16#00AA40# .. 16#00AA42# => LETTER_OTHER,
         when 16#00AA43#               => MARK_NONSPACING,
         when 16#00AA44# .. 16#00AA4B# => LETTER_OTHER,
         when 16#00AA4C#               => MARK_NONSPACING,
         when 16#00AA4D#               => MARK_SPACING_COMBINING,
         when 16#00AA50# .. 16#00AA59# => NUMBER_DECIMAL_DIGIT,
         when 16#00AA5C# .. 16#00AA5F# => PUNCTUATION_OTHER,
         when 16#00AA60# .. 16#00AA6F# => LETTER_OTHER,
         when 16#00AA70#               => LETTER_MODIFIER,
         when 16#00AA71# .. 16#00AA76# => LETTER_OTHER,
         when 16#00AA77# .. 16#00AA79# => SYMBOL_OTHER,
         when 16#00AA7A#               => LETTER_OTHER,
         when 16#00AA7B#               => MARK_SPACING_COMBINING,
         when 16#00AA7C#               => MARK_NONSPACING,
         when 16#00AA7D#               => MARK_SPACING_COMBINING,
         when 16#00AA7E# .. 16#00AAAF# => LETTER_OTHER,
         when 16#00AAB0#               => MARK_NONSPACING,
         when 16#00AAB1#               => LETTER_OTHER,
         when 16#00AAB2# .. 16#00AAB4# => MARK_NONSPACING,
         when 16#00AAB5# .. 16#00AAB6# => LETTER_OTHER,
         when 16#00AAB7# .. 16#00AAB8# => MARK_NONSPACING,
         when 16#00AAB9# .. 16#00AABD# => LETTER_OTHER,
         when 16#00AABE# .. 16#00AABF# => MARK_NONSPACING,
         when 16#00AAC0#               => LETTER_OTHER,
         when 16#00AAC1#               => MARK_NONSPACING,
         when 16#00AAC2#               => LETTER_OTHER,
         when 16#00AADB# .. 16#00AADC# => LETTER_OTHER,
         when 16#00AADD#               => LETTER_MODIFIER,
         when 16#00AADE# .. 16#00AADF# => PUNCTUATION_OTHER,
         when 16#00AAE0# .. 16#00AAEA# => LETTER_OTHER,
         when 16#00AAEB#               => MARK_SPACING_COMBINING,
         when 16#00AAEC# .. 16#00AAED# => MARK_NONSPACING,
         when 16#00AAEE# .. 16#00AAEF# => MARK_SPACING_COMBINING,
         when 16#00AAF0# .. 16#00AAF1# => PUNCTUATION_OTHER,
         when 16#00AAF2#               => LETTER_OTHER,
         when 16#00AAF3# .. 16#00AAF4# => LETTER_MODIFIER,
         when 16#00AAF5#               => MARK_SPACING_COMBINING,
         when 16#00AAF6#               => MARK_NONSPACING,
         when 16#00AB01# .. 16#00AB06# => LETTER_OTHER,
         when 16#00AB09# .. 16#00AB0E# => LETTER_OTHER,
         when 16#00AB11# .. 16#00AB16# => LETTER_OTHER,
         when 16#00AB20# .. 16#00AB26# => LETTER_OTHER,
         when 16#00AB28# .. 16#00AB2E# => LETTER_OTHER,
         when 16#00AB30# .. 16#00AB5A# => LETTER_LOWERCASE,
         when 16#00AB5B#               => SYMBOL_MODIFIER,
         when 16#00AB5C# .. 16#00AB5F# => LETTER_MODIFIER,
         when 16#00AB60# .. 16#00AB67# => LETTER_LOWERCASE,
         when 16#00AB70# .. 16#00ABBF# => LETTER_LOWERCASE,
         when 16#00ABC0# .. 16#00ABE2# => LETTER_OTHER,
         when 16#00ABE3# .. 16#00ABE4# => MARK_SPACING_COMBINING,
         when 16#00ABE5#               => MARK_NONSPACING,
         when 16#00ABE6# .. 16#00ABE7# => MARK_SPACING_COMBINING,
         when 16#00ABE8#               => MARK_NONSPACING,
         when 16#00ABE9# .. 16#00ABEA# => MARK_SPACING_COMBINING,
         when 16#00ABEB#               => PUNCTUATION_OTHER,
         when 16#00ABEC#               => MARK_SPACING_COMBINING,
         when 16#00ABED#               => MARK_NONSPACING,
         when 16#00ABF0# .. 16#00ABF9# => NUMBER_DECIMAL_DIGIT,
         when 16#00AC00# .. 16#00D7A3# => LETTER_OTHER,
         when 16#00D7B0# .. 16#00D7C6# => LETTER_OTHER,
         when 16#00D7CB# .. 16#00D7FB# => LETTER_OTHER,
         when 16#00D800# .. 16#00DFFF# => OTHER_SURROGATE,
         when 16#00E000# .. 16#00F8FF# => OTHER_PRIVATE_USE,
         when 16#00F900# .. 16#00FA6D# => LETTER_OTHER,
         when 16#00FA70# .. 16#00FAD9# => LETTER_OTHER,
         when 16#00FB00# .. 16#00FB06# => LETTER_LOWERCASE,
         when 16#00FB13# .. 16#00FB17# => LETTER_LOWERCASE,
         when 16#00FB1D#               => LETTER_OTHER,
         when 16#00FB1E#               => MARK_NONSPACING,
         when 16#00FB1F# .. 16#00FB28# => LETTER_OTHER,
         when 16#00FB29#               => SYMBOL_MATH,
         when 16#00FB2A# .. 16#00FB36# => LETTER_OTHER,
         when 16#00FB38# .. 16#00FB3C# => LETTER_OTHER,
         when 16#00FB3E#               => LETTER_OTHER,
         when 16#00FB40# .. 16#00FB41# => LETTER_OTHER,
         when 16#00FB43# .. 16#00FB44# => LETTER_OTHER,
         when 16#00FB46# .. 16#00FBB1# => LETTER_OTHER,
         when 16#00FBB2# .. 16#00FBC1# => SYMBOL_MODIFIER,
         when 16#00FBD3# .. 16#00FD3D# => LETTER_OTHER,
         when 16#00FD3E#               => PUNCTUATION_CLOSE,
         when 16#00FD3F#               => PUNCTUATION_OPEN,
         when 16#00FD50# .. 16#00FD8F# => LETTER_OTHER,
         when 16#00FD92# .. 16#00FDC7# => LETTER_OTHER,
         when 16#00FDF0# .. 16#00FDFB# => LETTER_OTHER,
         when 16#00FDFC#               => SYMBOL_CURRENCY,
         when 16#00FDFD#               => SYMBOL_OTHER,
         when 16#00FE00# .. 16#00FE0F# => MARK_NONSPACING,
         when 16#00FE10# .. 16#00FE16# => PUNCTUATION_OTHER,
         when 16#00FE17#               => PUNCTUATION_OPEN,
         when 16#00FE18#               => PUNCTUATION_CLOSE,
         when 16#00FE19#               => PUNCTUATION_OTHER,
         when 16#00FE20# .. 16#00FE2F# => MARK_NONSPACING,
         when 16#00FE30#               => PUNCTUATION_OTHER,
         when 16#00FE31# .. 16#00FE32# => PUNCTUATION_DASH,
         when 16#00FE33# .. 16#00FE34# => PUNCTUATION_CONNECTOR,
         when 16#00FE35#               => PUNCTUATION_OPEN,
         when 16#00FE36#               => PUNCTUATION_CLOSE,
         when 16#00FE37#               => PUNCTUATION_OPEN,
         when 16#00FE38#               => PUNCTUATION_CLOSE,
         when 16#00FE39#               => PUNCTUATION_OPEN,
         when 16#00FE3A#               => PUNCTUATION_CLOSE,
         when 16#00FE3B#               => PUNCTUATION_OPEN,
         when 16#00FE3C#               => PUNCTUATION_CLOSE,
         when 16#00FE3D#               => PUNCTUATION_OPEN,
         when 16#00FE3E#               => PUNCTUATION_CLOSE,
         when 16#00FE3F#               => PUNCTUATION_OPEN,
         when 16#00FE40#               => PUNCTUATION_CLOSE,
         when 16#00FE41#               => PUNCTUATION_OPEN,
         when 16#00FE42#               => PUNCTUATION_CLOSE,
         when 16#00FE43#               => PUNCTUATION_OPEN,
         when 16#00FE44#               => PUNCTUATION_CLOSE,
         when 16#00FE45# .. 16#00FE46# => PUNCTUATION_OTHER,
         when 16#00FE47#               => PUNCTUATION_OPEN,
         when 16#00FE48#               => PUNCTUATION_CLOSE,
         when 16#00FE49# .. 16#00FE4C# => PUNCTUATION_OTHER,
         when 16#00FE4D# .. 16#00FE4F# => PUNCTUATION_CONNECTOR,
         when 16#00FE50# .. 16#00FE52# => PUNCTUATION_OTHER,
         when 16#00FE54# .. 16#00FE57# => PUNCTUATION_OTHER,
         when 16#00FE58#               => PUNCTUATION_DASH,
         when 16#00FE59#               => PUNCTUATION_OPEN,
         when 16#00FE5A#               => PUNCTUATION_CLOSE,
         when 16#00FE5B#               => PUNCTUATION_OPEN,
         when 16#00FE5C#               => PUNCTUATION_CLOSE,
         when 16#00FE5D#               => PUNCTUATION_OPEN,
         when 16#00FE5E#               => PUNCTUATION_CLOSE,
         when 16#00FE5F# .. 16#00FE61# => PUNCTUATION_OTHER,
         when 16#00FE62#               => SYMBOL_MATH,
         when 16#00FE63#               => PUNCTUATION_DASH,
         when 16#00FE64# .. 16#00FE66# => SYMBOL_MATH,
         when 16#00FE68#               => PUNCTUATION_OTHER,
         when 16#00FE69#               => SYMBOL_CURRENCY,
         when 16#00FE6A# .. 16#00FE6B# => PUNCTUATION_OTHER,
         when 16#00FE70# .. 16#00FE74# => LETTER_OTHER,
         when 16#00FE76# .. 16#00FEFC# => LETTER_OTHER,
         when 16#00FEFF#               => OTHER_FORMAT,
         when 16#00FF01# .. 16#00FF03# => PUNCTUATION_OTHER,
         when 16#00FF04#               => SYMBOL_CURRENCY,
         when 16#00FF05# .. 16#00FF07# => PUNCTUATION_OTHER,
         when 16#00FF08#               => PUNCTUATION_OPEN,
         when 16#00FF09#               => PUNCTUATION_CLOSE,
         when 16#00FF0A#               => PUNCTUATION_OTHER,
         when 16#00FF0B#               => SYMBOL_MATH,
         when 16#00FF0C#               => PUNCTUATION_OTHER,
         when 16#00FF0D#               => PUNCTUATION_DASH,
         when 16#00FF0E# .. 16#00FF0F# => PUNCTUATION_OTHER,
         when 16#00FF10# .. 16#00FF19# => NUMBER_DECIMAL_DIGIT,
         when 16#00FF1A# .. 16#00FF1B# => PUNCTUATION_OTHER,
         when 16#00FF1C# .. 16#00FF1E# => SYMBOL_MATH,
         when 16#00FF1F# .. 16#00FF20# => PUNCTUATION_OTHER,
         when 16#00FF21# .. 16#00FF3A# => LETTER_UPPERCASE,
         when 16#00FF3B#               => PUNCTUATION_OPEN,
         when 16#00FF3C#               => PUNCTUATION_OTHER,
         when 16#00FF3D#               => PUNCTUATION_CLOSE,
         when 16#00FF3E#               => SYMBOL_MODIFIER,
         when 16#00FF3F#               => PUNCTUATION_CONNECTOR,
         when 16#00FF40#               => SYMBOL_MODIFIER,
         when 16#00FF41# .. 16#00FF5A# => LETTER_LOWERCASE,
         when 16#00FF5B#               => PUNCTUATION_OPEN,
         when 16#00FF5C#               => SYMBOL_MATH,
         when 16#00FF5D#               => PUNCTUATION_CLOSE,
         when 16#00FF5E#               => SYMBOL_MATH,
         when 16#00FF5F#               => PUNCTUATION_OPEN,
         when 16#00FF60#               => PUNCTUATION_CLOSE,
         when 16#00FF61#               => PUNCTUATION_OTHER,
         when 16#00FF62#               => PUNCTUATION_OPEN,
         when 16#00FF63#               => PUNCTUATION_CLOSE,
         when 16#00FF64# .. 16#00FF65# => PUNCTUATION_OTHER,
         when 16#00FF66# .. 16#00FF6F# => LETTER_OTHER,
         when 16#00FF70#               => LETTER_MODIFIER,
         when 16#00FF71# .. 16#00FF9D# => LETTER_OTHER,
         when 16#00FF9E# .. 16#00FF9F# => LETTER_MODIFIER,
         when 16#00FFA0# .. 16#00FFBE# => LETTER_OTHER,
         when 16#00FFC2# .. 16#00FFC7# => LETTER_OTHER,
         when 16#00FFCA# .. 16#00FFCF# => LETTER_OTHER,
         when 16#00FFD2# .. 16#00FFD7# => LETTER_OTHER,
         when 16#00FFDA# .. 16#00FFDC# => LETTER_OTHER,
         when 16#00FFE0# .. 16#00FFE1# => SYMBOL_CURRENCY,
         when 16#00FFE2#               => SYMBOL_MATH,
         when 16#00FFE3#               => SYMBOL_MODIFIER,
         when 16#00FFE4#               => SYMBOL_OTHER,
         when 16#00FFE5# .. 16#00FFE6# => SYMBOL_CURRENCY,
         when 16#00FFE8#               => SYMBOL_OTHER,
         when 16#00FFE9# .. 16#00FFEC# => SYMBOL_MATH,
         when 16#00FFED# .. 16#00FFEE# => SYMBOL_OTHER,
         when 16#00FFF9# .. 16#00FFFB# => OTHER_FORMAT,
         when 16#00FFFC# .. 16#00FFFD# => SYMBOL_OTHER,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;

   function Plane_01_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#010000# .. 16#01000B# => LETTER_OTHER,
         when 16#01000D# .. 16#010026# => LETTER_OTHER,
         when 16#010028# .. 16#01003A# => LETTER_OTHER,
         when 16#01003C# .. 16#01003D# => LETTER_OTHER,
         when 16#01003F# .. 16#01004D# => LETTER_OTHER,
         when 16#010050# .. 16#01005D# => LETTER_OTHER,
         when 16#010080# .. 16#0100FA# => LETTER_OTHER,
         when 16#010100# .. 16#010102# => PUNCTUATION_OTHER,
         when 16#010107# .. 16#010133# => NUMBER_OTHER,
         when 16#010137# .. 16#01013F# => SYMBOL_OTHER,
         when 16#010140# .. 16#010174# => NUMBER_LETTER,
         when 16#010175# .. 16#010178# => NUMBER_OTHER,
         when 16#010179# .. 16#010189# => SYMBOL_OTHER,
         when 16#01018A# .. 16#01018B# => NUMBER_OTHER,
         when 16#01018C# .. 16#01018E# => SYMBOL_OTHER,
         when 16#010190# .. 16#01019B# => SYMBOL_OTHER,
         when 16#0101A0#               => SYMBOL_OTHER,
         when 16#0101D0# .. 16#0101FC# => SYMBOL_OTHER,
         when 16#0101FD#               => MARK_NONSPACING,
         when 16#010280# .. 16#01029C# => LETTER_OTHER,
         when 16#0102A0# .. 16#0102D0# => LETTER_OTHER,
         when 16#0102E0#               => MARK_NONSPACING,
         when 16#0102E1# .. 16#0102FB# => NUMBER_OTHER,
         when 16#010300# .. 16#01031F# => LETTER_OTHER,
         when 16#010320# .. 16#010323# => NUMBER_OTHER,
         when 16#01032D# .. 16#010340# => LETTER_OTHER,
         when 16#010341#               => NUMBER_LETTER,
         when 16#010342# .. 16#010349# => LETTER_OTHER,
         when 16#01034A#               => NUMBER_LETTER,
         when 16#010350# .. 16#010375# => LETTER_OTHER,
         when 16#010376# .. 16#01037A# => MARK_NONSPACING,
         when 16#010380# .. 16#01039D# => LETTER_OTHER,
         when 16#01039F#               => PUNCTUATION_OTHER,
         when 16#0103A0# .. 16#0103C3# => LETTER_OTHER,
         when 16#0103C8# .. 16#0103CF# => LETTER_OTHER,
         when 16#0103D0#               => PUNCTUATION_OTHER,
         when 16#0103D1# .. 16#0103D5# => NUMBER_LETTER,
         when 16#010400# .. 16#010427# => LETTER_UPPERCASE,
         when 16#010428# .. 16#01044F# => LETTER_LOWERCASE,
         when 16#010450# .. 16#01049D# => LETTER_OTHER,
         when 16#0104A0# .. 16#0104A9# => NUMBER_DECIMAL_DIGIT,
         when 16#0104B0# .. 16#0104D3# => LETTER_UPPERCASE,
         when 16#0104D8# .. 16#0104FB# => LETTER_LOWERCASE,
         when 16#010500# .. 16#010527# => LETTER_OTHER,
         when 16#010530# .. 16#010563# => LETTER_OTHER,
         when 16#01056F#               => PUNCTUATION_OTHER,
         when 16#010600# .. 16#010736# => LETTER_OTHER,
         when 16#010740# .. 16#010755# => LETTER_OTHER,
         when 16#010760# .. 16#010767# => LETTER_OTHER,
         when 16#010800# .. 16#010805# => LETTER_OTHER,
         when 16#010808#               => LETTER_OTHER,
         when 16#01080A# .. 16#010835# => LETTER_OTHER,
         when 16#010837# .. 16#010838# => LETTER_OTHER,
         when 16#01083C#               => LETTER_OTHER,
         when 16#01083F# .. 16#010855# => LETTER_OTHER,
         when 16#010857#               => PUNCTUATION_OTHER,
         when 16#010858# .. 16#01085F# => NUMBER_OTHER,
         when 16#010860# .. 16#010876# => LETTER_OTHER,
         when 16#010877# .. 16#010878# => SYMBOL_OTHER,
         when 16#010879# .. 16#01087F# => NUMBER_OTHER,
         when 16#010880# .. 16#01089E# => LETTER_OTHER,
         when 16#0108A7# .. 16#0108AF# => NUMBER_OTHER,
         when 16#0108E0# .. 16#0108F2# => LETTER_OTHER,
         when 16#0108F4# .. 16#0108F5# => LETTER_OTHER,
         when 16#0108FB# .. 16#0108FF# => NUMBER_OTHER,
         when 16#010900# .. 16#010915# => LETTER_OTHER,
         when 16#010916# .. 16#01091B# => NUMBER_OTHER,
         when 16#01091F#               => PUNCTUATION_OTHER,
         when 16#010920# .. 16#010939# => LETTER_OTHER,
         when 16#01093F#               => PUNCTUATION_OTHER,
         when 16#010980# .. 16#0109B7# => LETTER_OTHER,
         when 16#0109BC# .. 16#0109BD# => NUMBER_OTHER,
         when 16#0109BE# .. 16#0109BF# => LETTER_OTHER,
         when 16#0109C0# .. 16#0109CF# => NUMBER_OTHER,
         when 16#0109D2# .. 16#0109FF# => NUMBER_OTHER,
         when 16#010A00#               => LETTER_OTHER,
         when 16#010A01# .. 16#010A03# => MARK_NONSPACING,
         when 16#010A05# .. 16#010A06# => MARK_NONSPACING,
         when 16#010A0C# .. 16#010A0F# => MARK_NONSPACING,
         when 16#010A10# .. 16#010A13# => LETTER_OTHER,
         when 16#010A15# .. 16#010A17# => LETTER_OTHER,
         when 16#010A19# .. 16#010A35# => LETTER_OTHER,
         when 16#010A38# .. 16#010A3A# => MARK_NONSPACING,
         when 16#010A3F#               => MARK_NONSPACING,
         when 16#010A40# .. 16#010A48# => NUMBER_OTHER,
         when 16#010A50# .. 16#010A58# => PUNCTUATION_OTHER,
         when 16#010A60# .. 16#010A7C# => LETTER_OTHER,
         when 16#010A7D# .. 16#010A7E# => NUMBER_OTHER,
         when 16#010A7F#               => PUNCTUATION_OTHER,
         when 16#010A80# .. 16#010A9C# => LETTER_OTHER,
         when 16#010A9D# .. 16#010A9F# => NUMBER_OTHER,
         when 16#010AC0# .. 16#010AC7# => LETTER_OTHER,
         when 16#010AC8#               => SYMBOL_OTHER,
         when 16#010AC9# .. 16#010AE4# => LETTER_OTHER,
         when 16#010AE5# .. 16#010AE6# => MARK_NONSPACING,
         when 16#010AEB# .. 16#010AEF# => NUMBER_OTHER,
         when 16#010AF0# .. 16#010AF6# => PUNCTUATION_OTHER,
         when 16#010B00# .. 16#010B35# => LETTER_OTHER,
         when 16#010B39# .. 16#010B3F# => PUNCTUATION_OTHER,
         when 16#010B40# .. 16#010B55# => LETTER_OTHER,
         when 16#010B58# .. 16#010B5F# => NUMBER_OTHER,
         when 16#010B60# .. 16#010B72# => LETTER_OTHER,
         when 16#010B78# .. 16#010B7F# => NUMBER_OTHER,
         when 16#010B80# .. 16#010B91# => LETTER_OTHER,
         when 16#010B99# .. 16#010B9C# => PUNCTUATION_OTHER,
         when 16#010BA9# .. 16#010BAF# => NUMBER_OTHER,
         when 16#010C00# .. 16#010C48# => LETTER_OTHER,
         when 16#010C80# .. 16#010CB2# => LETTER_UPPERCASE,
         when 16#010CC0# .. 16#010CF2# => LETTER_LOWERCASE,
         when 16#010CFA# .. 16#010CFF# => NUMBER_OTHER,
         when 16#010D00# .. 16#010D23# => LETTER_OTHER,
         when 16#010D24# .. 16#010D27# => MARK_NONSPACING,
         when 16#010D30# .. 16#010D39# => NUMBER_DECIMAL_DIGIT,
         when 16#010E60# .. 16#010E7E# => NUMBER_OTHER,
         when 16#010F00# .. 16#010F1C# => LETTER_OTHER,
         when 16#010F1D# .. 16#010F26# => NUMBER_OTHER,
         when 16#010F27#               => LETTER_OTHER,
         when 16#010F30# .. 16#010F45# => LETTER_OTHER,
         when 16#010F46# .. 16#010F50# => MARK_NONSPACING,
         when 16#010F51# .. 16#010F54# => NUMBER_OTHER,
         when 16#010F55# .. 16#010F59# => PUNCTUATION_OTHER,
         when 16#010FE0# .. 16#010FF6# => LETTER_OTHER,
         when 16#011000#               => MARK_SPACING_COMBINING,
         when 16#011001#               => MARK_NONSPACING,
         when 16#011002#               => MARK_SPACING_COMBINING,
         when 16#011003# .. 16#011037# => LETTER_OTHER,
         when 16#011038# .. 16#011046# => MARK_NONSPACING,
         when 16#011047# .. 16#01104D# => PUNCTUATION_OTHER,
         when 16#011052# .. 16#011065# => NUMBER_OTHER,
         when 16#011066# .. 16#01106F# => NUMBER_DECIMAL_DIGIT,
         when 16#01107F# .. 16#011081# => MARK_NONSPACING,
         when 16#011082#               => MARK_SPACING_COMBINING,
         when 16#011083# .. 16#0110AF# => LETTER_OTHER,
         when 16#0110B0# .. 16#0110B2# => MARK_SPACING_COMBINING,
         when 16#0110B3# .. 16#0110B6# => MARK_NONSPACING,
         when 16#0110B7# .. 16#0110B8# => MARK_SPACING_COMBINING,
         when 16#0110B9# .. 16#0110BA# => MARK_NONSPACING,
         when 16#0110BB# .. 16#0110BC# => PUNCTUATION_OTHER,
         when 16#0110BD#               => OTHER_FORMAT,
         when 16#0110BE# .. 16#0110C1# => PUNCTUATION_OTHER,
         when 16#0110CD#               => OTHER_FORMAT,
         when 16#0110D0# .. 16#0110E8# => LETTER_OTHER,
         when 16#0110F0# .. 16#0110F9# => NUMBER_DECIMAL_DIGIT,
         when 16#011100# .. 16#011102# => MARK_NONSPACING,
         when 16#011103# .. 16#011126# => LETTER_OTHER,
         when 16#011127# .. 16#01112B# => MARK_NONSPACING,
         when 16#01112C#               => MARK_SPACING_COMBINING,
         when 16#01112D# .. 16#011134# => MARK_NONSPACING,
         when 16#011136# .. 16#01113F# => NUMBER_DECIMAL_DIGIT,
         when 16#011140# .. 16#011143# => PUNCTUATION_OTHER,
         when 16#011144#               => LETTER_OTHER,
         when 16#011145# .. 16#011146# => MARK_SPACING_COMBINING,
         when 16#011150# .. 16#011172# => LETTER_OTHER,
         when 16#011173#               => MARK_NONSPACING,
         when 16#011174# .. 16#011175# => PUNCTUATION_OTHER,
         when 16#011176#               => LETTER_OTHER,
         when 16#011180# .. 16#011181# => MARK_NONSPACING,
         when 16#011182#               => MARK_SPACING_COMBINING,
         when 16#011183# .. 16#0111B2# => LETTER_OTHER,
         when 16#0111B3# .. 16#0111B5# => MARK_SPACING_COMBINING,
         when 16#0111B6# .. 16#0111BE# => MARK_NONSPACING,
         when 16#0111BF# .. 16#0111C0# => MARK_SPACING_COMBINING,
         when 16#0111C1# .. 16#0111C4# => LETTER_OTHER,
         when 16#0111C5# .. 16#0111C8# => PUNCTUATION_OTHER,
         when 16#0111C9# .. 16#0111CC# => MARK_NONSPACING,
         when 16#0111CD#               => PUNCTUATION_OTHER,
         when 16#0111D0# .. 16#0111D9# => NUMBER_DECIMAL_DIGIT,
         when 16#0111DA#               => LETTER_OTHER,
         when 16#0111DB#               => PUNCTUATION_OTHER,
         when 16#0111DC#               => LETTER_OTHER,
         when 16#0111DD# .. 16#0111DF# => PUNCTUATION_OTHER,
         when 16#0111E1# .. 16#0111F4# => NUMBER_OTHER,
         when 16#011200# .. 16#011211# => LETTER_OTHER,
         when 16#011213# .. 16#01122B# => LETTER_OTHER,
         when 16#01122C# .. 16#01122E# => MARK_SPACING_COMBINING,
         when 16#01122F# .. 16#011231# => MARK_NONSPACING,
         when 16#011232# .. 16#011233# => MARK_SPACING_COMBINING,
         when 16#011234#               => MARK_NONSPACING,
         when 16#011235#               => MARK_SPACING_COMBINING,
         when 16#011236# .. 16#011237# => MARK_NONSPACING,
         when 16#011238# .. 16#01123D# => PUNCTUATION_OTHER,
         when 16#01123E#               => MARK_NONSPACING,
         when 16#011280# .. 16#011286# => LETTER_OTHER,
         when 16#011288#               => LETTER_OTHER,
         when 16#01128A# .. 16#01128D# => LETTER_OTHER,
         when 16#01128F# .. 16#01129D# => LETTER_OTHER,
         when 16#01129F# .. 16#0112A8# => LETTER_OTHER,
         when 16#0112A9#               => PUNCTUATION_OTHER,
         when 16#0112B0# .. 16#0112DE# => LETTER_OTHER,
         when 16#0112DF#               => MARK_NONSPACING,
         when 16#0112E0# .. 16#0112E2# => MARK_SPACING_COMBINING,
         when 16#0112E3# .. 16#0112EA# => MARK_NONSPACING,
         when 16#0112F0# .. 16#0112F9# => NUMBER_DECIMAL_DIGIT,
         when 16#011300# .. 16#011301# => MARK_NONSPACING,
         when 16#011302# .. 16#011303# => MARK_SPACING_COMBINING,
         when 16#011305# .. 16#01130C# => LETTER_OTHER,
         when 16#01130F# .. 16#011310# => LETTER_OTHER,
         when 16#011313# .. 16#011328# => LETTER_OTHER,
         when 16#01132A# .. 16#011330# => LETTER_OTHER,
         when 16#011332# .. 16#011333# => LETTER_OTHER,
         when 16#011335# .. 16#011339# => LETTER_OTHER,
         when 16#01133B# .. 16#01133C# => MARK_NONSPACING,
         when 16#01133D#               => LETTER_OTHER,
         when 16#01133E# .. 16#01133F# => MARK_SPACING_COMBINING,
         when 16#011340#               => MARK_NONSPACING,
         when 16#011341# .. 16#011344# => MARK_SPACING_COMBINING,
         when 16#011347# .. 16#011348# => MARK_SPACING_COMBINING,
         when 16#01134B# .. 16#01134D# => MARK_SPACING_COMBINING,
         when 16#011350#               => LETTER_OTHER,
         when 16#011357#               => MARK_SPACING_COMBINING,
         when 16#01135D# .. 16#011361# => LETTER_OTHER,
         when 16#011362# .. 16#011363# => MARK_SPACING_COMBINING,
         when 16#011366# .. 16#01136C# => MARK_NONSPACING,
         when 16#011370# .. 16#011374# => MARK_NONSPACING,
         when 16#011400# .. 16#011434# => LETTER_OTHER,
         when 16#011435# .. 16#011437# => MARK_SPACING_COMBINING,
         when 16#011438# .. 16#01143F# => MARK_NONSPACING,
         when 16#011440# .. 16#011441# => MARK_SPACING_COMBINING,
         when 16#011442# .. 16#011444# => MARK_NONSPACING,
         when 16#011445#               => MARK_SPACING_COMBINING,
         when 16#011446#               => MARK_NONSPACING,
         when 16#011447# .. 16#01144A# => LETTER_OTHER,
         when 16#01144B# .. 16#01144F# => PUNCTUATION_OTHER,
         when 16#011450# .. 16#011459# => NUMBER_DECIMAL_DIGIT,
         when 16#01145B#               => PUNCTUATION_OTHER,
         when 16#01145D#               => PUNCTUATION_OTHER,
         when 16#01145E#               => MARK_NONSPACING,
         when 16#01145F#               => LETTER_OTHER,
         when 16#011480# .. 16#0114AF# => LETTER_OTHER,
         when 16#0114B0# .. 16#0114B2# => MARK_SPACING_COMBINING,
         when 16#0114B3# .. 16#0114B8# => MARK_NONSPACING,
         when 16#0114B9#               => MARK_SPACING_COMBINING,
         when 16#0114BA#               => MARK_NONSPACING,
         when 16#0114BB# .. 16#0114BE# => MARK_SPACING_COMBINING,
         when 16#0114BF# .. 16#0114C0# => MARK_NONSPACING,
         when 16#0114C1#               => MARK_SPACING_COMBINING,
         when 16#0114C2# .. 16#0114C3# => MARK_NONSPACING,
         when 16#0114C4# .. 16#0114C5# => LETTER_OTHER,
         when 16#0114C6#               => PUNCTUATION_OTHER,
         when 16#0114C7#               => LETTER_OTHER,
         when 16#0114D0# .. 16#0114D9# => NUMBER_DECIMAL_DIGIT,
         when 16#011580# .. 16#0115AE# => LETTER_OTHER,
         when 16#0115AF# .. 16#0115B1# => MARK_SPACING_COMBINING,
         when 16#0115B2# .. 16#0115B5# => MARK_NONSPACING,
         when 16#0115B8# .. 16#0115BB# => MARK_SPACING_COMBINING,
         when 16#0115BC# .. 16#0115BD# => MARK_NONSPACING,
         when 16#0115BE#               => MARK_SPACING_COMBINING,
         when 16#0115BF# .. 16#0115C0# => MARK_NONSPACING,
         when 16#0115C1# .. 16#0115D7# => PUNCTUATION_OTHER,
         when 16#0115D8# .. 16#0115DB# => LETTER_OTHER,
         when 16#0115DC# .. 16#0115DD# => MARK_NONSPACING,
         when 16#011600# .. 16#01162F# => LETTER_OTHER,
         when 16#011630# .. 16#011632# => MARK_SPACING_COMBINING,
         when 16#011633# .. 16#01163A# => MARK_NONSPACING,
         when 16#01163B# .. 16#01163C# => MARK_SPACING_COMBINING,
         when 16#01163D#               => MARK_NONSPACING,
         when 16#01163E#               => MARK_SPACING_COMBINING,
         when 16#01163F# .. 16#011640# => MARK_NONSPACING,
         when 16#011641# .. 16#011643# => PUNCTUATION_OTHER,
         when 16#011644#               => LETTER_OTHER,
         when 16#011650# .. 16#011659# => NUMBER_DECIMAL_DIGIT,
         when 16#011660# .. 16#01166C# => PUNCTUATION_OTHER,
         when 16#011680# .. 16#0116AA# => LETTER_OTHER,
         when 16#0116AB#               => MARK_NONSPACING,
         when 16#0116AC#               => MARK_SPACING_COMBINING,
         when 16#0116AD#               => MARK_NONSPACING,
         when 16#0116AE# .. 16#0116AF# => MARK_SPACING_COMBINING,
         when 16#0116B0# .. 16#0116B5# => MARK_NONSPACING,
         when 16#0116B6#               => MARK_SPACING_COMBINING,
         when 16#0116B7#               => MARK_NONSPACING,
         when 16#0116B8#               => LETTER_OTHER,
         when 16#0116C0# .. 16#0116C9# => NUMBER_DECIMAL_DIGIT,
         when 16#011700# .. 16#01171A# => LETTER_OTHER,
         when 16#01171D# .. 16#01171F# => MARK_NONSPACING,
         when 16#011720# .. 16#011721# => MARK_SPACING_COMBINING,
         when 16#011722# .. 16#011725# => MARK_NONSPACING,
         when 16#011726#               => MARK_SPACING_COMBINING,
         when 16#011727# .. 16#01172B# => MARK_NONSPACING,
         when 16#011730# .. 16#011739# => NUMBER_DECIMAL_DIGIT,
         when 16#01173A# .. 16#01173B# => NUMBER_OTHER,
         when 16#01173C# .. 16#01173E# => PUNCTUATION_OTHER,
         when 16#01173F#               => SYMBOL_OTHER,
         when 16#011800# .. 16#01182B# => LETTER_OTHER,
         when 16#01182C# .. 16#01182E# => MARK_SPACING_COMBINING,
         when 16#01182F# .. 16#011837# => MARK_NONSPACING,
         when 16#011838#               => MARK_SPACING_COMBINING,
         when 16#011839# .. 16#01183A# => MARK_NONSPACING,
         when 16#01183B#               => PUNCTUATION_OTHER,
         when 16#0118A0# .. 16#0118BF# => LETTER_UPPERCASE,
         when 16#0118C0# .. 16#0118DF# => LETTER_LOWERCASE,
         when 16#0118E0# .. 16#0118E9# => NUMBER_DECIMAL_DIGIT,
         when 16#0118EA# .. 16#0118F2# => NUMBER_OTHER,
         when 16#0118FF#               => LETTER_OTHER,
         when 16#0119A0# .. 16#0119A7# => LETTER_OTHER,
         when 16#0119AA# .. 16#0119D0# => LETTER_OTHER,
         when 16#0119D1# .. 16#0119D3# => MARK_SPACING_COMBINING,
         when 16#0119D4# .. 16#0119D7# => MARK_NONSPACING,
         when 16#0119DA# .. 16#0119DB# => MARK_NONSPACING,
         when 16#0119DC# .. 16#0119DF# => MARK_SPACING_COMBINING,
         when 16#0119E0#               => MARK_NONSPACING,
         when 16#0119E1#               => LETTER_OTHER,
         when 16#0119E2#               => PUNCTUATION_OTHER,
         when 16#0119E3#               => LETTER_OTHER,
         when 16#0119E4#               => MARK_SPACING_COMBINING,
         when 16#011A00#               => LETTER_OTHER,
         when 16#011A01# .. 16#011A0A# => MARK_NONSPACING,
         when 16#011A0B# .. 16#011A32# => LETTER_OTHER,
         when 16#011A33# .. 16#011A38# => MARK_NONSPACING,
         when 16#011A39#               => MARK_SPACING_COMBINING,
         when 16#011A3A#               => LETTER_OTHER,
         when 16#011A3B# .. 16#011A3E# => MARK_NONSPACING,
         when 16#011A3F# .. 16#011A46# => PUNCTUATION_OTHER,
         when 16#011A47#               => MARK_NONSPACING,
         when 16#011A50#               => LETTER_OTHER,
         when 16#011A51# .. 16#011A56# => MARK_NONSPACING,
         when 16#011A57# .. 16#011A58# => MARK_SPACING_COMBINING,
         when 16#011A59# .. 16#011A5B# => MARK_NONSPACING,
         when 16#011A5C# .. 16#011A89# => LETTER_OTHER,
         when 16#011A8A# .. 16#011A96# => MARK_NONSPACING,
         when 16#011A97#               => MARK_SPACING_COMBINING,
         when 16#011A98# .. 16#011A99# => MARK_NONSPACING,
         when 16#011A9A# .. 16#011A9C# => PUNCTUATION_OTHER,
         when 16#011A9D#               => LETTER_OTHER,
         when 16#011A9E# .. 16#011AA2# => PUNCTUATION_OTHER,
         when 16#011AC0# .. 16#011AF8# => LETTER_OTHER,
         when 16#011C00# .. 16#011C08# => LETTER_OTHER,
         when 16#011C0A# .. 16#011C2E# => LETTER_OTHER,
         when 16#011C2F#               => MARK_SPACING_COMBINING,
         when 16#011C30# .. 16#011C36# => MARK_NONSPACING,
         when 16#011C38# .. 16#011C3D# => MARK_NONSPACING,
         when 16#011C3E#               => MARK_SPACING_COMBINING,
         when 16#011C3F#               => MARK_NONSPACING,
         when 16#011C40#               => LETTER_OTHER,
         when 16#011C41# .. 16#011C45# => PUNCTUATION_OTHER,
         when 16#011C50# .. 16#011C59# => NUMBER_DECIMAL_DIGIT,
         when 16#011C5A# .. 16#011C6C# => NUMBER_OTHER,
         when 16#011C70# .. 16#011C71# => PUNCTUATION_OTHER,
         when 16#011C72# .. 16#011C8F# => LETTER_OTHER,
         when 16#011C92# .. 16#011CA7# => MARK_NONSPACING,
         when 16#011CA9#               => MARK_SPACING_COMBINING,
         when 16#011CAA# .. 16#011CB0# => MARK_NONSPACING,
         when 16#011CB1#               => MARK_SPACING_COMBINING,
         when 16#011CB2# .. 16#011CB3# => MARK_NONSPACING,
         when 16#011CB4#               => MARK_SPACING_COMBINING,
         when 16#011CB5# .. 16#011CB6# => MARK_NONSPACING,
         when 16#011D00# .. 16#011D06# => LETTER_OTHER,
         when 16#011D08# .. 16#011D09# => LETTER_OTHER,
         when 16#011D0B# .. 16#011D30# => LETTER_OTHER,
         when 16#011D31# .. 16#011D36# => MARK_NONSPACING,
         when 16#011D3A#               => MARK_NONSPACING,
         when 16#011D3C# .. 16#011D3D# => MARK_NONSPACING,
         when 16#011D3F# .. 16#011D45# => MARK_NONSPACING,
         when 16#011D46#               => LETTER_OTHER,
         when 16#011D47#               => MARK_NONSPACING,
         when 16#011D50# .. 16#011D59# => NUMBER_DECIMAL_DIGIT,
         when 16#011D60# .. 16#011D65# => LETTER_OTHER,
         when 16#011D67# .. 16#011D68# => LETTER_OTHER,
         when 16#011D6A# .. 16#011D89# => LETTER_OTHER,
         when 16#011D8A# .. 16#011D8E# => MARK_SPACING_COMBINING,
         when 16#011D90# .. 16#011D91# => MARK_NONSPACING,
         when 16#011D93# .. 16#011D94# => MARK_SPACING_COMBINING,
         when 16#011D95#               => MARK_NONSPACING,
         when 16#011D96#               => MARK_SPACING_COMBINING,
         when 16#011D97#               => MARK_NONSPACING,
         when 16#011D98#               => LETTER_OTHER,
         when 16#011DA0# .. 16#011DA9# => NUMBER_DECIMAL_DIGIT,
         when 16#011EE0# .. 16#011EF2# => LETTER_OTHER,
         when 16#011EF3# .. 16#011EF4# => MARK_NONSPACING,
         when 16#011EF5# .. 16#011EF6# => MARK_SPACING_COMBINING,
         when 16#011EF7# .. 16#011EF8# => PUNCTUATION_OTHER,
         when 16#011FC0# .. 16#011FD4# => NUMBER_OTHER,
         when 16#011FD5# .. 16#011FDC# => SYMBOL_OTHER,
         when 16#011FDD# .. 16#011FE0# => SYMBOL_CURRENCY,
         when 16#011FE1# .. 16#011FF1# => SYMBOL_OTHER,
         when 16#011FFF#               => PUNCTUATION_OTHER,
         when 16#012000# .. 16#012399# => LETTER_OTHER,
         when 16#012400# .. 16#01246E# => NUMBER_LETTER,
         when 16#012470# .. 16#012474# => PUNCTUATION_OTHER,
         when 16#012480# .. 16#012543# => LETTER_OTHER,
         when 16#013000# .. 16#01342E# => LETTER_OTHER,
         when 16#013430# .. 16#013438# => OTHER_FORMAT,
         when 16#014400# .. 16#014646# => LETTER_OTHER,
         when 16#016800# .. 16#016A38# => LETTER_OTHER,
         when 16#016A40# .. 16#016A5E# => LETTER_OTHER,
         when 16#016A60# .. 16#016A69# => NUMBER_DECIMAL_DIGIT,
         when 16#016A6E# .. 16#016A6F# => PUNCTUATION_OTHER,
         when 16#016AD0# .. 16#016AED# => LETTER_OTHER,
         when 16#016AF0# .. 16#016AF4# => MARK_NONSPACING,
         when 16#016AF5#               => PUNCTUATION_OTHER,
         when 16#016B00# .. 16#016B2F# => LETTER_OTHER,
         when 16#016B30# .. 16#016B36# => MARK_NONSPACING,
         when 16#016B37# .. 16#016B3B# => PUNCTUATION_OTHER,
         when 16#016B3C# .. 16#016B3F# => SYMBOL_OTHER,
         when 16#016B40# .. 16#016B43# => LETTER_MODIFIER,
         when 16#016B44#               => PUNCTUATION_OTHER,
         when 16#016B45#               => SYMBOL_OTHER,
         when 16#016B50# .. 16#016B59# => NUMBER_DECIMAL_DIGIT,
         when 16#016B5B# .. 16#016B61# => NUMBER_OTHER,
         when 16#016B63# .. 16#016B77# => LETTER_OTHER,
         when 16#016B7D# .. 16#016B8F# => LETTER_OTHER,
         when 16#016E40# .. 16#016E5F# => LETTER_UPPERCASE,
         when 16#016E60# .. 16#016E7F# => LETTER_LOWERCASE,
         when 16#016E80# .. 16#016E96# => NUMBER_OTHER,
         when 16#016E97# .. 16#016E9A# => PUNCTUATION_OTHER,
         when 16#016F00# .. 16#016F4A# => LETTER_OTHER,
         when 16#016F4F#               => MARK_NONSPACING,
         when 16#016F50#               => LETTER_OTHER,
         when 16#016F51# .. 16#016F87# => MARK_SPACING_COMBINING,
         when 16#016F8F# .. 16#016F92# => MARK_NONSPACING,
         when 16#016F93# .. 16#016F9F# => LETTER_MODIFIER,
         when 16#016FE0# .. 16#016FE1# => LETTER_MODIFIER,
         when 16#016FE2#               => PUNCTUATION_OTHER,
         when 16#016FE3#               => LETTER_MODIFIER,
         when 16#017000# .. 16#0187F7# => LETTER_OTHER,
         when 16#018800# .. 16#018AF2# => LETTER_OTHER,
         when 16#01B000# .. 16#01B11E# => LETTER_OTHER,
         when 16#01B150# .. 16#01B152# => LETTER_OTHER,
         when 16#01B164# .. 16#01B167# => LETTER_OTHER,
         when 16#01B170# .. 16#01B2FB# => LETTER_OTHER,
         when 16#01BC00# .. 16#01BC6A# => LETTER_OTHER,
         when 16#01BC70# .. 16#01BC7C# => LETTER_OTHER,
         when 16#01BC80# .. 16#01BC88# => LETTER_OTHER,
         when 16#01BC90# .. 16#01BC99# => LETTER_OTHER,
         when 16#01BC9C#               => SYMBOL_OTHER,
         when 16#01BC9D# .. 16#01BC9E# => MARK_NONSPACING,
         when 16#01BC9F#               => PUNCTUATION_OTHER,
         when 16#01BCA0# .. 16#01BCA3# => OTHER_FORMAT,
         when 16#01D000# .. 16#01D0F5# => SYMBOL_OTHER,
         when 16#01D100# .. 16#01D126# => SYMBOL_OTHER,
         when 16#01D129# .. 16#01D164# => SYMBOL_OTHER,
         when 16#01D165# .. 16#01D166# => MARK_SPACING_COMBINING,
         when 16#01D167# .. 16#01D169# => MARK_NONSPACING,
         when 16#01D16A# .. 16#01D16C# => SYMBOL_OTHER,
         when 16#01D16D# .. 16#01D172# => MARK_SPACING_COMBINING,
         when 16#01D173# .. 16#01D17A# => OTHER_FORMAT,
         when 16#01D17B# .. 16#01D182# => MARK_NONSPACING,
         when 16#01D183# .. 16#01D184# => SYMBOL_OTHER,
         when 16#01D185# .. 16#01D18B# => MARK_NONSPACING,
         when 16#01D18C# .. 16#01D1A9# => SYMBOL_OTHER,
         when 16#01D1AA# .. 16#01D1AD# => MARK_NONSPACING,
         when 16#01D1AE# .. 16#01D1E8# => SYMBOL_OTHER,
         when 16#01D200# .. 16#01D241# => SYMBOL_OTHER,
         when 16#01D242# .. 16#01D244# => MARK_NONSPACING,
         when 16#01D245#               => SYMBOL_OTHER,
         when 16#01D2E0# .. 16#01D2F3# => NUMBER_OTHER,
         when 16#01D300# .. 16#01D356# => SYMBOL_OTHER,
         when 16#01D360# .. 16#01D378# => NUMBER_OTHER,
         when 16#01D400# .. 16#01D419# => LETTER_UPPERCASE,
         when 16#01D41A# .. 16#01D433# => LETTER_LOWERCASE,
         when 16#01D434# .. 16#01D44D# => LETTER_UPPERCASE,
         when 16#01D44E# .. 16#01D454# => LETTER_LOWERCASE,
         when 16#01D456# .. 16#01D467# => LETTER_LOWERCASE,
         when 16#01D468# .. 16#01D481# => LETTER_UPPERCASE,
         when 16#01D482# .. 16#01D49B# => LETTER_LOWERCASE,
         when 16#01D49C#               => LETTER_UPPERCASE,
         when 16#01D49E# .. 16#01D49F# => LETTER_UPPERCASE,
         when 16#01D4A2#               => LETTER_UPPERCASE,
         when 16#01D4A5# .. 16#01D4A6# => LETTER_UPPERCASE,
         when 16#01D4A9# .. 16#01D4AC# => LETTER_UPPERCASE,
         when 16#01D4AE# .. 16#01D4B5# => LETTER_UPPERCASE,
         when 16#01D4B6# .. 16#01D4B9# => LETTER_LOWERCASE,
         when 16#01D4BB#               => LETTER_LOWERCASE,
         when 16#01D4BD# .. 16#01D4C3# => LETTER_LOWERCASE,
         when 16#01D4C5# .. 16#01D4CF# => LETTER_LOWERCASE,
         when 16#01D4D0# .. 16#01D4E9# => LETTER_UPPERCASE,
         when 16#01D4EA# .. 16#01D503# => LETTER_LOWERCASE,
         when 16#01D504# .. 16#01D505# => LETTER_UPPERCASE,
         when 16#01D507# .. 16#01D50A# => LETTER_UPPERCASE,
         when 16#01D50D# .. 16#01D514# => LETTER_UPPERCASE,
         when 16#01D516# .. 16#01D51C# => LETTER_UPPERCASE,
         when 16#01D51E# .. 16#01D537# => LETTER_LOWERCASE,
         when 16#01D538# .. 16#01D539# => LETTER_UPPERCASE,
         when 16#01D53B# .. 16#01D53E# => LETTER_UPPERCASE,
         when 16#01D540# .. 16#01D544# => LETTER_UPPERCASE,
         when 16#01D546#               => LETTER_UPPERCASE,
         when 16#01D54A# .. 16#01D550# => LETTER_UPPERCASE,
         when 16#01D552# .. 16#01D56B# => LETTER_LOWERCASE,
         when 16#01D56C# .. 16#01D585# => LETTER_UPPERCASE,
         when 16#01D586# .. 16#01D59F# => LETTER_LOWERCASE,
         when 16#01D5A0# .. 16#01D5B9# => LETTER_UPPERCASE,
         when 16#01D5BA# .. 16#01D5D3# => LETTER_LOWERCASE,
         when 16#01D5D4# .. 16#01D5ED# => LETTER_UPPERCASE,
         when 16#01D5EE# .. 16#01D607# => LETTER_LOWERCASE,
         when 16#01D608# .. 16#01D621# => LETTER_UPPERCASE,
         when 16#01D622# .. 16#01D63B# => LETTER_LOWERCASE,
         when 16#01D63C# .. 16#01D655# => LETTER_UPPERCASE,
         when 16#01D656# .. 16#01D66F# => LETTER_LOWERCASE,
         when 16#01D670# .. 16#01D689# => LETTER_UPPERCASE,
         when 16#01D68A# .. 16#01D6A5# => LETTER_LOWERCASE,
         when 16#01D6A8# .. 16#01D6C0# => LETTER_UPPERCASE,
         when 16#01D6C1#               => SYMBOL_MATH,
         when 16#01D6C2# .. 16#01D6DA# => LETTER_LOWERCASE,
         when 16#01D6DB#               => SYMBOL_MATH,
         when 16#01D6DC# .. 16#01D6E1# => LETTER_LOWERCASE,
         when 16#01D6E2# .. 16#01D6FA# => LETTER_UPPERCASE,
         when 16#01D6FB#               => SYMBOL_MATH,
         when 16#01D6FC# .. 16#01D714# => LETTER_LOWERCASE,
         when 16#01D715#               => SYMBOL_MATH,
         when 16#01D716# .. 16#01D71B# => LETTER_LOWERCASE,
         when 16#01D71C# .. 16#01D734# => LETTER_UPPERCASE,
         when 16#01D735#               => SYMBOL_MATH,
         when 16#01D736# .. 16#01D74E# => LETTER_LOWERCASE,
         when 16#01D74F#               => SYMBOL_MATH,
         when 16#01D750# .. 16#01D755# => LETTER_LOWERCASE,
         when 16#01D756# .. 16#01D76E# => LETTER_UPPERCASE,
         when 16#01D76F#               => SYMBOL_MATH,
         when 16#01D770# .. 16#01D788# => LETTER_LOWERCASE,
         when 16#01D789#               => SYMBOL_MATH,
         when 16#01D78A# .. 16#01D78F# => LETTER_LOWERCASE,
         when 16#01D790# .. 16#01D7A8# => LETTER_UPPERCASE,
         when 16#01D7A9#               => SYMBOL_MATH,
         when 16#01D7AA# .. 16#01D7C2# => LETTER_LOWERCASE,
         when 16#01D7C3#               => SYMBOL_MATH,
         when 16#01D7C4# .. 16#01D7C9# => LETTER_LOWERCASE,
         when 16#01D7CA#               => LETTER_UPPERCASE,
         when 16#01D7CB#               => LETTER_LOWERCASE,
         when 16#01D7CE# .. 16#01D7FF# => NUMBER_DECIMAL_DIGIT,
         when 16#01D800# .. 16#01D9FF# => SYMBOL_OTHER,
         when 16#01DA00# .. 16#01DA36# => MARK_NONSPACING,
         when 16#01DA37# .. 16#01DA3A# => SYMBOL_OTHER,
         when 16#01DA3B# .. 16#01DA6C# => MARK_NONSPACING,
         when 16#01DA6D# .. 16#01DA74# => SYMBOL_OTHER,
         when 16#01DA75#               => MARK_NONSPACING,
         when 16#01DA76# .. 16#01DA83# => SYMBOL_OTHER,
         when 16#01DA84#               => MARK_NONSPACING,
         when 16#01DA85# .. 16#01DA86# => SYMBOL_OTHER,
         when 16#01DA87# .. 16#01DA8B# => PUNCTUATION_OTHER,
         when 16#01DA9B# .. 16#01DA9F# => MARK_NONSPACING,
         when 16#01DAA1# .. 16#01DAAF# => MARK_NONSPACING,
         when 16#01E000# .. 16#01E006# => MARK_NONSPACING,
         when 16#01E008# .. 16#01E018# => MARK_NONSPACING,
         when 16#01E01B# .. 16#01E021# => MARK_NONSPACING,
         when 16#01E023# .. 16#01E024# => MARK_NONSPACING,
         when 16#01E026# .. 16#01E02A# => MARK_NONSPACING,
         when 16#01E100# .. 16#01E12C# => LETTER_OTHER,
         when 16#01E130# .. 16#01E136# => MARK_NONSPACING,
         when 16#01E137# .. 16#01E13D# => LETTER_MODIFIER,
         when 16#01E140# .. 16#01E149# => NUMBER_DECIMAL_DIGIT,
         when 16#01E14E#               => LETTER_OTHER,
         when 16#01E14F#               => SYMBOL_OTHER,
         when 16#01E2C0# .. 16#01E2EB# => LETTER_OTHER,
         when 16#01E2EC# .. 16#01E2EF# => MARK_NONSPACING,
         when 16#01E2F0# .. 16#01E2F9# => NUMBER_DECIMAL_DIGIT,
         when 16#01E2FF#               => SYMBOL_CURRENCY,
         when 16#01E800# .. 16#01E8C4# => LETTER_OTHER,
         when 16#01E8C7# .. 16#01E8CF# => NUMBER_OTHER,
         when 16#01E8D0# .. 16#01E8D6# => MARK_NONSPACING,
         when 16#01E900# .. 16#01E921# => LETTER_UPPERCASE,
         when 16#01E922# .. 16#01E943# => LETTER_LOWERCASE,
         when 16#01E944# .. 16#01E94A# => MARK_NONSPACING,
         when 16#01E94B#               => LETTER_MODIFIER,
         when 16#01E950# .. 16#01E959# => NUMBER_DECIMAL_DIGIT,
         when 16#01E95E# .. 16#01E95F# => PUNCTUATION_OTHER,
         when 16#01EC71# .. 16#01ECAB# => NUMBER_OTHER,
         when 16#01ECAC#               => SYMBOL_OTHER,
         when 16#01ECAD# .. 16#01ECAF# => NUMBER_OTHER,
         when 16#01ECB0#               => SYMBOL_CURRENCY,
         when 16#01ECB1# .. 16#01ECB4# => NUMBER_OTHER,
         when 16#01ED01# .. 16#01ED2D# => NUMBER_OTHER,
         when 16#01ED2E#               => SYMBOL_OTHER,
         when 16#01ED2F# .. 16#01ED3D# => NUMBER_OTHER,
         when 16#01EE00# .. 16#01EE03# => LETTER_OTHER,
         when 16#01EE05# .. 16#01EE1F# => LETTER_OTHER,
         when 16#01EE21# .. 16#01EE22# => LETTER_OTHER,
         when 16#01EE24#               => LETTER_OTHER,
         when 16#01EE27#               => LETTER_OTHER,
         when 16#01EE29# .. 16#01EE32# => LETTER_OTHER,
         when 16#01EE34# .. 16#01EE37# => LETTER_OTHER,
         when 16#01EE39#               => LETTER_OTHER,
         when 16#01EE3B#               => LETTER_OTHER,
         when 16#01EE42#               => LETTER_OTHER,
         when 16#01EE47#               => LETTER_OTHER,
         when 16#01EE49#               => LETTER_OTHER,
         when 16#01EE4B#               => LETTER_OTHER,
         when 16#01EE4D# .. 16#01EE4F# => LETTER_OTHER,
         when 16#01EE51# .. 16#01EE52# => LETTER_OTHER,
         when 16#01EE54#               => LETTER_OTHER,
         when 16#01EE57#               => LETTER_OTHER,
         when 16#01EE59#               => LETTER_OTHER,
         when 16#01EE5B#               => LETTER_OTHER,
         when 16#01EE5D#               => LETTER_OTHER,
         when 16#01EE5F#               => LETTER_OTHER,
         when 16#01EE61# .. 16#01EE62# => LETTER_OTHER,
         when 16#01EE64#               => LETTER_OTHER,
         when 16#01EE67# .. 16#01EE6A# => LETTER_OTHER,
         when 16#01EE6C# .. 16#01EE72# => LETTER_OTHER,
         when 16#01EE74# .. 16#01EE77# => LETTER_OTHER,
         when 16#01EE79# .. 16#01EE7C# => LETTER_OTHER,
         when 16#01EE7E#               => LETTER_OTHER,
         when 16#01EE80# .. 16#01EE89# => LETTER_OTHER,
         when 16#01EE8B# .. 16#01EE9B# => LETTER_OTHER,
         when 16#01EEA1# .. 16#01EEA3# => LETTER_OTHER,
         when 16#01EEA5# .. 16#01EEA9# => LETTER_OTHER,
         when 16#01EEAB# .. 16#01EEBB# => LETTER_OTHER,
         when 16#01EEF0# .. 16#01EEF1# => SYMBOL_MATH,
         when 16#01F000# .. 16#01F02B# => SYMBOL_OTHER,
         when 16#01F030# .. 16#01F093# => SYMBOL_OTHER,
         when 16#01F0A0# .. 16#01F0AE# => SYMBOL_OTHER,
         when 16#01F0B1# .. 16#01F0BF# => SYMBOL_OTHER,
         when 16#01F0C1# .. 16#01F0CF# => SYMBOL_OTHER,
         when 16#01F0D1# .. 16#01F0F5# => SYMBOL_OTHER,
         when 16#01F100# .. 16#01F10C# => NUMBER_OTHER,
         when 16#01F110# .. 16#01F16C# => SYMBOL_OTHER,
         when 16#01F170# .. 16#01F1AC# => SYMBOL_OTHER,
         when 16#01F1E6# .. 16#01F202# => SYMBOL_OTHER,
         when 16#01F210# .. 16#01F23B# => SYMBOL_OTHER,
         when 16#01F240# .. 16#01F248# => SYMBOL_OTHER,
         when 16#01F250# .. 16#01F251# => SYMBOL_OTHER,
         when 16#01F260# .. 16#01F265# => SYMBOL_OTHER,
         when 16#01F300# .. 16#01F3FA# => SYMBOL_OTHER,
         when 16#01F3FB# .. 16#01F3FF# => SYMBOL_MODIFIER,
         when 16#01F400# .. 16#01F6D5# => SYMBOL_OTHER,
         when 16#01F6E0# .. 16#01F6EC# => SYMBOL_OTHER,
         when 16#01F6F0# .. 16#01F6FA# => SYMBOL_OTHER,
         when 16#01F700# .. 16#01F773# => SYMBOL_OTHER,
         when 16#01F780# .. 16#01F7D8# => SYMBOL_OTHER,
         when 16#01F7E0# .. 16#01F7EB# => SYMBOL_OTHER,
         when 16#01F800# .. 16#01F80B# => SYMBOL_OTHER,
         when 16#01F810# .. 16#01F847# => SYMBOL_OTHER,
         when 16#01F850# .. 16#01F859# => SYMBOL_OTHER,
         when 16#01F860# .. 16#01F887# => SYMBOL_OTHER,
         when 16#01F890# .. 16#01F8AD# => SYMBOL_OTHER,
         when 16#01F900# .. 16#01F90B# => SYMBOL_OTHER,
         when 16#01F90D# .. 16#01F971# => SYMBOL_OTHER,
         when 16#01F973# .. 16#01F976# => SYMBOL_OTHER,
         when 16#01F97A# .. 16#01F9A2# => SYMBOL_OTHER,
         when 16#01F9A5# .. 16#01F9AA# => SYMBOL_OTHER,
         when 16#01F9AE# .. 16#01F9CA# => SYMBOL_OTHER,
         when 16#01F9CD# .. 16#01FA53# => SYMBOL_OTHER,
         when 16#01FA60# .. 16#01FA6D# => SYMBOL_OTHER,
         when 16#01FA70# .. 16#01FA73# => SYMBOL_OTHER,
         when 16#01FA78# .. 16#01FA7A# => SYMBOL_OTHER,
         when 16#01FA80# .. 16#01FA82# => SYMBOL_OTHER,
         when 16#01FA90# .. 16#01FA95# => SYMBOL_OTHER,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;

   function Plane_02_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#020000# .. 16#02A6D6# => LETTER_OTHER,
         when 16#02A700# .. 16#02B734# => LETTER_OTHER,
         when 16#02B740# .. 16#02B81D# => LETTER_OTHER,
         when 16#02B820# .. 16#02CEA1# => LETTER_OTHER,
         when 16#02CEB0# .. 16#02EBE0# => LETTER_OTHER,
         when 16#02F800# .. 16#02FA1D# => LETTER_OTHER,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;

   function Plane_03_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_04_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_05_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_06_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_07_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_08_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_09_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_0A_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_0B_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_0C_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_0D_Lookup (C: Codepoint) return General_Category_Type is
      (OTHER_NOT_ASSIGNED) with Inline;

   function Plane_0E_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#0E0001#               => OTHER_FORMAT,
         when 16#0E0020# .. 16#0E007F# => OTHER_FORMAT,
         when 16#0E0100# .. 16#0E01EF# => MARK_NONSPACING,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;

   function Plane_0F_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#0F0000# .. 16#0FFFFD# => OTHER_PRIVATE_USE,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;

   function Plane_10_Lookup (C: Codepoint) return General_Category_Type is
      (case C is
         when 16#100000# .. 16#10FFFD# => OTHER_PRIVATE_USE,

         when others => OTHER_NOT_ASSIGNED)
      with Inline;


   ----------------------
   -- General_Category --
   ----------------------
   function General_Category (C: Wide_Wide_Character)
                             return General_Category_Type
   is
      CP: constant Codepoint := Codepoint (Wide_Wide_Character'Pos(C));
   begin
      return
         (case CP is
            when 16#000000# .. 16#00FFFF# => Plane_00_Lookup (CP),
            when 16#010000# .. 16#01FFFF# => Plane_01_Lookup (CP),
            when 16#020000# .. 16#02FFFF# => Plane_02_Lookup (CP),
            when 16#030000# .. 16#03FFFF# => Plane_03_Lookup (CP),
            when 16#040000# .. 16#04FFFF# => Plane_04_Lookup (CP),
            when 16#050000# .. 16#05FFFF# => Plane_05_Lookup (CP),
            when 16#060000# .. 16#06FFFF# => Plane_06_Lookup (CP),
            when 16#070000# .. 16#07FFFF# => Plane_07_Lookup (CP),
            when 16#080000# .. 16#08FFFF# => Plane_08_Lookup (CP),
            when 16#090000# .. 16#09FFFF# => Plane_09_Lookup (CP),
            when 16#0A0000# .. 16#0AFFFF# => Plane_0A_Lookup (CP),
            when 16#0B0000# .. 16#0BFFFF# => Plane_0B_Lookup (CP),
            when 16#0C0000# .. 16#0CFFFF# => Plane_0C_Lookup (CP),
            when 16#0D0000# .. 16#0DFFFF# => Plane_0D_Lookup (CP),
            when 16#0E0000# .. 16#0EFFFF# => Plane_0E_Lookup (CP),
            when 16#0F0000# .. 16#0FFFFF# => Plane_0F_Lookup (CP),
            when 16#100000# .. 16#10FFFF# => Plane_10_Lookup (CP),

            when others => OTHER_NOT_ASSIGNED);
   end General_Category;

end Unicode.General_Category;
